unit UnidadAcercaDe;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, registry, ImgList, TypInfo, ShellAPI, 
  Messages, Dialogs, Qrctrls, ExtDlgs,  math, variants, ComCtrls, DB,
  inifiles, DBTables, jpeg;
type
  TFormAcercaDe = class(TForm)
    Panel1: TPanel;
    Nombre: TLabel;
    Version: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    OKButton: TSpeedButton;
    ImageList1: TImageList;
    Tab: TPageControl;
    TabSheet1: TTabSheet;
    Indices: TTreeView;
    Panel2: TPanel;
    Guardar: TSpeedButton;
    Recuperar: TSpeedButton;
    TabSheet3: TTabSheet;
    SpeedButton3: TSpeedButton;
    GroupBox1: TGroupBox;
    Label6: TLabel;
    TxtDNI: TEdit;
    BCalcular: TBitBtn;
    Label7: TLabel;
    L: TLabel;
    ImageList2: TImageList;
    dlgabrir: TOpenDialog;
    dlgguardar: TSaveDialog;
    TTabla: TTable;
    BActivar: TBitBtn;
    TxtContrasena: TEdit;
    BAceptar: TBitBtn;
    TEmpresas: TTable;
    TEmpresasIDEmpresa: TAutoIncField;
    TEmpresasNombreEmpresa: TStringField;
    TEmpresasFechaAlta: TDateField;
    TEmpresasFechaBaja: TDateField;
    TEmpresasRuta: TStringField;
    TEmpresasMoneda: TStringField;
    TEmpresasCambio: TFloatField;
    TEmpresasNota: TStringField;
    TEmpresasACTIVA: TBooleanField;
    TEmpresasUsuario: TStringField;
    TEmpresasCIF: TStringField;
    TEmpresasDomicilio: TStringField;
    TEmpresasPoblacion: TStringField;
    TEmpresasProvincia: TStringField;
    TEmpresasCP: TFloatField;
    TEmpresasTelefono: TStringField;
    TEmpresasFax: TStringField;
    TEmpresasEmail: TStringField;
    TEmpresasRutaLogotipo: TStringField;
    TEmpresasAjustarTamano: TBooleanField;
    TEmpresasId: TIntegerField;
    TEmpresasFicheros: TBooleanField;
    DEmpresas: TDataSource;
    Label12: TLabel;
    TabIni: TTabSheet;
    Panel4: TPanel;
    Panel5: TPanel;
    TxtINI: TMemo;
    Panel6: TPanel;
    Splitter1: TSplitter;
    Panel7: TPanel;
    SpeedButton8: TSpeedButton;
    TxtLog: TMemo;
    SpeedButton9: TSpeedButton;
    LWEB: TLabel;
    RichEdit1: TRichEdit;
    Image1: TImage;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure GuardarClick(Sender: TObject);
    procedure IndicesCollapsing(Sender: TObject; Node: TTreeNode;
  var AllowCollapse: Boolean);
    procedure IndicesExpanding(Sender: TObject; Node: TTreeNode;
  var AllowExpansion: Boolean);
    procedure RecuperarClick(Sender: TObject);
    procedure BCalcularClick(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure TxtDNIChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BActivarClick(Sender: TObject);
    procedure BAceptarClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure SpeedButton8Click(Sender: TObject);
    procedure SpeedButton9Click(Sender: TObject);
    procedure LWEBClick2(Sender: TObject);
    procedure OKButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormAcercaDe: TFormAcercaDe;

implementation

uses UnidadDatos, unidadprocedimientos, UnidadMenuPrincipal;

{$R *.DFM}



procedure TFormAcercaDe.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  screen.cursor:=crdefault;
  action := cafree;
end;


procedure TFormAcercaDe.FormCreate(Sender: TObject);
var
  MS: TMemoryStatus;
  NuevoNodo: TTreeNode;
  N: integer;
  Registry: TRegistry;
  fabricante, procesador, nn : string;
  Contador: Byte;
  Unidades: LongWord;
  Const  // Matriz con los tipos de unidades
    TiposUnidad: Array[0..6] Of String = ('Desconocida',
        'No es una unidad', 'Removible', 'Fija (Disco duro)',
        'Remota (red)', 'Lector CD-ROM', 'Disco RAM');
  Var
    Etiqueta: String;
    NumeroSerie: LongWord;
    Indicadores, MaximaLongitud: Cardinal;
    Disponible, Total, Libre: Int64;
    unidad, nombreemp, rutaemp, monedaemp : String;
    ffinemp, finicioemp : tdatetime;
    idemp : integer;
begin
  version.caption := 'Versin: ' + vTVersionAplicacion;
  nombre.Caption := vTNombreAplicacion;
  if formmenuprincipal.mnu.tag <> 10 then
    exit;
  tab.Align := alClient;
  txtini.Lines.LoadFromFile(ChangeFileExt(application.exename,'.ini'));
  try
    txtlog.Lines.LoadFromFile(ChangeFileExt(application.exename,'.log'));
  except
    //silenciosa
  end;

  //Datos PC
  // Aadimos un nuevo nodo al primer nivel
  NuevoNodo := Indices.Items.Add(Nil, 'Ordenador (PC)');
  // Establecemos las imgenes
  With NuevoNodo Do
  Begin
    ImageIndex := 0;
    SelectedIndex := 0;
  End;
  // CAPTULO MEMORIA
  // Seleccionando el nuevo nodo como actual
  Indices.Selected := NuevoNodo;
  // Obtenemos el ndice absoluto del nodo seleccionado
  N := Indices.Selected.AbsoluteIndex;
  // y vamos subiendo por el rbol hasta encontrar
  // el nodo correspondiente al libro
  While Indices.Items[N].Level <> 0 Do
   Dec(N);
  NuevoNodo := Indices.Items.AddChild(Indices.Items[N], 'Memoria');
  NuevoNodo.ImageIndex := 2;
  NuevoNodo.SelectedIndex := 2;
  // Seleccionamos el nuevo nodo como el actual
  Indices.Selected := NuevoNodo;
  // Obtenemos el ndice absoluto del nodo actual
  N := Indices.Selected.AbsoluteIndex;
  // y subimos por el rbol hasta encontrar el
  // nodo correspondiente al captulo
  While Indices.Items[N].Level <> 1 Do
    Dec(N);
  //Informacin MEMORIA
  try
    GlobalMemoryStatus(MS);
  except
    raise;
  end;
  NuevoNodo := Indices.Items.AddChild(Indices.Items[N], 'RAM Total (KB) -> '
      + FormatFloat('#,###" KB"', MS.dwTotalPhys / 1024));
  NuevoNodo.ImageIndex := 4;
  NuevoNodo.SelectedIndex := 4;
  NuevoNodo := Indices.Items.AddChild(Indices.Items[N], 'RAM Libre (%) -> '
      + Format('%d %%', [100 - MS.dwMemoryLoad]));
  NuevoNodo.ImageIndex := 4;
  NuevoNodo.SelectedIndex := 4;
  NuevoNodo := Indices.Items.AddChild(Indices.Items[N], 'RAM Libre (KB) -> '
      + FormatFloat('#,###" KB"', MS.dwAvailPhys / 1024));
  NuevoNodo.ImageIndex := 4;
  NuevoNodo.SelectedIndex := 4;
  NuevoNodo := Indices.Items.AddChild(Indices.Items[N], 'RAM Ocupada (%) -> '
      + Format('%d %%', [MS.dwMemoryLoad]));
  NuevoNodo.ImageIndex := 4;
  NuevoNodo.SelectedIndex := 4;
  NuevoNodo := Indices.Items.AddChild(Indices.Items[N], 'RAM Ocupada (KB) -> '
      + FormatFloat('#,###" KB"', (MS.dwTotalPhys -  MS.dwAvailPhys) / 1024));
  NuevoNodo.ImageIndex := 4;
  NuevoNodo.SelectedIndex := 4;
  NuevoNodo := Indices.Items.AddChild(Indices.Items[N], 'Virtual total -> '
      + FormatFloat('#,###" KB"', MS.dwTotalVirtual / 1024));
  NuevoNodo.ImageIndex := 4;
  NuevoNodo.SelectedIndex := 4;
  NuevoNodo := Indices.Items.AddChild(Indices.Items[N], 'Virtual libre -> '
      + FormatFloat('#,###" KB"', MS.dwAvailVirtual / 1024));
  NuevoNodo.ImageIndex := 4;
  NuevoNodo.SelectedIndex := 4;

  //Obtener datos del regedit
  Registry := TRegistry.Create;
  Registry.RootKey := HKEY_LOCAL_MACHINE;

  //Obtener datos procesador
  Registry.OpenKey('\Hardware\Description\System\CentralProcessor\0', False);
  procesador := Registry.ReadString('Identifier');
  fabricante := Registry.ReadString('VendorIdentifier');

  Registry.Free;

  // CAPTULO MONITOR
  // Seleccionamos el nuevo nodo como el actual
  N := Indices.Selected.AbsoluteIndex;
  While Indices.Items[N].Level <> 0 Do
   Dec(N);
  NuevoNodo := Indices.Items.AddChild(Indices.Items[N], 'Grficos');
  NuevoNodo.ImageIndex := 2;
  NuevoNodo.SelectedIndex := 2;
  Indices.Selected := NuevoNodo;
  N := Indices.Selected.AbsoluteIndex;
  While Indices.Items[N].Level <> 1 Do
    Dec(N);
  NuevoNodo.ImageIndex := 4;
  NuevoNodo.SelectedIndex := 4;
  NuevoNodo := Indices.Items.AddChild(Indices.Items[N], 'Resolucin -> ' +
    inttostr(screen.width) + 'x' + inttostr(screen.height));
  NuevoNodo.ImageIndex := 4;
  NuevoNodo.SelectedIndex := 4;
  NuevoNodo := Indices.Items.AddChild(Indices.Items[N], 'N Monitores -> ' +
    inttostr(screen.MonitorCount));
  NuevoNodo.ImageIndex := 4;
  NuevoNodo.SelectedIndex := 4;

  // CAPTULO IMPRESION
  // Seleccionamos el nuevo nodo como el actual
{  N := Indices.Selected.AbsoluteIndex;
  While Indices.Items[N].Level <> 0 Do
   Dec(N);
  NuevoNodo := Indices.Items.AddChild(Indices.Items[N], 'Impresin');
  NuevoNodo.ImageIndex := 2;
  NuevoNodo.SelectedIndex := 2;
  Indices.Selected := NuevoNodo;
  N := Indices.Selected.AbsoluteIndex;
  While Indices.Items[N].Level <> 1 Do
    Dec(N);
  NuevoNodo.ImageIndex := 4;
  NuevoNodo.SelectedIndex := 4;
  if impresora0 <> '' then
  begin
    NuevoNodo := Indices.Items.AddChild(Indices.Items[N], 'Impresora 0000 -> ' +
      impresora0);
    NuevoNodo.ImageIndex := 4;
    NuevoNodo.SelectedIndex := 4;
  end;
  if impresora1 <> '' then
  begin
    NuevoNodo := Indices.Items.AddChild(Indices.Items[N], 'Impresora 0001 -> ' +
      impresora1);
    NuevoNodo.ImageIndex := 4;
    NuevoNodo.SelectedIndex := 4;
  end;
  if impresora2 <> '' then
  begin
    NuevoNodo := Indices.Items.AddChild(Indices.Items[N], 'Impresora 0002 -> ' +
      impresora2);
    NuevoNodo.ImageIndex := 4;
    NuevoNodo.SelectedIndex := 4;
  end;
  if impresora3 <> '' then
  begin
    NuevoNodo := Indices.Items.AddChild(Indices.Items[N], 'Impresora 0003 -> ' +
      impresora3);
    NuevoNodo.ImageIndex := 4;
    NuevoNodo.SelectedIndex := 4;
  end;
  if impresora4 <> '' then
  begin
    NuevoNodo := Indices.Items.AddChild(Indices.Items[N], 'Impresora 0004 -> ' +
      tarjetagrafica5);
    NuevoNodo.ImageIndex := 4;
    NuevoNodo.SelectedIndex := 4;
  end;}

  //PROCESADOR
  // Seleccionamos el nuevo nodo como el actual
  N := Indices.Selected.AbsoluteIndex;
  While Indices.Items[N].Level <> 0 Do
   Dec(N);
  NuevoNodo := Indices.Items.AddChild(Indices.Items[N], 'Procesador');
  NuevoNodo.ImageIndex := 2;
  NuevoNodo.SelectedIndex := 2;
  Indices.Selected := NuevoNodo;
  N := Indices.Selected.AbsoluteIndex;
  While Indices.Items[N].Level <> 1 Do
    Dec(N);
  NuevoNodo := Indices.Items.AddChild(Indices.Items[N], 'Fabricante -> ' +
    fabricante);
  NuevoNodo.ImageIndex := 4;
  NuevoNodo.SelectedIndex := 4;
  NuevoNodo := Indices.Items.AddChild(Indices.Items[N], 'Nombre -> ' +
    procesador);
  NuevoNodo.ImageIndex := 4;
  NuevoNodo.SelectedIndex := 4;

  //UNIDADES DEL EQUIPO
  // Seleccionamos el nuevo nodo como el actual
  N := Indices.Selected.AbsoluteIndex;
  While Indices.Items[N].Level <> 0 Do
   Dec(N);
  NuevoNodo := Indices.Items.AddChild(Indices.Items[N], 'Unidades de almacenamiento');
  NuevoNodo.ImageIndex := 2;
  NuevoNodo.SelectedIndex := 2;
  // Obtenemos la mscara de unidades
  Unidades := GetLogicalDrives;
  // Recorremos los 32 bits de la mscara
  Indices.Selected := NuevoNodo;
  For Contador := 0 To 31 Do
  BEGIN
    // Si el bit Contador est a 1
    If (Unidades And Trunc(Power(2, Contador))) <> 0 Then
    begin
      // mostrar informacin de la unidad correspondiente
      Unidad := Char(Contador+Ord('A')) + ':\';
      N := Indices.Selected.AbsoluteIndex;
      While Indices.Items[N].Level <> 1 Do
        Dec(N);
      NuevoNodo := Indices.Items.AddChild(Indices.Items[N], 'Unidad -> ' +
        unidad);
      NuevoNodo.ImageIndex := 2;
      NuevoNodo.SelectedIndex := 2;
      Indices.Selected := NuevoNodo;
      N := Indices.Selected.AbsoluteIndex;
      While Indices.Items[N].Level <> 2 Do
        Dec(N);
      NuevoNodo := Indices.Items.AddChild(Indices.Items[N], 'Tipo -> ' +
        TiposUnidad[GetDriveType(PChar(Unidad))]);
      NuevoNodo.ImageIndex := 4;
      NuevoNodo.SelectedIndex := 4;
      SetLength(Etiqueta, MAX_PATH);
      // Intentamos obtener informacin de unidad
      If GetVolumeInformation(PChar(Unidad), PChar(Etiqueta),
          MAX_PATH, @NumeroSerie, MaximaLongitud,
          Indicadores, Nil, 0) Then
      Begin // si no hay problemas aadimos
        NuevoNodo := Indices.Items.AddChild(Indices.Items[N], 'Etiqueta -> ' +
          etiqueta);
        NuevoNodo.ImageIndex := 4;
        NuevoNodo.SelectedIndex := 4;
        GetDiskFreeSpaceEx(PChar(Unidad), Disponible, Total, @Libre);
        NuevoNodo := Indices.Items.AddChild(Indices.Items[N], 'N Serie -> ' +
          floattostr(numeroserie));
        NuevoNodo.ImageIndex := 4;
        NuevoNodo.SelectedIndex := 4;
        NuevoNodo := Indices.Items.AddChild(Indices.Items[N], 'Tamao total -> ' +
          Format('%20.0n', [(Total * 1.0) / 1024]) + ' Kb');
        NuevoNodo.ImageIndex := 4;
        NuevoNodo.SelectedIndex := 4;
        NuevoNodo := Indices.Items.AddChild(Indices.Items[N], 'Espacio libre -> ' +
          Format('%20.0n',[(Libre * 1.0) / 1024]) + ' Kb');
        NuevoNodo.ImageIndex := 4;
        NuevoNodo.SelectedIndex := 4;
      End; // If
    end;
    Indices.Items[N].Collapse(false);
  END; // for

  //DATOS USUARIO Y EQUIPO
  {NuevoNodo := Indices.Items.Add(Nil, 'Usuario/Red');
  // Establecemos las imgenes
  With NuevoNodo Do
  Begin
    ImageIndex := 0;
    SelectedIndex := 0;
  End;
  // Seleccionando el nuevo nodo como actual
  Indices.Selected := NuevoNodo;

  N := Indices.Selected.AbsoluteIndex;
  While Indices.Items[N].Level <> 0 Do
   Dec(N);
  NuevoNodo := Indices.Items.AddChild(Indices.Items[N], 'Usuario');
  NuevoNodo.ImageIndex := 2;
  NuevoNodo.SelectedIndex := 2;
  Indices.Selected := NuevoNodo;
  N := Indices.Selected.AbsoluteIndex;
  While Indices.Items[N].Level <> 1 Do
    Dec(N);
  NuevoNodo := Indices.Items.AddChild(Indices.Items[N], 'Nombre Organizacin -> ' +
    nombreorganizacion);
  NuevoNodo.ImageIndex := 4;
  NuevoNodo.SelectedIndex := 4;
  NuevoNodo := Indices.Items.AddChild(Indices.Items[N], 'Nombre Usuario -> ' +
    nombreusuario);
  NuevoNodo.ImageIndex := 4;
  NuevoNodo.SelectedIndex := 4;
  N := Indices.Selected.AbsoluteIndex;
  While Indices.Items[N].Level <> 0 Do
   Dec(N);
  NuevoNodo := Indices.Items.AddChild(Indices.Items[N], 'Red');
  NuevoNodo.ImageIndex := 2;
  NuevoNodo.SelectedIndex := 2;
  Indices.Selected := NuevoNodo;
  N := Indices.Selected.AbsoluteIndex;
  While Indices.Items[N].Level <> 1 Do
    Dec(N);
  NuevoNodo := Indices.Items.AddChild(Indices.Items[N], 'Nombre Equipo -> ' +
    nombreequipo);
  NuevoNodo.ImageIndex := 4;
  NuevoNodo.SelectedIndex := 4;
  NuevoNodo := Indices.Items.AddChild(Indices.Items[N], 'DNS (TCP/IP) -> ' +
    dip);
  NuevoNodo.ImageIndex := 4;
  NuevoNodo.SelectedIndex := 4;}


  //DATOS SISTEMA OPERATIVO
{  NuevoNodo := Indices.Items.Add(Nil, 'Sistema Operativo');
  With NuevoNodo Do
  Begin
    ImageIndex := 0;
    SelectedIndex := 0;
  End;
  Indices.Selected := NuevoNodo;
  N := Indices.Selected.AbsoluteIndex;
  While Indices.Items[N].Level <> 0 Do
   Dec(N);
  NuevoNodo := Indices.Items.AddChild(Indices.Items[N], 'Datos');
  NuevoNodo.ImageIndex := 2;
  NuevoNodo.SelectedIndex := 2;
  Indices.Selected := NuevoNodo;
  N := Indices.Selected.AbsoluteIndex;
  While Indices.Items[N].Level <> 1 Do
    Dec(N);
  NuevoNodo := Indices.Items.AddChild(Indices.Items[N], 'Nombre -> ' +
    so);
  NuevoNodo.ImageIndex := 4;
  NuevoNodo.SelectedIndex := 4;
  NuevoNodo := Indices.Items.AddChild(Indices.Items[N], 'Versin -> ' +
    versionl);
  NuevoNodo.ImageIndex := 4;
  NuevoNodo.SelectedIndex := 4;
  NuevoNodo := Indices.Items.AddChild(Indices.Items[N], 'Versin n -> ' +
    versionn);
  NuevoNodo.ImageIndex := 4;
  NuevoNodo.SelectedIndex := 4;
  N := Indices.Selected.AbsoluteIndex;
  While Indices.Items[N].Level <> 0 Do
   Dec(N);
  NuevoNodo := Indices.Items.AddChild(Indices.Items[N], 'Localizacin/Rutas');
  NuevoNodo.ImageIndex := 2;
  NuevoNodo.SelectedIndex := 2;
  Indices.Selected := NuevoNodo;
  N := Indices.Selected.AbsoluteIndex;
  While Indices.Items[N].Level <> 1 Do
    Dec(N);
  NuevoNodo := Indices.Items.AddChild(Indices.Items[N], 'Archivos de Programa -> ' +
    archivos);
  NuevoNodo.ImageIndex := 4;
  NuevoNodo.SelectedIndex := 4;
  NuevoNodo := Indices.Items.AddChild(Indices.Items[N], 'System -> ' +
    sistema);
  NuevoNodo.ImageIndex := 4;
  NuevoNodo.SelectedIndex := 4;
  NuevoNodo := Indices.Items.AddChild(Indices.Items[N], 'Windows -> ' +
    windows);
  NuevoNodo.ImageIndex := 4;
  NuevoNodo.SelectedIndex := 4;}
{  N := Indices.Selected.AbsoluteIndex;
  While Indices.Items[N].Level <> 0 Do
   Dec(N);
  NuevoNodo := Indices.Items.AddChild(Indices.Items[N], 'Variables de entorno MS-DOS');
  NuevoNodo.ImageIndex := 2;
  NuevoNodo.SelectedIndex := 2;
  getdos

  Env := GetDOSEnvironment;

  While Env^ <> #0 do begin
    Indices.Selected := NuevoNodo;
    N := Indices.Selected.AbsoluteIndex;
    While Indices.Items[N].Level <> 1 Do
      Dec(N);
    NuevoNodo := Indices.Items.AddChild(Indices.Items[N], StrPas(Env));
    NuevoNodo.ImageIndex := 4;
    NuevoNodo.SelectedIndex := 4;
    Inc(Env, StrLen(Env) + 1);
  end;}

  //DATOS APLICACIN
  NuevoNodo := Indices.Items.Add(Nil, 'Aplicacin');
  With NuevoNodo Do
  Begin
    ImageIndex := 0;
    SelectedIndex := 0;
  End;
  Indices.Selected := NuevoNodo;
  N := Indices.Selected.AbsoluteIndex;
  While Indices.Items[N].Level <> 0 Do
   Dec(N);
  NuevoNodo := Indices.Items.AddChild(Indices.Items[N], 'Datos aplicacin');
  NuevoNodo.ImageIndex := 2;
  NuevoNodo.SelectedIndex := 2;
  Indices.Selected := NuevoNodo;
  N := Indices.Selected.AbsoluteIndex;
  While Indices.Items[N].Level <> 1 Do
    Dec(N);
  NuevoNodo := Indices.Items.AddChild(Indices.Items[N], 'Nombre -> ' +
    application.title);
  NuevoNodo.ImageIndex := 4;
  NuevoNodo.SelectedIndex := 4;
  NuevoNodo := Indices.Items.AddChild(Indices.Items[N], 'Versin -> ' +
    vTVersionAplicacion);
  NuevoNodo.ImageIndex := 4;
  NuevoNodo.SelectedIndex := 4;
  NuevoNodo := Indices.Items.AddChild(Indices.Items[N], 'Ruta -> ' +
    application.ExeName);
  NuevoNodo.ImageIndex := 4;
  NuevoNodo.SelectedIndex := 4;
  NuevoNodo := Indices.Items.AddChild(Indices.Items[N], 'Desarrollador -> ' +
    'AjpdSoft  -  http://www.ajpdsoft.com');
  NuevoNodo.ImageIndex := 4;
  NuevoNodo.SelectedIndex := 4;
  N := Indices.Selected.AbsoluteIndex;
  While Indices.Items[N].Level <> 0 Do
   Dec(N);
  NuevoNodo := Indices.Items.AddChild(Indices.Items[N], 'Empresa abierta');
  NuevoNodo.ImageIndex := 2;
  NuevoNodo.SelectedIndex := 2;
  Indices.Selected := NuevoNodo;
  N := Indices.Selected.AbsoluteIndex;
  While Indices.Items[N].Level <> 1 Do
    Dec(N);
  NuevoNodo := Indices.Items.AddChild(Indices.Items[N], 'ID -> ' +
    inttostr(vTIDEmpresa));
  NuevoNodo.ImageIndex := 4;
  NuevoNodo.SelectedIndex := 4;
  NuevoNodo := Indices.Items.AddChild(Indices.Items[N], 'Nombre -> ' +
    vTNombreEmpresa);
  NuevoNodo.ImageIndex := 4;
  NuevoNodo.SelectedIndex := 4;
  NuevoNodo := Indices.Items.AddChild(Indices.Items[N], 'Ruta -> ' +
    vTRutaEmpresa);
  NuevoNodo.ImageIndex := 4;
  NuevoNodo.SelectedIndex := 4;
  NuevoNodo := Indices.Items.AddChild(Indices.Items[N], 'Fecha inicio -> ' +
    datetostr(vTInicioEmpresa));
  NuevoNodo.ImageIndex := 4;
  NuevoNodo.SelectedIndex := 4;
  NuevoNodo := Indices.Items.AddChild(Indices.Items[N], 'Fecha fin -> ' +
    datetostr(vTFinEmpresa));
  NuevoNodo.ImageIndex := 4;
  NuevoNodo.SelectedIndex := 4;
  NuevoNodo := Indices.Items.AddChild(Indices.Items[N], 'Moneda -> ' +
    vTmonedaEmpresa);
  NuevoNodo.ImageIndex := 4;
  NuevoNodo.SelectedIndex := 4;
  //Dems empresas
  tempresas.close;
  tempresas.databasename := extractfilepath(application.ExeName);
  tempresas.open;
  tempresas.active := true;
  tempresas.first;
  if tempresas.RecordCount > 1 then
  begin
    N := Indices.Selected.AbsoluteIndex;
    While Indices.Items[N].Level <> 0 Do
     Dec(N);
    NuevoNodo := Indices.Items.AddChild(Indices.Items[N], 'Dems empresas');
    NuevoNodo.ImageIndex := 2;
    NuevoNodo.SelectedIndex := 2;
    Indices.Selected := NuevoNodo;
    while not tempresas.eof do
    begin
      if dempresas.dataset.fieldbyname('ID').value <>
          vTIDEmpresa then
      begin
        if not varisnull(dempresas.dataset.fieldbyname('NombreEmpresa').value) then
        begin
          N := Indices.Selected.AbsoluteIndex;
          While Indices.Items[N].Level <> 1 Do
            Dec(N);
          NuevoNodo := Indices.Items.AddChild(Indices.Items[N], 'Empresa -> ' +
            dempresas.dataset.fieldbyname('NombreEmpresa').value);
          NuevoNodo.ImageIndex := 2;
          NuevoNodo.SelectedIndex := 2;
        end;
        if not varisnull(dempresas.dataset.fieldbyname('ID').value) then
        begin
          Indices.Selected := NuevoNodo;
          N := Indices.Selected.AbsoluteIndex;
          While Indices.Items[N].Level <> 2 Do
            Dec(N);
          NuevoNodo := Indices.Items.AddChild(Indices.Items[N], 'ID -> ' +
            inttostr(dempresas.dataset.fieldbyname('ID').value));
          NuevoNodo.ImageIndex := 4;
          NuevoNodo.SelectedIndex := 4;
        end;
        if not varisnull(dempresas.dataset.fieldbyname('Ruta').value) then
        begin
          NuevoNodo := Indices.Items.AddChild(Indices.Items[N], 'Ruta -> ' +
            dempresas.dataset.fieldbyname('Ruta').value);
          NuevoNodo.ImageIndex := 4;
          NuevoNodo.SelectedIndex := 4;
        end;
        if not varisnull(dempresas.dataset.fieldbyname('FechaAlta').value) then
        begin
          NuevoNodo := Indices.Items.AddChild(Indices.Items[N], 'Fecha inicio -> ' +
            datetostr(dempresas.dataset.fieldbyname('FechaAlta').value));
          NuevoNodo.ImageIndex := 4;
          NuevoNodo.SelectedIndex := 4;
        end;
        if not varisnull(dempresas.dataset.fieldbyname('FechaBaja').value) then
        begin
          NuevoNodo := Indices.Items.AddChild(Indices.Items[N], 'Fecha fin -> ' +
            datetostr(dempresas.dataset.fieldbyname('FechaBaja').value));
          NuevoNodo.ImageIndex := 4;
          NuevoNodo.SelectedIndex := 4;
        end;
        if not varisnull(dempresas.dataset.fieldbyname('Moneda').value) then
        begin
          NuevoNodo := Indices.Items.AddChild(Indices.Items[N], 'Moneda -> ' +
            dempresas.dataset.fieldbyname('Moneda').value);
          NuevoNodo.ImageIndex := 4;
          NuevoNodo.SelectedIndex := 4;
        end;
      end;
      tempresas.next;
    end;
  end;
end;

procedure TFormAcercaDe.GuardarClick(Sender: TObject);
begin
  dlgguardar.FileName := 'Informacion general.cdc';
  dlgguardar.Title := 'Guardar informacin general...';
  dlgguardar.Filter := 'Informacin Control de campo|*.cdc|Texto sin formato|*.txt|Todos los ficheros|*.*';
  if dlgguardar.Execute then
  begin
    // Grabamos el contenido en un archivo
    Indices.SaveToFile(dlgguardar.FileName);
  end;
end;

 procedure TFormAcercaDe.IndicesCollapsing(Sender: TObject; Node: TTreeNode;
  var AllowCollapse: Boolean);
begin
   // Restauramos las imgenes originales
   Node.ImageIndex := Node.Level * 2;
   Node.SelectedIndex := Node.Level * 2;
end;

procedure TFormAcercaDe.IndicesExpanding(Sender: TObject; Node: TTreeNode;
  var AllowExpansion: Boolean);
begin
     // Si no estamos en el ltimo nivel
   If Node.Level <> 2 Then
    Begin
         // Usamos las imgenes de los libros abiertos
       Node.ImageIndex := Node.Level * 2 + 1;
       Node.SelectedIndex := Node.Level * 2 + 1;
    End;
end;

procedure TFormAcercaDe.RecuperarClick(Sender: TObject);
Var
   N: Integer;
begin
  dlgabrir.FileName := 'Informacion general.cdc';
  dlgabrir.Title := 'Abrir archivo de informacin general...';
  dlgabrir.Filter := 'Informacin Control de Campo|*.cdc|Texto sin formato|*.txt|Todos los archivos|*.*';
  if dlgabrir.Execute then
  begin
    With Indices Do
    Begin
      // Recuperamos el contenido del archivo
      LoadFromFile(dlgabrir.filename);
      // y restablecemos las imgenes segn el nivel
      For N := 0 To Items.Count - 1 Do
      Begin
        Items[N].ImageIndex := Items[N].Level * 2;
        Items[N].SelectedIndex := Items[N].Level * 2;
      End;
    End;
  end;
end;


procedure LeerDefinicion(const ADB, ATable: string; Lista: TStrings);
var
  I: Integer;
  S: string;
begin
  with TTable.Create(nil) do
  try
    DatabaseName := ADB;
    TableName := ATable;
    FieldDefs.Update;
    Lista.BeginUpdate;
    try
      lista.Add('***** ALIAS: ' + adb + ' *****');
      Lista.Add('TABLA: ' + ATable);
      Lista.Add('Ruta: ' + '');
      lista.add('Campos:');
      for I := 0 to FieldDefs.Count - 1 do
        with FieldDefs.Items[I] do
        begin
          S := '  [Tipo: ' + GetEnumName(TypeInfo(TFieldType), Ord(DataType)) + ']';
          S := #9 + '  [' + Name + ']' + Copy(S, 1, Length(S));
          if Size <> 0 then
            S := S + '  [Tamao: ' + IntToStr(Size) + ']';
          if Required then
            S := S + '  [Valor Requerido]';
          if I < FieldDefs.Count - 1 then
            Lista.Add(S);
        end;
      Lista.Add(')');
    finally
      Lista.EndUpdate;
    end;
  finally
    Free;
  end;
end;


Function LetraNif (Nif: String) : Char;
var
  s : String;
Begin
  s := 'TRWAGMTFPDXBNJZSQVHLCKET';
  if nif <> '' then
    LetraNif := s[StrToInt(NIF) Mod (23)+1]
  else
    LetraNif := ' ';
End;{LetraNif}

procedure TFormAcercaDe.BCalcularClick(Sender: TObject);
begin
  l.caption := LetraNIF(txtdni.text);
end;

procedure TFormAcercaDe.BitBtn2Click(Sender: TObject);
begin
  CLOSE;
end;


procedure TFormAcercaDe.TxtDNIChange(Sender: TObject);
begin
  l.caption:='';
  BCalcular.Default:=true;
end;

procedure TFormAcercaDe.FormShow(Sender: TObject);
begin
  screen.cursor := crdefault;
end;

procedure TFormAcercaDe.BActivarClick(Sender: TObject);
begin
  if vtversioncompleta = 0 then
  begin
    baceptar.Visible := true;
    TxtContrasena.visible := true;
    txtcontrasena.setfocus;
  end;
end;

procedure TFormAcercaDe.BAceptarClick(Sender: TObject);
begin
  if txtcontrasena.Text <> 'AAABBBCCCDDD' then
  begin
    vtversioncompleta := 0;
    with tinifile.create (changefileext(paramstr(0),'.INI')) do
    try
      writeinteger('Aplicacion','Formularios', vtversioncompleta);
    finally
      free;
    end;
    messagedlg ('La contrasea es incorrecta, consulte con su proveedor.',mterror,[mbok],0);
  end
  else
  begin
    vtversioncompleta := 1;
    with tinifile.create (changefileext(paramstr(0),'.INI')) do
    try
      writeinteger('Aplicacion','Formularios', vtversioncompleta);
    finally
      free;
    end;
    messagedlg ('La aplicacin ha quedado registrada.',mtinformation,[mbok],0);    
  end;
  BActivar.Visible := false;
  BAceptar.Visible := false;
  txtcontrasena.Visible := false;
end;

procedure TFormAcercaDe.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if ((key = 'r') or (key = 'R')) and
      (vtversioncompleta <> 1) then
    bactivar.visible := true;
end;

procedure TFormAcercaDe.SpeedButton8Click(Sender: TObject);
begin
  dlgguardar.FileName := 'Campo.ini';
  dlgguardar.Title := 'Guardar INI...';
  dlgguardar.Filter := 'INI campo|*.ini|Texto sin formato|*.txt|Todos los ficheros|*.*';
  if dlgguardar.Execute then
  begin
    // Grabamos el contenido en un archivo
    TxtINI.Lines.SaveToFile(dlgguardar.FileName);
  end;
end;

procedure TFormAcercaDe.SpeedButton9Click(Sender: TObject);
begin
  dlgguardar.FileName := 'campo.log';
  dlgguardar.Title := 'Guardar LOG...';
  dlgguardar.Filter := 'LOG campo|*.log|Texto sin formato|*.txt|Todos los ficheros|*.*';
  if dlgguardar.Execute then
  begin
    // Grabamos el contenido en un archivo
    TxtLog.lines.SaveToFile(dlgguardar.FileName);
  end;
end;

procedure TFormAcercaDe.LWEBClick2(Sender: TObject);
begin
  ShellExecute(Handle, Nil, PChar(LWEB.CAPTION),
      Nil, Nil, SW_SHOWNORMAL);
end;

procedure TFormAcercaDe.OKButtonClick(Sender: TObject);
begin
  close;
end;

end.

