unit UnidadCalendario;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Buttons, ComCtrls, ActnList, Menus, ToolWin, Grids,
  Calendar;

type
  TFormCalendario = class(TForm)
    PopupMenu1: TPopupMenu;
    ActionList1: TActionList;
    ActSeleccionar: TAction;
    ActCerrar: TAction;
    ActIrAHoy: TAction;
    CB: TControlBar;
    BB: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton5: TToolButton;
    Seleccionar1: TMenuItem;
    Irahoy1: TMenuItem;
    N1: TMenuItem;
    ActCerrar1: TMenuItem;
    Calendar1: TCalendar;
    LFecha: TLabel;
    ActMesSiguiente: TAction;
    LFechaSeleccionada: TLabel;
    ActMesAnterior: TAction;
    ActAnoSiguiente: TAction;
    ActAnoAnterior: TAction;
    N2: TMenuItem;
    MesAnterior1: TMenuItem;
    Aosiguiente1: TMenuItem;
    Aoanterior1: TMenuItem;
    Aosiguiente2: TMenuItem;
    N3: TMenuItem;
    ToolButton3: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    ToolButton10: TToolButton;
    ToolButton11: TToolButton;
    ActSumarDias: TAction;
    ToolButton12: TToolButton;
    SumarRestardas1: TMenuItem;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure ActSeleccionarExecute(Sender: TObject);
    procedure ActCerrarExecute(Sender: TObject);
    procedure ActIrAHoyExecute(Sender: TObject);
    procedure CalendarioKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Calendar1Change(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure Calendar1KeyPress(Sender: TObject; var Key: Char);
    procedure ActMesSiguienteExecute(Sender: TObject);
    procedure ActMesAnteriorExecute(Sender: TObject);
    procedure ActAnoSiguienteExecute(Sender: TObject);
    procedure ActAnoAnteriorExecute(Sender: TObject);
    procedure ActSumarDiasExecute(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormCalendario: TFormCalendario;

implementation

uses UnidadProcedimientos;

{$R *.DFM}

procedure TFormCalendario.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  action := caFree;
end;

procedure TFormCalendario.FormShow(Sender: TObject);
var
  dia, nMes, ano : word;
begin
  DecodeDate (date, ano, nMes, dia);
  lfecha.caption := 'Hoy es: ' + inttostr(dia) + ' de ' +
      pMes (nMes) + ' de ' + inttostr(ano);
  Calendar1Change(nil);      
end;

procedure TFormCalendario.ActSeleccionarExecute(Sender: TObject);
begin
  claveelegida := datetostr(
      pFecha (calendar1.Day, calendar1.Month,calendar1.Year));
  close;
end;

procedure TFormCalendario.ActCerrarExecute(Sender: TObject);
begin
  close;
end;

procedure TFormCalendario.ActIrAHoyExecute(Sender: TObject);
var
  dia, mes, ano : word;
begin
  decodedate (date, ano, mes, dia);
  calendar1.Day := dia;
  calendar1.Month := mes;
  calendar1.Year := ano;
end;

procedure TFormCalendario.CalendarioKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key = 13 then
    ActSeleccionarExecute(nil);
end;

procedure TFormCalendario.Calendar1Change(Sender: TObject);
begin
  lfechaseleccionada.caption := 'Seleccin: ' +
      inttostr(Calendar1.Day) + ' de ' + pmes(calendar1.Month)
      + ' de ' + inttostr(calendar1.Year);
end;

procedure TFormCalendario.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = chr(27) then
    ActCerrarExecute(nil);
end;

procedure TFormCalendario.Calendar1KeyPress(Sender: TObject;
  var Key: Char);
begin
  if key = chr(13) then
    ActSeleccionarExecute(nil);
end;

procedure TFormCalendario.ActMesSiguienteExecute(Sender: TObject);
begin
  if (calendar1.day = 29) or (calendar1.day = 30) or (calendar1.day = 31) then
    calendar1.day := 15; 
  calendar1.Month := calendar1.Month + 1;
end;

procedure TFormCalendario.ActMesAnteriorExecute(Sender: TObject);
begin
  if (calendar1.day = 29) or (calendar1.day = 30) or (calendar1.day = 31) then
    calendar1.day := 15;
  calendar1.Month := calendar1.Month - 1;
end;

procedure TFormCalendario.ActAnoSiguienteExecute(Sender: TObject);
begin
  if (calendar1.day = 29) or (calendar1.day = 30) or (calendar1.day = 31) then
    calendar1.day := 15;
  calendar1.year := calendar1.year + 1;
end;

procedure TFormCalendario.ActAnoAnteriorExecute(Sender: TObject);
begin
  if (calendar1.day = 29) or (calendar1.day = 30) or (calendar1.day = 31) then
    calendar1.day := 15;
  calendar1.year := calendar1.year - 1;
end;

procedure TFormCalendario.ActSumarDiasExecute(Sender: TObject);
var
  dia, ano, mes : word;
  dias : string;
  diasN : integer;
  fechaActual : tdatetime;
begin
  diasN := 0;
  dias := inputbox ('Sumar/Restar das a la fecha seleccionada...',
      'Das a sumar/restar (para restar -> nmero negativo).','15');
  try
    diasN := strtoint(dias);
  except
    msError ('No ha introducido un nmero vlido.', 'Nmero no vlido...');
  end;
  fechaactual := pFecha (calendar1.day,
      calendar1.month, calendar1.Year);
  fechaactual := fechaactual + diasN;
  decodedate(fechaactual, ano, mes, dia);
  calendar1.Day := dia;
  calendar1.month := mes;
  calendar1.year := ano;    
end;

end.
