unit UnidadCasa;

interface

uses
  Windows, Messages, Classes, SysUtils, Graphics, Controls, StdCtrls, Forms,
  Dialogs, DBCtrls, DB, DBGrids, Buttons, DBTables, Grids, ExtCtrls,
  ComCtrls, Qrctrls, QuickRpt, ToolWin, Menus;

type
  TFormCasas = class(TForm)
    TTabla: TTable;
    DBD: TDataSource;
    LImpresion: TQuickRep;
    TitleBand1: TQRBand;
    QRBand1: TQRBand;
    QRDBText6: TQRDBText;
    QRDBText2: TQRDBText;
    ColumnHeaderBand1: TQRBand;
    QRLabel5: TQRLabel;
    QRLabel2: TQRLabel;
    PageFooterBand1: TQRBand;
    QRSysData2: TQRSysData;
    QRDBText1: TQRDBText;
    QRLabel1: TQRLabel;
    QRLabel3: TQRLabel;
    QRDBText3: TQRDBText;
    ScrollBox1: TScrollBox;
    QRSysData3: TQRSysData;
    LEmpresa: TQRLabel;
    PageHeaderBand1: TQRBand;
    QRSysData1: TQRSysData;
    Panel2: TPanel;
    Navegador: TDBNavigator;
    BAnadir: TBitBtn;
    BEliminarObreros: TBitBtn;
    Panel3: TPanel;
    Tabla: TDBGrid;
    ControlBar1: TControlBar;
    BB: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolBar2: TToolBar;
    Panel1: TPanel;
    LBuscar: TLabel;
    TxtBuscar: TEdit;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    PopupMenu1: TPopupMenu;
    Aadirnuevafinca1: TMenuItem;
    N1: TMenuItem;
    Previsualizar1: TMenuItem;
    N3: TMenuItem;
    Cerrarventana1: TMenuItem;
    N: TStaticText;
    procedure BitBtn1Click(Sender: TObject);
    procedure TTablaAfterInsert(DataSet: TDataSet);
    procedure TablaEnter(Sender: TObject);
    procedure TTablaPostError(DataSet: TDataSet; E: EDatabaseError;
      var Action: TDataAction);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure BPrevisualizarClick(Sender: TObject);
    procedure BEliminarObrerosClick(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure TxtBuscarChange2(Sender: TObject);
    procedure BAnadirClick(Sender: TObject);
    procedure TTablaAfterScroll(DataSet: TDataSet);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  FormCasas: TFormCasas;

implementation

uses UnidadMenuPrincipal, UnidadDatos;

{$R *.DFM}

procedure TFormCasas.BitBtn1Click(Sender: TObject);
begin
  if (dbd.DataSet.state=dsinsert) or (dbd.dataset.state=dsedit) then
    dbd.DataSet.Post;
  close;
end;

procedure TFormCasas.TTablaAfterInsert(DataSet: TDataSet);
begin
  tabla.SetFocus;
  tabla.SelectedIndex:=1;  
end;

procedure TFormCasas.TablaEnter(Sender: TObject);
begin
  dbd.dataset.FieldByName('Telefono').editmask:='0000000009;1;_';
end;


procedure TFormCasas.TTablaPostError(DataSet: TDataSet; E: EDatabaseError;
  var Action: TDataAction);
var
  i: integer;
begin
  if E is EDBEngineError then
  begin
    for i:=0 to EDBEngineError(E).errorcount-1 do
    begin
      if EDBEngineError(E).errors[i].Errorcode=9729 then
      begin
        messagedlg('La casa introducida ya existe, cmbiela y vuelva a intentarlo.',mtwarning,[mbok],0);
        action := daAbort;
        exit;
      end
      else
      begin
        messagedlg('Hay algn dato incorrecto. Compruebe los datos y vuelva a intentarlo.',mtwarning,[mbok],0);
        action := daAbort;
        exit;
      end;  
    end;
  end;
end;

procedure TFormCasas.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  action := cafree;
end;

procedure TFormCasas.FormShow(Sender: TObject);
begin
  ttabla.open;
  if formmenuprincipal.vtflat=1 then
  begin
    navegador.flat:=true;
    bb.flat:=true;
  end
  else
  begin
    navegador.flat:=false;
    bb.flat:=false;
  end;
  n.caption:=inttostr(dbd.dataset.recno) + ' de ' + inttostr(dbd.DataSet.recordcount);  
end;

procedure TFormCasas.BPrevisualizarClick(Sender: TObject);
begin
  lempresa.caption:=formmenuprincipal.vtnombreempresa;
  limpresion.ReportTitle:='LISTADO DE CASAS COMERCIALES DE PRODUCTOS FITOSANITARIOS';
  limpresion.Preview;
end;

procedure TFormCasas.BEliminarObrerosClick(Sender: TObject);
var
  nombre:string;
begin
  if dbd.DataSet.recordcount=0 then
    messagedlg('No hay casas comerciales para eliminar.',mtinformation,[mbok],0)
  else
  begin
    if not (dbd.dataset.fieldbyname('Nombre').value=Null) then
      Nombre:=dbd.dataset.fieldbyname('Nombre').value
    else
      nombre:='';
    if messagedlg('Est seguro que desea ELIMINAR la casa comercial [' + nombre + ']?',mtconfirmation,[mbno,mbyes],0)=mryes then
      dbd.dataset.delete;
  end;    
end;

procedure TFormCasas.RadioButton1Click(Sender: TObject);
begin
  ttabla.indexfieldnames:='Nombre';
  lbuscar.caption:='Nombre a &buscar:';
end;

procedure TFormCasas.RadioButton2Click(Sender: TObject);
begin
  ttabla.indexfieldnames:='ID';
  lbuscar.caption:='ID a &buscar:';
end;

procedure TFormCasas.TxtBuscarChange2(Sender: TObject);
begin
  try
    ttabla.findnearest([txtbuscar.text])
  except
  end;  
end;

procedure TFormCasas.BAnadirClick(Sender: TObject);
begin
  dbd.dataset.Insert;
end;

procedure TFormCasas.TTablaAfterScroll(DataSet: TDataSet);
begin
  n.caption:=inttostr(dbd.dataset.recno) + ' de ' + inttostr(dbd.DataSet.recordcount);
end;

end.