unit UnidadClaves;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Grids, DBGrids, ExtCtrls, Db, DBTables, inifiles, 
  ComCtrls, ImgList, variants,shellapi;

type
  TFormClaves = class(TForm)
    Image1: TImage;
    Label1: TLabel;
    TxtClave: TEdit;
    BCancelar: TBitBtn;
    BAceptar: TBitBtn;
    TTabla: TTable;
    DBD: TDataSource;
    TTablaID: TAutoIncField;
    TTablaNombre: TStringField;
    TTablaClave: TStringField;
    TTablaGrupo: TStringField;
    TTablaTipo: TStringField;
    TTablaConsulta: TBooleanField;
    TTablaActivo: TBooleanField;
    Label2: TLabel;
    de: TDataSource;
    te: TTable;
    Panel1: TPanel;
    TLista: TDBGrid;
    Panel2: TPanel;
    DBGrid1: TDBGrid;
    Label3: TLabel;
    Label4: TLabel;
    LNombre: TLabel;
    LVersion: TLabel;
    LAcceso: TLabel;
    LEjecuciones: TLabel;
    LApagado: TLabel;
    BE: TStatusBar;
    Panel3: TPanel;
    LI: TShape;
    Label12: TLabel;
    LWEB: TLabel;
    procedure guardaActivo (id : integer);
    procedure FormCreate(Sender: TObject);
    procedure comprobar ();
    procedure Pasar ();
    procedure BAceptarClick(Sender: TObject);
    procedure TListaDblClick(Sender: TObject);
    procedure TListaKeyPress(Sender: TObject; var Key: Char);
    procedure BCancelarClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TxtClaveKeyPress(Sender: TObject; var Key: Char);
    procedure DBDDataChange(Sender: TObject; Field: TField);
    procedure DBGrid1DblClick(Sender: TObject);
    procedure DBGrid1KeyPress(Sender: TObject; var Key: Char);
    procedure deDataChange(Sender: TObject; Field: TField);
    procedure LWEBClick(Sender: TObject);
  private
    seguir : boolean;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormClaves: TFormClaves;

implementation

uses UnidadI, UnidadDatos, UnidadMenuPrincipal;

{$R *.DFM}

procedure TFormClaves.FormCreate(Sender: TObject);
var
  id, idempresa, neje : integer;
begin
  seguir := false;
  session.AddPassword ('11111111');
  TTabla.DatabaseName := extractfilepath(application.ExeName);
  Te.DatabaseName := extractfilepath(application.ExeName);
  ttabla.open;
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    id := readinteger ('Usuario', 'ID', -33333);
    idempresa := readinteger ('Empresa', 'Codigo', -33333);
    lacceso.caption := 'ltimo acceso: ' +
        datetimetostr(readdatetime ('Aplicacion', 'Ultimo Acceso', now));
    lapagado.caption := 'Se cerr correctamente: ' +
        readstring ('Aplicacion', 'Cerrada bien', 'No');
    neje := readinteger ('Aplicacion', 'Ejecuciones', 0);
    lejecuciones.caption := 'N Ejecuciones: ' +
        inttostr(neje);
    writeinteger('Aplicacion', 'Ejecuciones', neje + 1);
    WriteString ('Aplicacion', 'Cerrada bien', 'No');
  finally
    free;
  end;
  te.open;
  if id <> -33333 then
    ttabla.Locate ('ID', id, []);
  if idempresa <> -33333 then
    te.Locate ('ID', idempresa, []);
end;

procedure tformclaves.comprobar ();
begin
 if (ttablaclave.AsString = null) or (ttablaclave.AsString = '') then
   BAceptarClick(nil)
 else
 begin
   TxtClave.SetFocus;
   txtclave.SelectAll;
 end;
end;

procedure tformclaves.guardaActivo (id : integer);
begin
  ttabla.close;
  ttabla.ReadOnly := false;
  dbd.DataSet.DisableControls;
  ttabla.open;
  ttabla.first;
  while not ttabla.eof do
  begin
    if (TTablaID.asinteger <> id) and (TTablaActivo.AsBoolean = true) then
    begin
      ttabla.edit;
      TTablaActivo.AsBoolean := false;
      ttabla.post;
    end;
    if ttablaid.asinteger = id then
    begin
      ttabla.edit;
      TTablaActivo.AsBoolean := true;
      ttabla.post;
    end;
    ttabla.next;
  end;
end;

procedure tformclaves.Pasar ();
var
  id : integer;
  clave, tipo, ruta : string;
begin
  if (TTablaID.AsInteger = null)  or (TTablaID.AsInteger = null) then
  begin
    messagedlg ('El usuario actual no tiene todos los datos (tipo ' +
        'de usuario o identificador), elija otro usuario.', mterror, [mbok],0);
    exit;
  end;
  id := TTablaID.AsInteger;
  tipo := TTablaTipo.AsString;
  if (TTablaClave.AsString = null) then
    clave := ''
  else
    clave := TTablaClave.AsString;
  if (clave = '') then
  begin
    seguir := true;
  end
  else
  begin
    if txtclave.text = TTablaClave.asstring then
    begin
      seguir := true;
    end
    else
    begin
      seguir := false;
      messagedlg ('Clave incorrecta para el usuario actual.',
          mterror, [mbok],0);
      txtclave.SelectAll;
      txtclave.setfocus;
    end;
  end;
  if seguir then
  begin
   guardaActivo(id);
   with tinifile.create (changefileext(paramstr(0),'.INI')) do
    try
      writestring ('Usuario', 'Tipo', tipo);
      writestring ('Usuario', 'Nombre', clave);
      writeinteger ('Usuario', 'ID', id);
    finally
      free;
    end;
    //abrir empresa
    if not varisnull(de.dataset.fieldbyname('Ruta').value) then
      ruta := de.dataset.fieldbyname('Ruta').value
    else
      ruta := '';
    if (de.dataset.fieldbyname('Ficheros').value = false) or
       (not DirectoryExists(ruta)) then
    begin
      messagedlg ('Debe crear los ficheros de la empresa antes de abrirla.',
                 mterror, [mbok], 0);
      DBGrid1.setfocus;
      exit;
    end;
    if  varisnull(de.dataset.fieldbyname('Moneda').value) or
        varisnull(de.dataset.fieldbyname('Cambio').value) or
        varisnull(de.dataset.fieldbyname('NombreEmpresa').value) or
        varisnull(de.dataset.fieldbyname('ID').value) or
        varisnull(de.dataset.fieldbyname('FechaAlta').value) or
        varisnull(de.dataset.fieldbyname('FechaBaja').value) or
        varisnull(de.dataset.fieldbyname('CIF').value) or
        varisnull(de.dataset.fieldbyname('Domicilio').value) or
        varisnull(de.dataset.fieldbyname('Poblacion').value) or
        varisnull(de.dataset.fieldbyname('Provincia').value) or
        varisnull(de.dataset.fieldbyname('CP').value) or
        varisnull(de.dataset.fieldbyname('Telefono').value) then
    begin
      messagedlg ('Faltan datos por introducir en la empresa actual ' +
                     '(moneda, cambio, nombre, cdigo, fecha inicio, fecha ' +
                     'fin, domicilio, CIF, telfono, C.P., poblacin y ' +
                     'provincia).', mterror, [mbok], 0);
      DBGrid1.setfocus;
      exit;
    end;
    if (ruta = '') or (not (directoryexists(ruta))) then
    begin
      messagedlg ('La empresa actual no tiene datos, debe crearlos.',
                 mterror, [mbok],0);
      DBGrid1.setfocus;
      exit;
    end;
    screen.Cursor := crhourglass;
    try
      with tinifile.create (changefileext(paramstr(0),'.INI')) do
      try
        writestring ('Empresa','Ruta',ruta);
        if not varisnull(de.dataset.fieldbyname('Usuario').value) then
          writestring ('Aplicacion','Usuario',de.dataset.fieldbyname('Usuario').value);
        writestring ('Empresa','Nombre',de.dataset.fieldbyname('NombreEmpresa').value);
        writestring ('Empresa','CIF',de.dataset.fieldbyname('CIF').value);
        writestring ('Empresa','Domicilio',de.dataset.fieldbyname('Domicilio').value);
        writestring ('Empresa','Poblacion',de.dataset.fieldbyname('Poblacion').value);
        writestring ('Empresa','Provincia',de.dataset.fieldbyname('Provincia').value);
        writestring ('Empresa','Telefono',de.dataset.fieldbyname('Telefono').value);
        writestring ('Empresa','CP',de.dataset.fieldbyname('CP').value);
        writestring ('Empresa','Moneda',de.dataset.fieldbyname('Moneda').value);
        writefloat ('Empresa','Cambio',de.dataset.fieldbyname('Cambio').value);
        writedate ('Empresa','Inicio',de.dataset.fieldbyname('FechaAlta').value);
        writedate ('Empresa','Fin',de.dataset.fieldbyname('FechaBaja').value);
        writeinteger ('Empresa','Codigo',de.dataset.fieldbyname('ID').value);
        if not varisnull(de.dataset.fieldbyname('Inscripcion').value) then
          writestring ('Empresa','Inscripcion',
              de.dataset.fieldbyname('Inscripcion').value)
        else
          writestring ('Empresa','Inscripcion','');
        if not varisnull(de.dataset.fieldbyname('RutaLogotipo').value) then
          writestring ('Empresa','Ruta Logotipo',
              de.dataset.fieldbyname('RutaLogotipo').value);
      finally
        free;
      end;
      datos := tdatos.create(nil);
      datos.db.close;
      datos.db.Params.Clear;
      datos.db.Params.Add('PATH=' + ruta);
      datos.db.Params.Add('DEFAULT DRIVER=PARADOX');
      datos.db.Params.Add('ENABLE BCD=FALSE');
      datos.db.Connected := true;
      formmenuprincipal.AbrirEmpresa(false);
    except
      screen.Cursor := crdefault;
      raise;
    end;
    screen.Cursor := crdefault;
    Close;
  end;
end;


procedure TFormClaves.BAceptarClick(Sender: TObject);
begin
  Pasar;
end;

procedure TFormClaves.TListaDblClick(Sender: TObject);
begin
  DBGrid1.SetFocus;
end;

procedure TFormClaves.TListaKeyPress(Sender: TObject; var Key: Char);
begin
  if key = chr(13) then
    DBGrid1.setfocus;
end;

procedure TFormClaves.BCancelarClick(Sender: TObject);
begin
  application.terminate;
end;

procedure TFormClaves.FormShow(Sender: TObject);
begin
  tlista.SetFocus;
end;

procedure TFormClaves.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if seguir then
    action := cafree
  else
    application.Terminate;
end;

procedure TFormClaves.TxtClaveKeyPress(Sender: TObject; var Key: Char);
begin
  if key = chr(13) then
    BAceptarclick(nil);
end;

procedure TFormClaves.DBDDataChange(Sender: TObject; Field: TField);
begin
  if (TTablaClave.AsString = '') or (ttablaclave.asstring = null) then
    txtclave.color := clSilver
  else
    txtclave.Color := clGreen;
end;

procedure TFormClaves.DBGrid1DblClick(Sender: TObject);
begin
  comprobar;
end;

procedure TFormClaves.DBGrid1KeyPress(Sender: TObject; var Key: Char);
begin
  if key = chr(13) then
    comprobar;
end;

procedure TFormClaves.deDataChange(Sender: TObject; Field: TField);
var
  rutaempresa : string;
  fecha : tdatetime;
  dias : double;
//  hora : tdatetime;
begin
  if not varisnull(de.DataSet.fieldbyname('Ruta').value) then
    rutaempresa := de.DataSet.fieldbyname('Ruta').value
  else
    rutaempresa := '';
  if fileexists(rutaempresa + '\CS.ini') then
  begin
    with tinifile.create (rutaempresa + '\CS.ini') do
    try
      fecha := readdate('Copia Seguridad', 'Fecha', date);
    finally
      free;
    end;
    dias := date - fecha;
    if (dias > 2) and (dias < 5) then
    begin
      li.Brush.Color := clYellow;
    end;
    if (dias > 5) and (dias < 10) then
    begin
      li.Brush.Color := clpurple;
    end;
    if (dias > 10) then
    begin
      li.Brush.Color := clRed;
    end;
    if (dias <= 2) then
    begin
      li.Brush.Color := clGreen;
    end;
    BE.Panels[0].text :=
        'La ltima copia de seguridad de esta empresa la realiz hace ' +
        floattostr(dias) + ' das';
  end
  else
  begin
    li.Brush.Color := clRed;
    BE.Panels[0].text :=
        'No existe informacin sobre copia de seguridad de esta empresa.';
  end;
end;

procedure TFormClaves.LWEBClick(Sender: TObject);
begin
  ShellExecute(Handle, Nil, PChar('http://www.ajpdsoft.com'),
      Nil, Nil, SW_SHOWNORMAL);
end;

end.
