unit UnidadConsultasPartes;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Buttons, db, DBTables,
  dxCntner, dxTL, dxDBCtrl, dxDBGrid, dxEditor, dxExEdtr, dxDBEdtr,
  dxDBELib, DBCtrls, dxDBTLCl, dxGrClms;

type
  TformConsultasPartes = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    BFiltrar: TBitBtn;
    TC: TQuery;
    DataSource1: TDataSource;
    Tabla: TdxDBGrid;
    txtVariedad: TDBLookupComboBox;
    TCID: TIntegerField;
    TCIDCuadrilla: TIntegerField;
    TCHorasObrero: TFloatField;
    TCTotalHoras: TFloatField;
    TCPrecioHora: TCurrencyField;
    TCTotalCoche: TCurrencyField;
    TCTotalObreros: TFloatField;
    TCImporteTotal: TCurrencyField;
    TCFecha: TDateField;
    TCNota: TStringField;
    TCIDTrabajo: TIntegerField;
    TCCuadrilla: TStringField;
    TCTrabajo: TStringField;
    TablaID: TdxDBGridMaskColumn;
    TablaIDCuadrilla: TdxDBGridMaskColumn;
    TablaHorasObrero: TdxDBGridMaskColumn;
    TablaTotalHoras: TdxDBGridMaskColumn;
    TablaPrecioHora: TdxDBGridCurrencyColumn;
    TablaTotalCoche: TdxDBGridCurrencyColumn;
    TablaTotalObreros: TdxDBGridMaskColumn;
    TablaImporteTotal: TdxDBGridCurrencyColumn;
    TablaFecha: TdxDBGridDateColumn;
    TablaNota: TdxDBGridMaskColumn;
    TablaIDTrabajo: TdxDBGridMaskColumn;
    TablaCuadrilla: TdxDBGridMaskColumn;
    TablaTrabajo: TdxDBGridMaskColumn;
    txtFinca: TDBLookupComboBox;
    Label2: TLabel;
    LObrero: TLabel;
    BSD1: TSpeedButton;
    txtObrero: TEdit;
    Label12: TLabel;
    procedure BFiltrarClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TablaDblClick(Sender: TObject);
    procedure BSD1Click(Sender: TObject);
    procedure txtObreroChange(Sender: TObject);
    procedure txtObreroKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formConsultasPartes: TformConsultasPartes;

implementation

uses UnidadDatos, UnidadMenuPrincipal, UnidadPartes, MPartes,
  UnidadSeleccion, unidadprocedimientos;

{$R *.dfm}

procedure TformConsultasPartes.BFiltrarClick(Sender: TObject);
begin
  TC.Close;
  TC.SQL.Clear;
  TC.sql.add('SELECT  p.*, c.nombre Cuadrilla, t.Trabajo Trabajo');
  TC.sql.add('FROM parte p, Cuadrillas c, trabajoRealizado t');
  TC.sql.add('WHERE p.IDCuadrilla = c.ID and p.IDTrabajo = t.ID AND p.ID IN (');
  TC.SQL.Add('  SELECT IDParte');
  TC.SQL.Add('  FROM FincasParte fp');
  TC.SQL.Add('  WHERE IDVariedadVariedades = :pIDVariedad)');
  TC.sql.add('ORDER BY p.Fecha');
  tc.ParamByName('pIDVariedad').DataType := ftInteger;
  tc.ParamByName('pIDVariedad').Value := txtVariedad.KeyValue;
  TC.open;
end;


procedure TformConsultasPartes.FormShow(Sender: TObject);
begin
  datos.TVariedades.Open;
  datos.tfincas.Open;
end;

procedure TformConsultasPartes.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  tc.Close;
  action := cafree;
end;

procedure TformConsultasPartes.TablaDblClick(Sender: TObject);
var
  f:tform;
begin
  screen.cursor:=crhourglass;
  lockwindowupdate(application.mainform.handle);
  try
    F := application.findcomponent('FormPartes') as tform;
    if Assigned(F) then
    begin
      if f.WindowState=wsminimized then
        f.windowstate:=wsmaximized;
      f.bringtofront;
      screen.cursor:=crdefault;
    end
    else
    begin
      application.createform (TFormpartes, Formpartes);
      formpartes.WindowState := wsmaximized;
    end;
    mopartes.tag := 1;
  finally
    lockwindowupdate(0);
  end;
  mopartes.tag := 1;
  mopartes.tpartes.Locate('ID', tc.fieldbyname('ID').value,[]);
end;

procedure TformConsultasPartes.BSD1Click(Sender: TObject);
begin
  application.createform(tformseleccion, formseleccion);
  formseleccion.tag := 10;
  formseleccion.ShowModal;
  if claveelegida <> '' then
    Txtobrero.Text := claveelegida;
end;

procedure TformConsultasPartes.txtObreroChange(Sender: TObject);
var
  nombre, apellido1, apellido2 : string;
begin
  if txtObrero.Text <> '' then
  begin
    datos.TObreros.Filtered := false;
    datos.tobreros.open;
    try
      if datos.TObreros.Locate ('ID', txtObrero.Text,[]) then
      begin
        if not varisnull(datos.TObreros.fieldbyname('Nombre').Value) then
          nombre := datos.TObreros.fieldbyname('Nombre').Value
        else
          nombre := '';
        if not varisnull(datos.TObreros.fieldbyname('Apellido1').Value) then
          apellido1 := datos.TObreros.fieldbyname('Apellido1').Value
        else
          apellido1 := '';
        if not varisnull(datos.TObreros.fieldbyname('Apellido2').Value) then
          apellido2 := datos.TObreros.fieldbyname('Apellido2').Value
        else
          apellido2 := '';
        LObrero.Caption := apellido1 + ' ' + apellido2 + ', ' + nombre;
      end
      else
        lobrero.Caption := '';
    except
      lobrero.Caption := '';
    end;
  end
  else
    lobrero.Caption := '';
end;

procedure TformConsultasPartes.txtObreroKeyPress(Sender: TObject; var Key: Char);
begin
  if key = '+' then
  begin
    key := chr(0);
    BSD1click(nil);
  end;
end;

end.
