unit UnidadDatosNomina;

interface

uses
  Windows, Messages, Classes, SysUtils, Graphics, Controls, StdCtrls, Forms,
  Dialogs, DBCtrls, DB, Mask, DBTables, ExtCtrls, ComCtrls, Buttons, Grids,
  DBGrids, Qrctrls, QuickRpt, Menus, ImgList, ToolWin, ActnList, variants;

type
  TFormQuincena = class(TForm)
    DBD: TDataSource;
    LImpresion: TQuickRep;
    TitleBand1: TQRBand;
    GroupHeaderBand1: TQRBand;
    QRLabel11: TQRLabel;
    PageFooterBand1: TQRBand;
    QRSysData1: TQRSysData;
    PopupMenu1: TPopupMenu;
    Previsualizar1: TMenuItem;
    N3: TMenuItem;
    Cerrarventana1: TMenuItem;
    QRSysData3: TQRSysData;
    LEmpresa: TQRLabel;
    PageHeaderBand1: TQRBand;
    QRSysData2: TQRSysData;
    CB: TControlBar;
    BB: TToolBar;
    ToolButton1: TToolButton;
    ToolButton3: TToolButton;
    ToolButton2: TToolButton;
    ActionList1: TActionList;
    ActNuevo: TAction;
    ActImprimir: TAction;
    ActCerrar: TAction;
    ActEliminar: TAction;
    QRLabel2: TQRLabel;
    QRLabel4: TQRLabel;
    QRLabel6: TQRLabel;
    QRLabel7: TQRLabel;
    QRBand1: TQRBand;
    QRDBText15: TQRDBText;
    QRDBText3: TQRDBText;
    QRDBText5: TQRDBText;
    QRDBText7: TQRDBText;
    QRDBText8: TQRDBText;
    QRDBText10: TQRDBText;
    QRLabel8: TQRLabel;
    SummaryBand1: TQRBand;
    QRExpr1: TQRExpr;
    QRLabel10: TQRLabel;
    QRDBText13: TQRDBText;
    QRExpr6: TQRExpr;
    QRExpr7: TQRExpr;
    QRExpr8: TQRExpr;
    QRExpr10: TQRExpr;
    PanelTotal: TPanel;
    Panel19: TPanel;
    Label14: TLabel;
    Label2: TLabel;
    txtTotalNeto: TStaticText;
    TxtNumero: TStaticText;
    TC: TQuery;
    txtTotalHoras: TStaticText;
    Label1: TLabel;
    Tabla: TDBGrid;
    Splitter1: TSplitter;
    Tab2: TPageControl;
    TabFiltrar: TTabSheet;
    ScrollBox1: TScrollBox;
    Panel6: TPanel;
    Label12: TLabel;
    BSD1: TSpeedButton;
    LObrero: TLabel;
    BFiltrarCliente: TBitBtn;
    txtObrero: TEdit;
    Panel5: TPanel;
    Label8: TLabel;
    Label11: TLabel;
    TxtDesdeFecha: TMaskEdit;
    TxtHastaFecha: TMaskEdit;
    BitBtn1: TBitBtn;
    AcumularFiltro: TCheckBox;
    BitBtn2: TBitBtn;
    procedure BCerrarClick(Sender: TObject);
    procedure DBEdit1Enter(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BPrevisualizarClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TablaKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure BFiltrarClienteClick(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BQuitarFiltroClick(Sender: TObject);
    procedure BSD1Click(Sender: TObject);
    procedure txtObreroChange(Sender: TObject);
    procedure txtObreroExit(Sender: TObject);
    procedure txtObreroKeyPress(Sender: TObject; var Key: Char);

    procedure filtrar (desdeObrero, hastaObrero : integer; desdeFecha, hastaFecha : Tdatetime);
    procedure filtrarInicio ();
    procedure BitBtn2Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  FormQuincena: TFormQuincena;

implementation

uses UnidadDatos, unidadprocedimientos, UnidadSeleccion;


{$R *.DFM}


procedure TFormQuincena.BCerrarClick(Sender: TObject);
begin
  close;
end;

procedure TFormQuincena.filtrarInicio ();
var
  desde, hasta : string;
begin
  try
    desde := DateToStr(VTFCInicio);
    hasta := DateToStr(VTFCFin);
  except
    MessageDlg('Introduzca las fechas de inicio y fin de nmina en ' +
        'Configuracin antes de continuar.', mtinformation,[mbok],0);
    close;
    exit;
  end;
  caption := 'Datos de CUA34 [' + desde + '] - [' + hasta + ']';
  tc.Close;
  tc.SQL.Clear;
  tc.DatabaseName := 'ACampo';
  tc.SQL.Add('select count(*) SNumero, sum(q.Horas) STotalHoras, sum(q.Total) STotalBruto, sum(q.TotalPercibir) STotalPercibir, sum(q.Coche) STotalCoche');
  tc.SQL.Add('from obreroscuadrillas e, "' + ExtractFilePath(application.ExeName) + 'Quincena\quincena.db" q');
  tc.SQL.Add('where q.IDObrero = e.ID AND q.IDObrero >= :pDIDObrero AND q.IDObrero <= :pHIDObrero and');
  tc.SQL.Add('FInicio >= :pFInicio and FFin <= :pFFin');
  tc.ParamByName('pFInicio').DataType := ftDate;
  tc.ParamByName('pFFin').DataType := ftDate;
  tc.ParamByName('pDIDObrero').DataType := ftinteger;
  tc.ParamByName('pHIDObrero').DataType := ftinteger;
  tc.ParamByName('pFInicio').value := strtodate(desde);
  tc.ParamByName('pFFin').value := strtodate(hasta);
  tc.ParamByName('pDIDObrero').value := 0;
  tc.ParamByName('pHIDObrero').value := 99999;
  try
    tc.open;
  except
    //silenciosa
  end;
  if tc.fieldbyname('SNumero').Value <= 0 then
  begin
    messagedlg ('No hay datos del CUA34 generados en el perodo de la ' +
        'empresa actual.', mtwarning,[mbok],0);
    close;
    exit;
  end;
  TxtNumero.Caption := formatfloat('###,###,###,##0;-###,###,###,##0;0',
      tc.fieldbyname('SNumero').Value);
  txtTotalNeto.Caption := formatfloat('###,###,###,##0.00;-###,###,###,##0.00;0',
      tc.fieldbyname('STotalPercibir').Value);
  txtTotalHoras.Caption := formatfloat('###,###,###,##0.00;-###,###,###,##0.00;0',
      tc.fieldbyname('STotalHoras').Value);
  tc.Close;
  tc.SQL.Clear;
  tc.DatabaseName := 'ACampo';
  tc.SQL.Add('select e.apellido1 || " " || e.apellido2 || ", " || e.nombre Nombre, q.Horas, q.Total, ' +
      'q.TotalPercibir, q.Coche, q.FInicio, q.FFin, q.PrecioHora');
  tc.SQL.Add('from obreroscuadrillas e, "' + ExtractFilePath(application.ExeName) + 'Quincena\quincena.db" q');
  tc.SQL.Add('where q.IDObrero = e.ID AND q.IDObrero >= :pDIDObrero AND q.IDObrero <= :pHIDObrero and');
  tc.SQL.Add('FInicio >= :pFInicio and FFin <= :pFFin');
  tc.SQL.Add('order by Nombre, q.FInicio');
  tc.ParamByName('pFInicio').DataType := ftDate;
  tc.ParamByName('pFFin').DataType := ftDate;
  tc.ParamByName('pDIDObrero').DataType := ftinteger;
  tc.ParamByName('pHIDObrero').DataType := ftinteger;
  tc.ParamByName('pFInicio').value := strtodate(desde);
  tc.ParamByName('pFFin').value := strtodate(hasta);
  tc.ParamByName('pDIDObrero').value := 0;
  tc.ParamByName('pHIDObrero').value := 99999;
  tc.open;
end;

procedure TFormQuincena.filtrar (desdeObrero, hastaObrero : integer; desdeFecha, hastaFecha : Tdatetime);
begin
  tc.Close;
  tc.SQL.Clear;
  tc.DatabaseName := 'ACampo';
  tc.SQL.Add('select count(*) SNumero, sum(q.Horas) STotalHoras, sum(q.Total) STotalBruto, sum(q.TotalPercibir) STotalPercibir, sum(q.Coche) STotalCoche');
  tc.SQL.Add('from obreroscuadrillas e, "' + ExtractFilePath(application.ExeName) + 'Quincena\quincena.db" q');
  tc.SQL.Add('where q.IDObrero = e.ID AND q.IDObrero >= :pDIDObrero AND q.IDObrero <= :pHIDObrero and');
  tc.SQL.Add('FInicio >= :pFInicio and FInicio <= :pFFin');
  tc.ParamByName('pFInicio').DataType := ftDate;
  tc.ParamByName('pFFin').DataType := ftDate;
  tc.ParamByName('pDIDObrero').DataType := ftinteger;
  tc.ParamByName('pHIDObrero').DataType := ftinteger;
  tc.ParamByName('pFInicio').value := desdefecha;
  tc.ParamByName('pFFin').value := hastafecha;
  tc.ParamByName('pDIDObrero').value := desdeobrero;
  tc.ParamByName('pHIDObrero').value := hastaobrero;
  try
    tc.Open;
  except
    txtnumero.Caption := '';
    txttotalneto.Caption := '';
    txttotalhoras.Caption := '';
  end;
  if tc.fieldbyname('SNumero').Value <= 0 then
  begin
    txtnumero.Caption := '';
    txttotalneto.Caption := '';
    txttotalhoras.Caption := '';
    messagedlg ('No hay datos del CUA34 generados para este filtro',
        mtwarning,[mbok],0);
    exit;
  end;
  TxtNumero.Caption := formatfloat('###,###,###,##0;-###,###,###,##0;0',
      tc.fieldbyname('SNumero').Value);
  txtTotalNeto.Caption := formatfloat('###,###,###,##0.00;-###,###,###,##0.00;0',
      tc.fieldbyname('STotalPercibir').Value);
  txtTotalHoras.Caption := formatfloat('###,###,###,##0.00;-###,###,###,##0.00;0',
      tc.fieldbyname('STotalHoras').Value);
  tc.Close;
  tc.SQL.Clear;
  tc.DatabaseName := 'ACampo';
  tc.SQL.Add('select e.apellido1 || " " || e.apellido2 || ", " || e.nombre Nombre, q.Horas, q.Total, ' +
      'q.TotalPercibir, q.Coche, q.FInicio, q.FFin, q.PrecioHora');
  tc.SQL.Add('from obreroscuadrillas e, "' + ExtractFilePath(application.ExeName) + 'Quincena\quincena.db" q');
  tc.SQL.Add('where q.IDObrero = e.ID AND q.IDObrero >= :pDIDObrero AND q.IDObrero <= :pHIDObrero and');
  tc.SQL.Add('FInicio >= :pFInicio and FInicio <= :pFFin');
  tc.SQL.Add('order by Nombre, q.FInicio');
  tc.ParamByName('pFInicio').DataType := ftDate;
  tc.ParamByName('pFFin').DataType := ftDate;
  tc.ParamByName('pDIDObrero').DataType := ftinteger;
  tc.ParamByName('pHIDObrero').DataType := ftinteger;
  tc.ParamByName('pFInicio').value := desdefecha;
  tc.ParamByName('pFFin').value := hastafecha;
  tc.ParamByName('pDIDObrero').value := desdeobrero;
  tc.ParamByName('pHIDObrero').value := hastaobrero;
  tc.Open;
end;

procedure TFormQuincena.DBEdit1Enter(Sender: TObject);
begin
  dbd.dataset.FieldByName('Aclareo').editmask:='!99/99/00;1;_';
end;

procedure TFormQuincena.FormShow(Sender: TObject);
begin
  filtrarInicio;
  screen.cursor:=crdefault;
end;


procedure TFormQuincena.BPrevisualizarClick(Sender: TObject);
begin
  lempresa.caption :=  ' PERODO NMINA [' + datetostr (vtfcinicio) +
        ' - ' + datetostr (vtfcfin) + ']';
  limpresion.ReportTitle:='LISTADO DE DATOS DE NMINA DE OBREROS';
  limpresion.PreviewModal;
end;

procedure TFormQuincena.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  if (dbd.dataset.state=dsinsert) or (dbd.dataset.state=dsedit) then
    dbd.DataSet.post;
  tC.close;
  screen.cursor:=crdefault;
  action:=cafree;
end;


procedure TFormQuincena.TablaKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  // para no aadir al pulsar tecla abajo ni tab en ultima fila
  // y si se pulsa si aadir
  with (Sender as TDbGrid) do
  begin
    if key = 19 then  //si se pulsa Pausa validar
      if (datasource.dataset.state = dsinsert)
          or (datasource.dataset.state = dsedit) then
        datasource.dataset.post;
  end;
end;

procedure TFormQuincena.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if (Key = #13) and Not (ActiveControl is TDBGrid) then
  begin
    Key := #0;
    Perform(WM_NEXTDLGCTL, 0, 0);
  end;
end;

procedure TFormQuincena.BFiltrarClienteClick(Sender: TObject);
begin
  if AcumularFiltro.Checked then
  begin
     filtrar(strtoint(txtobrero.text),strtoint(txtobrero.text),
         strtodate(txtdesdefecha.text), strtodate(txthastafecha.text));
  end
  else
    filtrar(strtoint(txtobrero.text),strtoint(txtobrero.text),
         VTFCInicio, VTFCFin);
end;

procedure TFormQuincena.BitBtn1Click(Sender: TObject);
begin
  if AcumularFiltro.Checked then
  begin
     filtrar(strtoint(txtobrero.text),strtoint(txtobrero.text),
         strtodate(txtdesdefecha.text), strtodate(txthastafecha.text));
  end
  else
    filtrar(0, 99999, strtodate(txtdesdefecha.text),
        strtodate(txthastafecha.text));
end;

procedure TFormQuincena.BQuitarFiltroClick(Sender: TObject);
begin
{  tdinero.open;
  tdinero.filtered:=false;
  tdinero.filter:='';
  tdinero.refresh;
  filtros.caption:=' Todos (sin filtro)';
  if mostrartotal.state=cbChecked then
    btotalclick(sender)
  else
  begin
    txtimporte.caption:='';
    txtnumero.caption:='';
  end;}
end;

procedure TFormQuincena.BSD1Click(Sender: TObject);
begin
  application.createform(tformseleccion, formseleccion);
  formseleccion.tag := 10;
  formseleccion.ShowModal;
  if claveelegida <> '' then
    Txtobrero.Text := claveelegida;
end;

procedure TFormQuincena.txtObreroChange(Sender: TObject);
var
  nombre, apellido1, apellido2 : string;
begin
  if txtObrero.Text <> '' then
  begin
    datos.TObreros.Filtered := false;
    datos.tobreros.open;
    try
      if datos.TObreros.Locate ('ID', txtObrero.Text,[]) then
      begin
        if not varisnull(datos.TObreros.fieldbyname('Nombre').Value) then
          nombre := datos.TObreros.fieldbyname('Nombre').Value
        else
          nombre := '';
        if not varisnull(datos.TObreros.fieldbyname('Apellido1').Value) then
          apellido1 := datos.TObreros.fieldbyname('Apellido1').Value
        else
          apellido1 := '';
        if not varisnull(datos.TObreros.fieldbyname('Apellido2').Value) then
          apellido2 := datos.TObreros.fieldbyname('Apellido2').Value
        else
          apellido2 := '';
        LObrero.Caption := apellido1 + ' ' + apellido2 + ', ' + nombre;
      end
      else
        lobrero.Caption := '';
    except
      lobrero.Caption := '';
    end;
  end
  else
    lobrero.Caption := '';
end;

procedure TFormQuincena.txtObreroExit(Sender: TObject);
begin
  if esNumero (txtobrero.text) < 0 then
  begin
    msinfo('Debe introducir un nmero entre 0 y 99999.',
        'Nmero incorrecto...');
    txtobrero.SelectAll;
    txtobrero.SetFocus;
  end;
end;

procedure TFormQuincena.txtObreroKeyPress(Sender: TObject; var Key: Char);
begin
  if key = '+' then
  begin
    key := chr(0);
    BSD1click(nil);
  end;
end;

procedure TFormQuincena.BitBtn2Click(Sender: TObject);
begin
  filtrarInicio;
end;

end.
