unit UnidadEnvases;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, Grids, DBGrids, ExtCtrls, DBCtrls, Db, DBTables, StdCtrls,
  Buttons, Qrctrls, QuickRpt, ToolWin, Menus, ActnList,bde, variants;

type
  TFormEnvases = class(TForm)
    TTabla: TTable;
    DDB: TDataSource;
    LImpresion: TQuickRep;
    TitleBand1: TQRBand;
    QRSubDetail2: TQRSubDetail;
    QRDBText11: TQRDBText;
    QRDBText15: TQRDBText;
    QRDBText1: TQRDBText;
    GroupHeaderBand1: TQRBand;
    QRLabel11: TQRLabel;
    QRLabel12: TQRLabel;
    QRLabel13: TQRLabel;
    PageFooterBand1: TQRBand;
    QRSysData1: TQRSysData;
    ScrollBox1: TScrollBox;
    LEmpresa: TQRLabel;
    QRSysData3: TQRSysData;
    PageHeaderBand1: TQRBand;
    LTitulo: TQRSysData;
    Panel1: TPanel;
    Panel2: TPanel;
    Navegador: TDBNavigator;
    BEliminar: TBitBtn;
    Tabla: TDBGrid;
    BNuevo: TBitBtn;
    r: TStaticText;
    CB: TControlBar;
    BB: TToolBar;
    ToolButton1: TToolButton;
    ToolButton3: TToolButton;
    ToolButton2: TToolButton;
    ToolBar2: TToolBar;
    Panel3: TPanel;
    LBuscar: TLabel;
    TxtBuscar: TEdit;
    OpOrdenarNombre: TRadioButton;
    RadioButton2: TRadioButton;
    PopupMenu1: TPopupMenu;
    Aadirnuevafinca1: TMenuItem;
    N1: TMenuItem;
    Previsualizar1: TMenuItem;
    N3: TMenuItem;
    Cerrarventana1: TMenuItem;
    ListaAcciones: TActionList;
    ActNuevo: TAction;
    ActImprimirListado: TAction;
    ActCerrar: TAction;
    ActEliminarEnvase: TAction;
    Label1: TLabel;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BCerrarClick(Sender: TObject);
    procedure TablaKeyPress(Sender: TObject; var Key: Char);
    procedure BEliminarClick(Sender: TObject);
    procedure BPrevisualizarClick(Sender: TObject);
    procedure TTablaAfterInsert(DataSet: TDataSet);
    procedure TTablaPostError(DataSet: TDataSet; E: EDatabaseError;
      var Action: TDataAction);
    procedure FormShow(Sender: TObject);
    procedure BNuevoClick(Sender: TObject);
    procedure OpOrdenarNombreClick(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure TxtBuscarChange(Sender: TObject);
    procedure TTablaAfterScroll(DataSet: TDataSet);
    procedure TTablaAfterPost(DataSet: TDataSet);
    procedure TablaKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormEnvases: TFormEnvases;

implementation

uses UnidadDatos, unidadprocedimientos;

{$R *.DFM}


procedure TFormEnvases.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if (ddb.dataset.state=dsedit) or (ddb.dataset.state=dsinsert) then
    ddb.dataset.post;
  screen.cursor:=crdefault;
  ttabla.close;
  action := cafree;
end;

procedure TFormEnvases.BCerrarClick(Sender: TObject);
begin
  close;
end;

procedure TFormEnvases.TablaKeyPress(Sender: TObject;
  var Key: Char);
begin
  if key = '.' then
    if (tabla.Columns[tabla.selectedindex].fieldname='Tara') then
      key := ',';
end;

procedure TFormEnvases.BEliminarClick(Sender: TObject);
var
  nombre:string;
begin
  if ddb.dataset.recordcount=0 then
    msinfo('No hay envases para eliminar.', 'Eliminar envase...')
  else
  begin
    datos.dfincasparte.dataset.open;
    if datos.dfincasparte.DataSet.Locate('IDEnvase',
        ddb.DataSet.fieldbyname('ID').value,[]) then
    begin
      msatencion('El envase actual no se puede eliminar ya que existe ' +
                    'en partes de trabajo.', 'Eliminar envase...');
      exit;
    end;
    datos.dvariedadesvales.dataset.open;
    if datos.dvariedadesvales.DataSet.Locate('IDEnvase',
        ddb.DataSet.fieldbyname('ID').value,[]) then
    begin
      msatencion('El envase actual no se puede eliminar ya que existe ' +
                    'en vales de fruta.','Eliminar envase...');
      exit;
    end;
    if not (ddb.dataset.fieldbyname('Envase').value = Null) then
      Nombre := ddb.dataset.fieldbyname('Envase').value
    else
      nombre:='';
    if mssi('Est seguro que desea ELIMINAR el envase [' + nombre
        + ']?', 'Eliminar envase...') then
      ddb.dataset.delete;
  end;
end;

procedure TFormEnvases.BPrevisualizarClick(Sender: TObject);
begin
  lempresa.caption :=  inttostr(vtidempresa) + ' - ' +
        vtnombreempresa + ' [' +
        datetostr (vtinicioempresa) +
        ' - ' + datetostr (vtfinempresa) + ']';
  limpresion.ReportTitle:='LISTADO DE TIPOS DE ENVASES';
  limpresion.PreviewModal;
end;

procedure TFormEnvases.TTablaAfterInsert(DataSet: TDataSet);
begin
  tabla.setfocus;
  tabla.SelectedIndex:=1;
end;


function GetBDEError(E:EDatabaseError):integer;
var
  i:integer;
begin
  if E is EDBEngineError then
  with EDBEngineError(E) do
    for i:=0 to Errorcount-1 do
    begin
      Result:=Errors[i].errorcode;
      if result<>DBIERR_USERCONSTRERR then
        if result=DBIERR_CONSTRAINTFAILED then
          databaseerror(errors[i].message)
        else if errors[i].nativeerror=0 then
          exit;
    end;
  result:=1;
end;

procedure TFormEnvases.TTablaPostError(DataSet: TDataSet;
  E: EDatabaseError; var Action: TDataAction);
begin
  case GetBDEError(e) of
     DBIERR_KEYVIOL:
       DatabaseError('Nombre de envase ya existente.');
     DBIERR_REQDERR:
       DatabaseError('Faltan datos por introducir en el envase actual (nombre).');
  end;
end;



procedure TFormEnvases.FormShow(Sender: TObject);
begin
  opordenarnombreclick(sender);
  ttabla.open;
  r.caption := inttostr(ddb.dataset.recno) + '/' +
      inttostr(ddb.DataSet.recordcount);
  screen.cursor := crdefault;
end;

procedure TFormEnvases.BNuevoClick(Sender: TObject);
begin
  ddb.DataSet.insert;
end;

procedure TFormEnvases.OpOrdenarNombreClick(Sender: TObject);
begin
  ttabla.indexfieldnames := 'Envase';
  lbuscar.caption := 'Nombre a &buscar:';
end;

procedure TFormEnvases.RadioButton2Click(Sender: TObject);
begin
  ttabla.indexfieldnames := 'ID';
  lbuscar.caption := 'ID a &buscar:';
end;

procedure TFormEnvases.TxtBuscarChange(Sender: TObject);
begin
  try
    ttabla.findnearest([txtbuscar.text])
  except
    raise;  
  end;
end;

procedure TFormEnvases.TTablaAfterScroll(DataSet: TDataSet);
begin
  r.caption := inttostr(ddb.dataset.recno) + '/'
      + inttostr(ddb.DataSet.recordcount);
end;

procedure TFormEnvases.TTablaAfterPost(DataSet: TDataSet);
begin
  ttabla.flushbuffers;
end;

procedure TFormEnvases.TablaKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  // para no aadir al pulsar tecla abajo ni tab en ultima fila
  // y si se pulsa si aadir
  with (Sender as TDbGrid) do
  begin
    if key = 19 then  //si se pulsa Pausa validar
      if (datasource.dataset.state = dsinsert)
          or (datasource.dataset.state = dsedit) then
        datasource.dataset.post;
  end;
end;

end.
