unit UnidadExportarDatos;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, ExtCtrls, dxDBTLCl, dxGrClms, dxTL,
  dxDBCtrl, dxDBGrid, dxCntner, Buttons, DB, DBTables, dxExEdtr;

type
  TformExportar = class(TForm)
    tab: TPageControl;
    TabPartesTrabajo: TTabSheet;
    TabNuevaInversion: TTabSheet;
    Panel2: TPanel;
    Label1: TLabel;
    TablaParte: TdxDBGrid;
    TablaParteID: TdxDBGridMaskColumn;
    TablaParteFecha: TdxDBGridDateColumn;
    TablaParteIDTrabajo: TdxDBGridMaskColumn;
    TablaParteIDCuadrilla: TdxDBGridMaskColumn;
    TablaParteTotalObreros: TdxDBGridSpinColumn;
    TablaParteHorasObrero: TdxDBGridSpinColumn;
    TablaPartePrecioHora: TdxDBGridCurrencyColumn;
    TablaParteTotalCoche: TdxDBGridCurrencyColumn;
    TablaParteTotalHoras: TdxDBGridSpinColumn;
    TablaParteImporteTotal: TdxDBGridCurrencyColumn;
    TablaParteNota: TdxDBGridMaskColumn;
    DParte: TDataSource;
    TCParte: TQuery;
    TCParteID: TIntegerField;
    TCParteIDCuadrilla: TIntegerField;
    TCParteHorasObrero: TFloatField;
    TCParteTotalHoras: TFloatField;
    TCPartePrecioHora: TCurrencyField;
    TCParteTotalCoche: TCurrencyField;
    TCParteTotalObreros: TFloatField;
    TCParteImporteTotal: TCurrencyField;
    TCParteFecha: TDateField;
    TCParteNota: TStringField;
    TCParteIDTrabajo: TIntegerField;
    TCParteCuadrilla: TStringField;
    TCParteTrabajo: TStringField;
    TablaParteCuadrilla: TdxDBGridMaskColumn;
    TablaParteTrabajo: TdxDBGridMaskColumn;
    TC: TQuery;
    DTC: TDataSource;
    DI: TDataSource;
    TI: TTable;
    Panel3: TPanel;
    Label2: TLabel;
    TablaNuevaInversion: TdxDBGrid;
    DNuevaInversion: TDataSource;
    TCNuevaInversion: TQuery;
    TCNuevaInversionID: TIntegerField;
    TCNuevaInversionFecha: TDateField;
    TCNuevaInversionIDTercero: TIntegerField;
    TCNuevaInversionIDTipoGasto: TIntegerField;
    TCNuevaInversionImporte: TCurrencyField;
    TCNuevaInversionNota: TMemoField;
    TCNuevaInversionFinalizado: TStringField;
    TCNuevaInversionTercero: TStringField;
    TCNuevaInversionGasto: TStringField;
    TablaNuevaInversionID: TdxDBGridMaskColumn;
    TablaNuevaInversionFecha: TdxDBGridDateColumn;
    TablaNuevaInversionIDTercero: TdxDBGridMaskColumn;
    TablaNuevaInversionImporte: TdxDBGridCurrencyColumn;
    TablaNuevaInversionIDTipoGasto: TdxDBGridMaskColumn;
    TablaNuevaInversionNota: TdxDBGridMemoColumn;
    TablaNuevaInversionFinalizado: TdxDBGridMaskColumn;
    TablaNuevaInversionTercero: TdxDBGridMaskColumn;
    TablaNuevaInversionGasto: TdxDBGridMaskColumn;
    Panel1: TPanel;
    GExportar: TGroupBox;
    OpEmpresa: TRadioButton;
    opAccess: TRadioButton;
    BExportar: TBitBtn;
    BCerrar: TBitBtn;
    opEliminar: TCheckBox;
    tabStock: TTabSheet;
    Memo1: TMemo;
    TabPagosCobros: TTabSheet;
    Memo2: TMemo;
    TabAlbaranesProductos: TTabSheet;
    TablaAlbaranesProductos: TdxDBGrid;
    TCAlbaranesProductos: TQuery;
    DAlbaranesProductos: TDataSource;
    TCAlbaranesProductosID: TIntegerField;
    TCAlbaranesProductosNumero: TStringField;
    TCAlbaranesProductosFecha: TDateField;
    TCAlbaranesProductosIDTercero: TIntegerField;
    TCAlbaranesProductosNota: TStringField;
    TCAlbaranesProductosFacturado: TStringField;
    TCAlbaranesProductosTercero: TStringField;
    TablaAlbaranesProductosID: TdxDBGridMaskColumn;
    TablaAlbaranesProductosNumero: TdxDBGridMaskColumn;
    TablaAlbaranesProductosFecha: TdxDBGridDateColumn;
    TablaAlbaranesProductosIDTercero: TdxDBGridMaskColumn;
    TablaAlbaranesProductosNota: TdxDBGridMaskColumn;
    TablaAlbaranesProductosFacturado: TdxDBGridMaskColumn;
    TablaAlbaranesProductosTercero: TdxDBGridMaskColumn;
    procedure BCerrarClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BExportarClick(Sender: TObject);
    procedure tabChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formExportar: TformExportar;


implementation

uses UnidadSeleccionEmpresaImportar, UnidadProcedimientos,
  UnidadMenuPrincipal, UnidadI, UnidadDatos;

{$R *.dfm}

procedure TformExportar.BCerrarClick(Sender: TObject);
begin
  close;
end;

procedure TformExportar.FormShow(Sender: TObject);
begin
  try
    TCParte.Open;
    TCNuevaInversion.Open;
    TCAlbaranesProductos.Open;    
  except
    raise
  end;
end;

procedure TformExportar.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  TCParte.Close;
  action := cafree;
end;

procedure TformExportar.BExportarClick(Sender: TObject);
var
  i, idParteN, numPartes : integer;
  textoNota : String;
begin
  if tab.ActivePage = TabPartesTrabajo then  //Exportar partes de trabajo
  begin
    if opAccess.Checked then
    begin
      ShowMessage('Opcin an no disponible.');
    end;
    if OpEmpresa.Checked then
    begin
      application.createform(TFormImportarEmpresa, FormImportarEmpresa);
      FormImportarEmpresa.LInfo.Tag := 20;
      formimportarempresa.tag := vtidempresa;
      formImportarEmpresa.ShowModal;
      if FormMenuPrincipal.filtro <> '' then  //Si se ha seleccionado alguna empresa
      begin
        numPartes := TablaParte.SelectedCount;
        if numPartes = 0 then
          MessageDlg ('Debe seleccionar, al menos, un parte de trabajo.',
               mtinformation,[mbok],0)
        else
        begin
          if MessageDlg('Se van a exportar ' + inttostr(numPartes) +
              ' partes de trabajo de la empresa ' +
              VTNombreEmpresa + ' a la empresa ' +
              FormMenuPrincipal.nombreEmpresaImportar + '. Desea realizar esta operacin?',
              mtConfirmation, [mbyes,mbno],0) = mryes then
          begin
            screen.cursor := crhourglass;
            tc.Close;
            ti.Close;
            TI.DatabaseName := formmenuprincipal.filtro; //Ruta empresa a copiar
            TC.DatabaseName := VTRutaEmpresa; //Ruta Empresa actual
            formi.B.min := 0;
            formi.B.visible := true;
            formi.L.Caption := 'Exportando datos, espere por favor...';
            formi.b.max := numPartes;
            formi.b.Position := 0;
            formi.show;
            formi.Refresh;
            datos.TPartes.Filtered := false;
            datos.TPartes.Open;
            datos.TFincasParte.Filtered := false;
            datos.TFincasParte.Open;
            datos.TMaquinariaPartes.Filtered := false;
            datos.TMaquinariaPartes.Open;
            datos.TEmpleadosPartes.Filtered := false;
            datos.TEmpleadosPartes.Open;
            for i := 0 to numPartes - 1 do
            begin
              FormI.B.Position := i;
              formi.B.Refresh;
              TCParte.Bookmark := TablaParte.SelectedRows[i];
              //Aadimos el parte de trabajo
              ti.close;
              TI.TableName := 'Parte';
              TI.Open;
              TI.Insert;
              if not varisnull(TCParte.fieldbyname('Fecha').value) then
                TI.fieldbyname('Fecha').value := TCParte.fieldbyname('Fecha').value;
              if not varisnull(TCParte.fieldbyname('IDCuadrilla').value) then
                TI.fieldbyname('IDCuadrilla').value := TCParte.fieldbyname('IDCuadrilla').value;
              if not varisnull(TCParte.fieldbyname('HorasObrero').value) then
                TI.fieldbyname('HorasObrero').value := TCParte.fieldbyname('HorasObrero').value;
              if not varisnull(TCParte.fieldbyname('TotalHoras').value) then
                TI.fieldbyname('TotalHoras').value := TCParte.fieldbyname('TotalHoras').value;
              if not varisnull(TCParte.fieldbyname('PrecioHora').value) then
                TI.fieldbyname('PrecioHora').value := TCParte.fieldbyname('PrecioHora').value;
              if not varisnull(TCParte.fieldbyname('TotalCoche').value) then
                TI.fieldbyname('TotalCoche').value := TCParte.fieldbyname('TotalCoche').value;
              if not varisnull(TCParte.fieldbyname('ImporteTotal').value) then
                TI.fieldbyname('ImporteTotal').value := TCParte.fieldbyname('ImporteTotal').value;
              if not varisnull(TCParte.fieldbyname('Nota').value) then
                textoNota := 'Imp[' + VTNombreEmpresa + '] ' +
                    TCParte.fieldbyname('Nota').value
              else
                textoNota := 'Imp[' + VTNombreEmpresa + '] ';
              TI.fieldbyname('Nota').value := textoNota;
              if not varisnull(TCParte.fieldbyname('IDTrabajo').value) then
                TI.fieldbyname('IDTrabajo').value := TCParte.fieldbyname('IDTrabajo').value;
              if not varisnull(TCParte.fieldbyname('TotalObreros').value) then
                TI.fieldbyname('TotalObreros').value := TCParte.fieldbyname('TotalObreros').value;
              try
                TI.Post;
              except
                FormI.Close;
                Screen.Cursor := crDefault;
                raise;
              end;
              //Eliminamos parte si est chequeada la opcin
              if opEliminar.Checked then
                if Datos.TPartes.Locate('ID',TCParte.fieldbyname('ID').Value,[]) then
                  Datos.TPartes.Delete;
              IDParteN := TI.fieldbyname('ID').value;
              //AADIMOS LOS EMPLEADOS DEL PARTE ACTUAL
              ti.Close;
              ti.TableName := 'EmpleadosParte';
              ti.Open;
              //Filtramos los empleados del parte actual
              tc.Close;
              tc.SQL.Clear;
              tc.SQL.Add('Select * from EmpleadosParte where IDParte = :pIDParte');
              tc.ParamByName('pIDParte').DataType := ftInteger;
              tc.ParamByName('pIDParte').Value := TCParte.fieldbyname('ID').Value;
              tc.Open;
              while not tc.Eof do
              begin
                ti.Insert;
                ti.FieldByName('IDParte').Value := idParteN;
                if not varisnull(tc.FieldByName('IDObrero').Value) then
                  ti.FieldByName('IDObrero').Value := tc.FieldByName('IDObrero').Value;
                if not varisnull(tc.FieldByName('IDCuadrilla').Value) then
                  ti.FieldByName('IDCuadrilla').Value := tc.FieldByName('IDCuadrilla').Value;
                if not varisnull(tc.FieldByName('Horas').Value) then
                  ti.FieldByName('Horas').Value := tc.FieldByName('Horas').Value;
                if not varisnull(tc.FieldByName('PrecioHora').Value) then
                  ti.FieldByName('PrecioHora').Value := tc.FieldByName('PrecioHora').Value;
                if not varisnull(tc.FieldByName('Coche').Value) then
                  ti.FieldByName('Coche').Value := tc.FieldByName('Coche').Value;
                if not varisnull(tc.FieldByName('Importe').Value) then
                  ti.FieldByName('Importe').Value := tc.FieldByName('Importe').Value;
                if not varisnull(tc.FieldByName('Nota').Value) then
                  ti.FieldByName('Nota').Value := tc.FieldByName('Nota').Value;
                try
                  ti.Post;
                except
                  FormI.Close;
                  Screen.Cursor := crDefault;
                  raise;
                end;
                //eliminamos el obrero si la opcin est chequeada
                if opEliminar.Checked then
                  if Datos.TEmpleadosPartes.Locate('ID',TC.fieldbyname('ID').Value,[]) then
                    Datos.TEmpleadosPartes.Delete;
                tc.Next;
              end;
              //AADIMOS LAS FINCAS DEL PARTE ACTUAL
              ti.Close;
              ti.TableName := 'FincasParte';
              ti.Open;
              //Filtramos las fincas del parte actual
              tc.Close;
              tc.SQL.Clear;
              tc.SQL.Add('Select * from FincasParte where IDParte = :pIDParte');
              tc.ParamByName('pIDParte').DataType := ftInteger;
              tc.ParamByName('pIDParte').Value := TCParte.fieldbyname('ID').Value;
              tc.Open;
              while not tc.Eof do
              begin
                ti.Insert;
                ti.FieldByName('IDParte').Value := idParteN;
                if not varisnull(tc.FieldByName('IDFinca').Value) then
                  ti.FieldByName('IDFinca').Value := tc.FieldByName('IDFinca').Value;
                if not varisnull(tc.FieldByName('IDSector').Value) then
                  ti.FieldByName('IDSector').Value := tc.FieldByName('IDSector').Value;
                if not varisnull(tc.FieldByName('IDVariedad').Value) then
                  ti.FieldByName('IDVariedad').Value := tc.FieldByName('IDVariedad').Value;
                if not varisnull(tc.FieldByName('IDVariedadVariedades').Value) then
                  ti.FieldByName('IDVariedadVariedades').Value := tc.FieldByName('IDVariedadVariedades').Value;
                if not varisnull(tc.FieldByName('Bultos').Value) then
                  ti.FieldByName('Bultos').Value := tc.FieldByName('Bultos').Value;
                if not varisnull(tc.FieldByName('Porcentaje').Value) then
                  ti.FieldByName('Porcentaje').Value := tc.FieldByName('Porcentaje').Value;
                if not varisnull(tc.FieldByName('IDEnvase').Value) then
                  ti.FieldByName('IDEnvase').Value := tc.FieldByName('IDEnvase').Value;
                try
                  ti.Post;
                except
                  FormI.Close;
                  Screen.Cursor := crDefault;
                  raise;
                end;
                //eliminamos la finca si la opcin est chequeada
                if opEliminar.Checked then
                  if Datos.TFincasParte.Locate('ID',TC.fieldbyname('ID').Value,[]) then
                    Datos.TFincasParte.Delete;
                tc.Next;
              end;
              //AADIMOS LAS HORAS MAQUINARIA DEL PARTE ACTUAL
              ti.Close;
              ti.TableName := 'HorasMaquinaria';
              ti.Open;
              //Filtramos las horasmaquinaria del parte actual
              tc.Close;
              tc.SQL.Clear;
              tc.SQL.Add('Select * from HorasMaquinaria where IDParte = :pIDParte');
              tc.ParamByName('pIDParte').DataType := ftInteger;
              tc.ParamByName('pIDParte').Value := TCParte.fieldbyname('ID').Value;
              tc.Open;
              while not tc.Eof do
              begin
                ti.Insert;
                ti.FieldByName('IDParte').Value := idParteN;
                if not varisnull(tc.FieldByName('IDMaquinaria').Value) then
                  ti.FieldByName('IDMaquinaria').Value := tc.FieldByName('IDMaquinaria').Value;
                if not varisnull(tc.FieldByName('Horas').Value) then
                  ti.FieldByName('Horas').Value := tc.FieldByName('Horas').Value;
                if not varisnull(tc.FieldByName('Terreno').Value) then
                  ti.FieldByName('Terreno').Value := tc.FieldByName('Terreno').Value;
                if not varisnull(tc.FieldByName('Nota').Value) then
                  ti.FieldByName('Nota').Value := tc.FieldByName('Nota').Value;
                try
                  ti.Post;
                except
                  FormI.Close;
                  Screen.Cursor := crDefault;
                  raise;
                end;
                //eliminamos la maquinaria si la opcin est chequeada
                if opEliminar.Checked then
                  if Datos.TMaquinariaPartes.Locate('ID',TC.fieldbyname('ID').Value,[]) then
                    Datos.TMaquinariaPartes.Delete;
                tc.Next;
              end;
            end;
            FormI.Close;
            Screen.Cursor := crDefault;
            MessageDlg('El proceso de exportacin ha finalizado correctamente.',
                mtInformation,[mbok],0);
          end;
          Close;
        end;
      end;
    end;
  end;

  if tab.ActivePage = TabNuevaInversion then  //Exportar nueva inversin
  begin
    if opAccess.Checked then
    begin
      ShowMessage('Opcin an no disponible.');
    end;
    if OpEmpresa.Checked then
    begin
      application.createform(TFormImportarEmpresa, FormImportarEmpresa);
      FormImportarEmpresa.LInfo.Tag := 20;
      formimportarempresa.tag := vtidempresa;
      formImportarEmpresa.ShowModal;
      if FormMenuPrincipal.filtro <> '' then  //Si se ha seleccionado alguna empresa
      begin
        numPartes := TablaNuevaInversion.SelectedCount;
        if numPartes = 0 then
          MessageDlg ('Debe seleccionar, al menos, un gasto de nueva inversin.',
              mtinformation,[mbok],0)
        else
        begin
          if MessageDlg('Se van a exportar ' + inttostr(numPartes) +
              ' gastos de nueva inversin de la empresa ' +
              VTNombreEmpresa + ' a la empresa ' +
              FormMenuPrincipal.nombreEmpresaImportar +
              '. Desea realizar esta operacin?',
              mtConfirmation, [mbyes,mbno],0) = mryes then
          begin
            screen.cursor := crhourglass;
            tc.Close;
            ti.Close;
            TI.DatabaseName := formmenuprincipal.filtro; //Ruta empresa a copiar
            TC.DatabaseName := VTRutaEmpresa; //Ruta Empresa actual
            formi.B.min := 0;
            formi.B.visible := true;
            formi.L.Caption := 'Exportando datos, espere por favor...';
            formi.b.max := numPartes;
            formi.b.Position := 0;
            formi.show;
            formi.Refresh;
            datos.TNuevaInversion.Filtered := false;
            Datos.TNuevaInversion.Open;
            datos.TFincasNuevaInversion.Filtered := false;
            Datos.TFincasNuevaInversion.Open;
            for i := 0 to numPartes - 1 do
            begin
              FormI.B.Position := i;
              formi.B.Refresh;
              TCNuevaInversion.Bookmark := TablaNuevaInversion.SelectedRows[i];
              //Aadimos el gasto de nueva inversion
              ti.close;
              TI.TableName := 'NuevaInversion';
              TI.Open;
              TI.Insert;
              if not varisnull(TCNuevaInversion.fieldbyname('Fecha').value) then
                TI.fieldbyname('Fecha').value := TCNuevaInversion.fieldbyname('Fecha').value;
              if not varisnull(TCNuevaInversion.fieldbyname('IDTercero').value) then
                TI.fieldbyname('IDTercero').value := TCNuevaInversion.fieldbyname('IDTercero').value;
              if not varisnull(TCNuevaInversion.fieldbyname('Importe').value) then
                TI.fieldbyname('Importe').value := TCNuevaInversion.fieldbyname('Importe').value;
              if not varisnull(TCNuevaInversion.fieldbyname('Nota').value) then
                textoNota := 'Imp[' + VTNombreEmpresa + '] ' +
                    TCNuevaInversion.fieldbyname('Nota').value
              else
                textoNota := 'Imp[' + VTNombreEmpresa + '] ';
              TI.fieldbyname('Nota').value := textoNota;
              if not varisnull(TCNuevaInversion.fieldbyname('IDTipoGasto').value) then
                TI.fieldbyname('IDTipoGasto').value := TCNuevaInversion.fieldbyname('IDTipoGasto').value;
              if not varisnull(TCNuevaInversion.fieldbyname('Finalizado').value) then
                TI.fieldbyname('Finalizado').value := TCNuevaInversion.fieldbyname('Finalizado').value;
              try
                TI.Post;
              except
                FormI.Close;
                Screen.Cursor := crDefault;
                raise;
              end;
              //Eliminamos nueva inversin si est chequeada la opcin
              if opEliminar.Checked then
                if Datos.TNuevaInversion.Locate('ID',TCNuevaInversion.fieldbyname('ID').Value,[]) then
                  Datos.TNuevaInversion.Delete;
              IDParteN := TI.fieldbyname('ID').value;
              //AADIMOS LAS FINCAS DEL GASTO ACTUAL
              ti.Close;
              ti.TableName := 'NuevaInversionFincas';
              ti.Open;
              //Filtramos las fincas del gasto actual
              tc.Close;
              tc.SQL.Clear;
              tc.SQL.Add('Select * from NuevaInversionFincas where IDNuevaInversion = :pIDParte');
              tc.ParamByName('pIDParte').DataType := ftInteger;
              tc.ParamByName('pIDParte').Value := TCNuevaInversion.fieldbyname('ID').Value;
              tc.Open;
              while not tc.Eof do
              begin
                ti.Insert;
                ti.FieldByName('IDNuevaInversion').Value := idParteN;
                if not varisnull(tc.FieldByName('IDFinca').Value) then
                  ti.FieldByName('IDFinca').Value := tc.FieldByName('IDFinca').Value;
                if not varisnull(tc.FieldByName('IDSector').Value) then
                  ti.FieldByName('IDSector').Value := tc.FieldByName('IDSector').Value;
                if not varisnull(tc.FieldByName('IDVariedad').Value) then
                  ti.FieldByName('IDVariedad').Value := tc.FieldByName('IDVariedad').Value;
                if not varisnull(tc.FieldByName('IDVariedadVariedad').Value) then
                  ti.FieldByName('IDVariedadVariedad').Value := tc.FieldByName('IDVariedadVariedad').Value;
                if not varisnull(tc.FieldByName('Porcentaje').Value) then
                  ti.FieldByName('Porcentaje').Value := tc.FieldByName('Porcentaje').Value;
                if not varisnull(tc.FieldByName('Nota').Value) then
                  ti.FieldByName('Nota').Value := tc.FieldByName('Nota').Value;
                try
                  ti.Post;
                except
                  FormI.Close;
                  Screen.Cursor := crDefault;
                  raise;
                end;
                //Eliminamos fincas nueva inversin si est chequeada la opcin
                if opEliminar.Checked then
                  if Datos.TFincasNuevaInversion.Locate('ID',TC.fieldbyname('ID').Value,[]) then
                    Datos.TFincasNuevaInversion.Delete;
                tc.Next;
              end;
            end;
            FormI.Close;
            Screen.Cursor := crDefault;
            MessageDlg('El proceso de exportacin ha finalizado correctamente.',
                mtInformation,[mbok],0);
          end;
          Close;
        end;
      end;
    end;
  end;


  if tab.ActivePage = tabStock then  //Exportar stock de productos
  begin
    application.createform(TFormImportarEmpresa, FormImportarEmpresa);
    FormImportarEmpresa.LInfo.Tag := 20;
    formimportarempresa.tag := vtidempresa;
    formImportarEmpresa.ShowModal;
    if FormMenuPrincipal.filtro <> '' then  //Si se ha seleccionado alguna empresa
    begin
      if MessageDlg('Se va a exportar el Stock de productos fitosanitarios ' +
          'y nutricionales de la empresa ' + VTNombreEmpresa + ' a la empresa ' +
            FormMenuPrincipal.nombreEmpresaImportar +
            '. Realice esta opcin slo si ya ha actualizado el Stock ' +
            'de productos en la empresa origen y, adems, no va a ' +
            'introducir ms Partes de tratamientos ni ms Partes de agua ' +
            'de riego ni ms Facturas de productos en la empresa origen ' +
            ' Desea realizar esta operacin?',
            mtConfirmation, [mbyes,mbno],0) = mryes then
      begin
        screen.cursor := crhourglass;
        tc.Close;
        ti.Close;
        TI.DatabaseName := formmenuprincipal.filtro; //Ruta empresa a copiar
        TC.DatabaseName := formmenuprincipal.filtro; //Ruta empresa a copiar
        datos.TProductos.Filtered := false;
        Datos.TProductos.Open;
        TI.TableName := 'ProductosStock';
        TI.Open;
        Tc.sql.Clear;
        tc.SQL.Add('Select ID From Producto');
        Tc.Open;
        numPartes := datos.TProductos.RecordCount;
        formi.B.min := 0;
        formi.B.visible := true;
        formi.L.Caption := 'Exportando datos, espere por favor...';
        formi.b.max := numPartes;
        formi.b.Position := 0;
        formi.show;
        formi.Refresh;
        datos.TProductos.First;
        while not datos.TProductos.Eof do
        begin
          FormI.B.Position := datos.tproductos.RecNo;
          formi.B.Refresh;
          //Aadimos el stock del producto a Stock manual de la nueva empresa
          if tc.Locate('ID', datos.TProductos.fieldbyname('ID').Value,[]) then
          begin
            TI.Insert;
            if not varisnull(datos.tproductos.fieldbyname('Stock').Value) then
              ti.FieldByName('Cantidad').Value :=
                  datos.TProductos.fieldbyname('Stock').Value;
            ti.FieldByName('IDProducto').Value :=
                datos.TProductos.fieldbyname('ID').Value;
            ti.FieldByName('Fecha').Value := date;
            ti.FieldByName('Nota').Value := 'Importado de ' + VTNombreEmpresa;
            try
              TI.Post;
            except
              FormI.Close;
              Screen.Cursor := crDefault;
              raise;
            end;
          end;
          Datos.TProductos.Next;
        end;
        FormI.Close;
        Screen.Cursor := crDefault;
        MessageDlg('El proceso de exportacin ha finalizado correctamente.',
            mtInformation,[mbok],0);
      end;
      Close;
    end;
  end;

  if tab.ActivePage = TabAlbaranesProductos then  //Exportar albaranes de productos fitosanitarios
  begin
    if opAccess.Checked then
    begin
      ShowMessage('Opcin an no disponible.');
    end;
    if OpEmpresa.Checked then
    begin
      application.createform(TFormImportarEmpresa, FormImportarEmpresa);
      FormImportarEmpresa.LInfo.Tag := 20;
      formimportarempresa.tag := vtidempresa;
      formImportarEmpresa.ShowModal;
      if FormMenuPrincipal.filtro <> '' then  //Si se ha seleccionado alguna empresa
      begin
        numPartes := TablaAlbaranesProductos.SelectedCount;
        if numPartes = 0 then
          MessageDlg ('Debe seleccionar, al menos, un albarn de productos fitosanitarios.',
              mtinformation,[mbok],0)
        else
        begin
          if MessageDlg('Se van a exportar ' + inttostr(numPartes) +
              ' albaranes de productos fitosanitarios de la empresa ' +
              VTNombreEmpresa + ' a la empresa ' +
              FormMenuPrincipal.nombreEmpresaImportar +
              '. Desea realizar esta operacin?',
              mtConfirmation, [mbyes,mbno],0) = mryes then
          begin
            screen.cursor := crhourglass;
            tc.Close;
            ti.Close;
            TI.DatabaseName := formmenuprincipal.filtro; //Ruta empresa a copiar
            TC.DatabaseName := VTRutaEmpresa; //Ruta Empresa actual
            formi.B.min := 0;
            formi.B.visible := true;
            formi.L.Caption := 'Exportando datos, espere por favor...';
            formi.b.max := numPartes;
            formi.b.Position := 0;
            formi.show;
            formi.Refresh;
            datos.TAlbaranes.Filtered := false;
            Datos.TAlbaranes.Open;
            datos.TAlbaranesProductos.Filtered := false;
            Datos.TAlbaranesProductos.Open;
            for i := 0 to numPartes - 1 do
            begin
              FormI.B.Position := i;
              formi.B.Refresh;
              TCAlbaranesProductos.Bookmark := TablaAlbaranesProductos.SelectedRows[i];
              //Aadimos el albarn
              ti.close;
              TI.TableName := 'AlbaranesProductos';
              TI.Open;
              TI.Insert;
              if not varisnull(TCAlbaranesProductos.fieldbyname('Numero').value) then
                TI.fieldbyname('Numero').value := TCAlbaranesProductos.fieldbyname('Numero').value;
              if not varisnull(TCAlbaranesProductos.fieldbyname('Fecha').value) then
                TI.fieldbyname('Fecha').value := TCAlbaranesProductos.fieldbyname('Fecha').value;
              if not varisnull(TCAlbaranesProductos.fieldbyname('IDTercero').value) then
                TI.fieldbyname('IDTercero').value := TCAlbaranesProductos.fieldbyname('IDTercero').value;
              if not varisnull(TCAlbaranesProductos.fieldbyname('Nota').value) then
                textoNota := 'Imp[' + VTNombreEmpresa + '] ' +
                    TCAlbaranesProductos.fieldbyname('Nota').value
              else
                textoNota := 'Imp[' + VTNombreEmpresa + '] ';
              TI.fieldbyname('Nota').value := textoNota;
              if not varisnull(TCAlbaranesProductos.fieldbyname('Facturado').value) then
                TI.fieldbyname('Facturado').value := TCAlbaranesProductos.fieldbyname('Facturado').value;
              try
                TI.Post;
              except
                FormI.Close;
                Screen.Cursor := crDefault;
                raise;
              end;
              //Eliminamos albarn si est chequeada la opcin
              if opEliminar.Checked then
                if Datos.TAlbaranes.Locate('ID',TCAlbaranesProductos.fieldbyname('ID').Value,[]) then
                  Datos.TAlbaranes.Delete;
              IDParteN := TI.fieldbyname('ID').value;
              //AADIMOS LOS PRODUCTOS DEL ALBARN
              ti.Close;
              ti.TableName := 'AlbaranesProductosDe';
              ti.Open;
              //Filtramos los productos del albarn actual
              tc.Close;
              tc.SQL.Clear;
              tc.SQL.Add('Select * from AlbaranesProductosDe where IDFactura = :pIDParte');
              tc.ParamByName('pIDParte').DataType := ftInteger;
              tc.ParamByName('pIDParte').Value := TCAlbaranesProductos.fieldbyname('ID').Value;
              tc.Open;
              while not tc.Eof do
              begin
                ti.Insert;
                ti.FieldByName('IDFactura').Value := idParteN;
                if not varisnull(tc.FieldByName('IDProducto').Value) then
                  ti.FieldByName('IDProducto').Value := tc.FieldByName('IDProducto').Value;
                if not varisnull(tc.FieldByName('UnidadDosis').Value) then
                  ti.FieldByName('UnidadDosis').Value := tc.FieldByName('UnidadDosis').Value;
                if not varisnull(tc.FieldByName('Cantidad').Value) then
                  ti.FieldByName('Cantidad').Value := tc.FieldByName('Cantidad').Value;
                if not varisnull(tc.FieldByName('Precio').Value) then
                  ti.FieldByName('Precio').Value := tc.FieldByName('Precio').Value;
                if not varisnull(tc.FieldByName('Importe').Value) then
                  ti.FieldByName('Importe').Value := tc.FieldByName('Importe').Value;
                if not varisnull(tc.FieldByName('Nota').Value) then
                  ti.FieldByName('Nota').Value := tc.FieldByName('Nota').Value;
                try
                  ti.Post;
                except
                  FormI.Close;
                  Screen.Cursor := crDefault;
                  raise;
                end;
                //Eliminamos los productos si est chequeada la opcin
                if opEliminar.Checked then
                  if Datos.TAlbaranesProductos.Locate('ID',TC.fieldbyname('ID').Value,[]) then
                    Datos.TAlbaranesProductos.Delete;
                tc.Next;
              end;
            end;
            FormI.Close;
            Screen.Cursor := crDefault;
            MessageDlg('El proceso de exportacin ha finalizado correctamente.',
                mtInformation,[mbok],0);
          end;
          Close;
        end;
      end;
    end;
  end;
end;

procedure TformExportar.tabChange(Sender: TObject);
begin
  if tabStock.Showing then
  begin
    GExportar.Visible := false;
    opEliminar.Visible := false;
    BExportar.Visible := true;
  end;
  if TabPagosCobros.Showing then
  begin
    GExportar.Visible := false;
    opEliminar.Visible := false;
    BExportar.Visible := false;
  end;
  if TabPartesTrabajo.Showing then
  begin
    GExportar.Visible := true;
    opEliminar.Visible := true;
    BExportar.Visible := true;
  end;
  if TabNuevaInversion.Showing then
  begin
    GExportar.Visible := true;
    opEliminar.Visible := true;
    BExportar.Visible := true;    
  end;
  if TabAlbaranesProductos.Showing then
  begin
    GExportar.Visible := true;
    opEliminar.Visible := true;
    BExportar.Visible := true;
  end;
end;

end.
