unit UnidadFormMtoFacturasProductos;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DBCtrls, StdCtrls, Mask, ExtCtrls, Db, DBTables, Buttons, Grids, DBGrids;

type
  TFormMtoFacturas = class(TForm)
    PanelDatos: TPanel;
    Label1: TLabel;
    TxtNumero: TDBEdit;
    Label2: TLabel;
    TxtFecha: TDBEdit;
    Label4: TLabel;
    TxtImporte: TDBEdit;
    Label3: TLabel;
    Label5: TLabel;
    TxtConformada: TDBEdit;
    Button1: TButton;
    BitBtn2: TBitBtn;
    BitBtn1: TBitBtn;
    DProducto: TDataSource;
    TProducto: TTable;
    TProductoID: TAutoIncField;
    TProductoNombre: TStringField;
    TProductoUnidadDosis: TStringField;
    TProductoStock: TFloatField;
    TProductoIDCasa: TIntegerField;
    TProductoPrecio: TCurrencyField;
    TProductoNota: TStringField;
    TProductoPrecioSinIVA: TCurrencyField;
    TProductoTIpo: TStringField;
    TProductoUnidad: TStringField;
    TProductoDosis: TFloatField;
    DCasas: TDataSource;
    TCasas: TTable;
    DProductos: TDataSource;
    TProductos: TTable;
    TProductosID: TIntegerField;
    TProductosIDProducto: TIntegerField;
    TProductosUnidadDosis: TStringField;
    TProductosCantidad: TFloatField;
    TProductosPrecio: TCurrencyField;
    TProductosImporte: TCurrencyField;
    TProductosNota: TStringField;
    TProductosLProducto: TStringField;
    TProductosIDFactura: TIntegerField;
    TProductosStock: TBooleanField;
    DFacturas: TDataSource;
    TFacturas: TTable;
    TFacturasID: TAutoIncField;
    TFacturasNumero: TStringField;
    TFacturasFecha: TDateField;
    TFacturasIDTercero: TIntegerField;
    TFacturasImporte: TCurrencyField;
    TFacturasNota: TStringField;
    TFacturasLTercero: TStringField;
    TFacturasConformada: TStringField;
    TxtTercero: TDBLookupComboBox;
    BNuevoProducto: TBitBtn;
    BEliminarProducto: TBitBtn;
    BitBtn3: TBitBtn;
    BCalcularParte: TBitBtn;
    TablaProductos: TDBGrid;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure TFacturasAfterEdit(DataSet: TDataSet);
    procedure TFacturasAfterInsert(DataSet: TDataSet);
    procedure TProductosAfterEdit(
  DataSet: TDataSet);
    procedure TProductosAfterInsert(
  DataSet: TDataSet);
    procedure TProductosAfterPost(
  DataSet: TDataSet);
    procedure TProductosBeforeDelete(DataSet: TDataSet);
    procedure TProductosBeforeInsert(DataSet: TDataSet);
    procedure ActAlbaranesExecute(Sender: TObject);
    procedure BCalcularParteClick(Sender: TObject);
    procedure BEliminarProductoClick(
  Sender: TObject);
    procedure BNuevoProductoClick(Sender: TObject);
    procedure TablaProductosColExit(
  Sender: TObject);
    procedure TablaProductosKeyPress(
  Sender: TObject; var Key: Char);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormMtoFacturas: TFormMtoFacturas;

implementation

uses UnidadMenuPrincipal, MFacturasProductos, UnidadSeleccionAlbaranFactura,
  UnidadDatos, UnidadFormComentarios;

{$R *.DFM}

procedure TFormMtoFacturas.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  action:=cafree;
end;

procedure TFormMtoFacturas.Button1Click(Sender: TObject);
var
  F : TForm;
begin
  F := application.findcomponent('formcomentarios') as TForm;
  if Assigned(F) then
    f.showmodal
  else
  begin
    application.createform(Tformcomentarios, formcomentarios);
    formcomentarios.dbd.dataset.close;
    formcomentarios.ttabla.tablename:='FacturasProductos';
    formcomentarios.ttabla.open;
    formcomentarios.TxtComentario.DataField:='Nota';
    formcomentarios.showmodal;
  end;
end;

procedure TFormMtoFacturas.BitBtn1Click(Sender: TObject);
begin
  dfacturas.dataset.post;
  close;
end;

procedure TFormMtoFacturas.BitBtn2Click(Sender: TObject);
begin
  dfacturas.dataset.cancel;
  close;
end;

procedure TFormMtoFacturas.TFacturasAfterEdit(DataSet: TDataSet);
begin
  dfacturas.dataset.FieldByName('Fecha').editmask:='!99/99/00;1;_';
end;


procedure TFormMtoFacturas.TFacturasAfterInsert(DataSet: TDataSet);
begin
  dfacturas.dataset.FieldByName('Fecha').editmask:='!99/99/00;1;_';
  dfacturas.dataset.FieldByName('Fecha').value:=date;
  txtnumero.setfocus;
end;





procedure TFormMtoFacturas.TProductosAfterEdit(
  DataSet: TDataSet);
var
  campo, filtro:string;
begin
  campo:='Tipo';
  filtro:=quotedstr('Tratamiento');
  tproducto.filter:='[' + campo + '] = ' + filtro;
  tproducto.filtered:=true;
  tproducto.refresh;
end;


procedure TFormMtoFacturas.TProductosAfterInsert(
  DataSet: TDataSet);
begin
  tablaproductos.setfocus;
  tablaproductos.SelectedIndex:=0;
end;

procedure TFormMtoFacturas.TProductosAfterPost(
  DataSet: TDataSet);
begin
  tproducto.filter:='';
  tproducto.filtered:=false;
  tproducto.refresh;
  tproductos.refresh;
end;


procedure TFormMtoFacturas.TProductosBeforeDelete(DataSet: TDataSet);
begin
  if (dproductos.dataset.fieldbyname('Cantidad').value<>NULL) and (dproductos.dataset.fieldbyname('IDProducto').value<>NULL)and (dproductos.dataset.fieldbyname('Stock').value) then
    formmenuprincipal.stock(False,dproductos.dataset.fieldbyname('Cantidad').value,dproductos.dataset.fieldbyname('IDProducto').value);
end;


procedure TFormMtoFacturas.TProductosBeforeInsert(DataSet: TDataSet);
begin
  if (dfacturas.dataset.state=dsinsert) or (dfacturas.dataset.state=dsedit) then
    dfacturas.DataSet.Post;
end;



procedure TFormMtoFacturas.ActAlbaranesExecute(Sender: TObject);
var
  F : TForm;
  Filtro: string;
  campo: string;
  operador: string;
begin
  Application.CreateForm(TMoFacturasProductos, MoFacturasProductos);
  mofacturasproductos.tfacturas.open;
  mofacturasproductos.talbaranes.open;
  campo:='Facturado';
  operador:='=';
  filtro:=quotedstr('No');
  mofacturasproductos.talbaranes.filter:=Format ('[%s] %s %s', [campo,operador,Filtro]);
  campo:='IDTercero';
  operador:='=';
  filtro:=quotedstr(dfacturas.dataset.fieldbyname('IDTercero').value);
  mofacturasproductos.talbaranes.filter:=Format ('%s AND [%s] %s %s', [mofacturasproductos.talbaranes.filter,campo,operador,Filtro]);
  mofacturasproductos.talbaranes.filtered:=true;
  mofacturasproductos.talbaranes.refresh;
  mofacturasproductos.tag:=dfacturas.dataset.fieldbyname('ID').value;
  F := application.findcomponent('formalbaranesfactura') as TForm;
  if Assigned(F) then
    f.showmodal
  else
  begin
    application.createform(Tformalbaranesfactura, formalbaranesfactura);
    formalbaranesfactura.showmodal;
  end;
end;


procedure TFormMtoFacturas.BCalcularParteClick(Sender: TObject);
var
  Precio, Cantidad : double;
  TotalFactura : double;
begin
  datos.tproductos.open;
  datos.tproductos.filter:='';
  datos.tproductos.filtered:=false;
  datos.tproductos.refresh;
  dproductos.dataset.First;
  totalfactura:=0;
  while not dproductos.dataset.eof do
  begin
    if varisnull(dproductos.dataset.fieldbyname('IDProducto').value) then
    begin
      messagedlg ('Faltan datos en el producto actual.',mtwarning,[mbok],0);
      exit;
    end;
    //Poner precio por defecto
    if varisnull(dproductos.dataset.fieldbyname('Precio').value) or
       (dproductos.dataset.fieldbyname('Precio').value=0) then
    begin
      if datos.TProductos.Locate('ID',dproductos.dataset.fieldbyname('IDProducto').value,[]) then
      begin
        dproductos.dataset.edit;
        if not varisnull(datos.dproductos.dataset.fieldbyname('UnidadDosis').value) then
          dproductos.dataset.fieldbyname('UnidadDosis').value:=datos.dproductos.dataset.fieldbyname('UnidadDosis').value;
        if formmenuprincipal.VTPreciosSinIVA=1 then
        begin
          if not varisnull(datos.dproductos.dataset.fieldbyname('PrecioSinIVA').value) then
            dproductos.dataset.fieldbyname('Precio').value:=datos.dproductos.dataset.fieldbyname('PrecioSinIVA').value;
        end
        else
        begin
          if not varisnull(datos.dproductos.dataset.fieldbyname('Precio').value) then
            dproductos.dataset.fieldbyname('Precio').value:=datos.dproductos.dataset.fieldbyname('Precio').value;
        end;
      end;
    end;
    if not varisnull(dproductos.dataset.fieldbyname('Precio').value) then
      Precio:=dproductos.dataset.fieldbyname('Precio').value
    else
      Precio:=0;
    if not varisnull(dproductos.dataset.fieldbyname('Cantidad').value) then
      Cantidad:=dproductos.dataset.fieldbyname('Cantidad').value
    else
      Cantidad:=0;
    dproductos.dataset.edit;
    dproductos.dataset.fieldbyname('Importe').value:=precio*cantidad;
    //Control de stock
    if not dproductos.dataset.fieldbyname('Stock').value then
      formmenuprincipal.Stock(True,cantidad,dproductos.dataset.fieldbyname('IDProducto').value);
    dproductos.dataset.fieldbyname('Stock').value:=True;
    dproductos.dataset.post;
    TotalFactura:=TotalFactura + (precio*cantidad);
    dproductos.dataset.next;
  end;
  dproductos.dataset.first;
  dfacturas.dataset.edit;
  dfacturas.dataset.fieldbyname('Importe').value:=totalfactura;
  dfacturas.dataset.post;
end;















procedure TFormMtoFacturas.BEliminarProductoClick(
  Sender: TObject);
var
  nombre:string;
begin
  if dproductos.dataset.recordcount=0 then
    messagedlg('No hay productos para eliminar.',mtinformation,[mbok],0)
  else
  begin
    if not (dproductos.dataset.fieldbyname('LProducto').value=Null) then
      Nombre:=dproductos.dataset.fieldbyname('LProducto').value
    else
      nombre:='';
    if messagedlg('Est seguro que desea ELIMINAR el producto [' + nombre + ']?',mtconfirmation,[mbno,mbyes],0)=mryes then
      dproductos.dataset.delete;
  end;
end;

procedure TFormMtoFacturas.BNuevoProductoClick(Sender: TObject);
begin
  if dfacturas.dataset.recordcount=0 then
    messagedlg ('Introduzca primero la factura.',mtinformation,[mbok],0)
  else
  begin
    dproductos.dataset.Insert;
  end;  
end;

procedure TFormMtoFacturas.TablaProductosColExit(
  Sender: TObject);
begin
  if tablaproductos.Columns[tablaproductos.selectedindex].fieldname='LProducto' then
  begin
    if not varisnull(dproductos.dataset.fieldbyname('IDProducto').value) then
    begin
      datos.tproductos.filter:='';
      datos.tproductos.filtered:=false;
      datos.tproductos.open;
      if datos.TProductos.Locate('ID',dproductos.dataset.fieldbyname('IDProducto').value,[]) then
      begin
        dproductos.dataset.edit;
        if not varisnull(datos.dproductos.dataset.fieldbyname('UnidadDosis').value) then
          dproductos.dataset.fieldbyname('UnidadDosis').value:=datos.dproductos.dataset.fieldbyname('UnidadDosis').value;
        if formmenuprincipal.VTPreciosSinIVA=1 then
        begin
          if not varisnull(datos.dproductos.dataset.fieldbyname('PrecioSinIVA').value) then
            dproductos.dataset.fieldbyname('Precio').value:=datos.dproductos.dataset.fieldbyname('PrecioSinIVA').value;
        end
        else
        begin
          if not varisnull(datos.dproductos.dataset.fieldbyname('Precio').value) then
            dproductos.dataset.fieldbyname('Precio').value:=datos.dproductos.dataset.fieldbyname('Precio').value;
        end;
      end;
    end;
  end;
end;









procedure TFormMtoFacturas.TablaProductosKeyPress(
  Sender: TObject; var Key: Char);
begin
  if (tablaproductos.Columns[tablaproductos.selectedindex].fieldname='Precio') or (tablaproductos.Columns[tablaproductos.selectedindex].fieldname='Importe') or (tablaproductos.Columns[tablaproductos.selectedindex].fieldname='Cantidad')then
    if key='.' then key:=',';
end;

procedure TFormMtoFacturas.FormShow(Sender: TObject);
begin
  tfacturas.open;
  tproductos.open;
  tproducto.open;
  tcasas.open;
end;

end.
