unit UnidadGastoAguaRiegoG;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DBCtrls, StdCtrls, Mask, Buttons, ExtCtrls, db, dxCntner,
  dxEditor, dxExEdtr, dxEdLib, dxDBELib;

type
  TformPartesAguaRiegoG = class(TForm)
    Label1: TLabel;
    Label3: TLabel;
    txtFinca: TDBLookupComboBox;
    Label4: TLabel;
    txtSector: TDBLookupComboBox;
    Label5: TLabel;
    txtPrecio: TDBEdit;
    Label6: TLabel;
    txtHoras: TDBEdit;
    Label7: TLabel;
    txtLitros: TDBEdit;
    Panel1: TPanel;
    bAceptar: TBitBtn;
    bCancelar: TBitBtn;
    txtFecha: TdxDBDateEdit;
    Label2: TLabel;
    txtTecnico: TDBEdit;
    procedure bCancelarClick(Sender: TObject);
    procedure bAceptarClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure txtFincaClick(Sender: TObject);
    procedure txtHorasKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formPartesAguaRiegoG: TformPartesAguaRiegoG;

implementation

uses UnidadAguaRiego, UnidadProcedimientos, UnidadCalculos;

{$R *.dfm}

procedure TformPartesAguaRiegoG.bCancelarClick(Sender: TObject);
begin
  if FormAgua.TAgua.State in [dsedit, dsinsert] then
  begin
    FormAgua.TAgua.Cancel;
    close;
  end;
end;

procedure TformPartesAguaRiegoG.bAceptarClick(Sender: TObject);
var
  seguir : boolean;
begin
  seguir := true;
  if (FormAgua.TAguaFecha.Value = null) then
  begin
    MessageDlg('Debe introducir una fecha vlida.', mtInformation, [mbok], 0);
    txtFecha.SetFocus;
    seguir := false;
  end;
  if seguir then
  begin
    if (FormAgua.TAguaIDFinca.Value = null) then
    begin
      MessageDlg('Debe introducir una finca vlida.', mtInformation, [mbok], 0);
      txtFinca.SetFocus;
      seguir := false;
    end;
  end;
  if seguir then
  begin
    if (FormAgua.TAguaIDSector.Value = null) then
    begin
      MessageDlg('Debe introducir un sector de riego vlido.', mtInformation, [mbok], 0);
      txtSector.SetFocus;
      seguir := false;
    end;
  end;
  if seguir then
  begin
    DatosCalculos.TC.Close;
    DatosCalculos.tc.SQL.Clear;
    DatosCalculos.tc.SQL.Add('SELECT id FROM  SectoresFincas WHERE IDFinca = :pIDFinca and ID = :pID');
    DatosCalculos.tc.ParamByName('pIDFinca').DataType := ftFloat;
    DatosCalculos.tc.ParamByName('pIDFinca').Value := FormAgua.TAguaIDFinca.Value;
    DatosCalculos.tc.ParamByName('pID').DataType := ftFloat;
    DatosCalculos.tc.ParamByName('pID').Value := FormAgua.TAguaIDSector.Value;
    DatosCalculos.tc.Open;
    if DatosCalculos.tc.RecordCount > 0 then
    begin
      if FormAgua.TAgua.State in [dsedit, dsinsert] then
      begin
        if (FormAgua.TAguaHoras.Value = 0 ) or (FormAgua.TAguaHoras.Value = null) then
          FormAgua.TAguaHoras.Value := 0;
        if (FormAgua.TAguaPrecio.Value = 0 ) or (FormAgua.TAguaPrecio.Value = null) then
          FormAgua.TAguaPrecio.Value := 0;
        if (FormAgua.TAguaLitros.Value = 0 ) or (FormAgua.TAguaLitros.Value = null) then
          FormAgua.TAguaLitros.Value := 0;
        if (FormAgua.TAguaImporteTotalAgua.Value = 0 ) or (FormAgua.TAguaImporteTotalAgua.Value = null) then
          FormAgua.TAguaImporteTotalAgua.Value := 0;
        if (FormAgua.TAguaImporteTotalProductos.Value = 0 ) or (FormAgua.TAguaImporteTotalProductos.Value = null) then
          FormAgua.TAguaImporteTotalProductos.Value := 0;
        if (FormAgua.TAguaImporteTotalParte.Value = 0 ) or (FormAgua.TAguaImporteTotalParte.Value = null) then
          FormAgua.TAguaImporteTotalParte.Value := 0;
        fechaEnPeriodo (FormAgua.TAguaFecha.Value, true);
        FormAgua.TAgua.Post;
        close;
      end;
    end
    else
    begin
      MessageDlg(Format ('El sector introducido no pertene a la finca: %s',
          [formAgua.TAguaLFinca.AsString]), mtinformation, [mbok], 0);
      txtSector.SetFocus;
    end;
    datoscalculos.tc.close;
  end;
end;

procedure TformPartesAguaRiegoG.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  if FormAgua.TAgua.State in [dsedit, dsinsert] then
  begin
    FormAgua.TAgua.Cancel;
    close;
  end;
  Action := caFree;
end;

procedure TformPartesAguaRiegoG.txtFincaClick(Sender: TObject);
var
  filtro, campo, operador: string;
begin
  if not varisnull(FormAgua.TAguaIDFinca.value) then
  begin
    Filtro := FormAgua.TAguaIDFinca.AsString;
    campo := 'IDFinca';
    operador := '=';
    FormAgua.tsectores.filter := Format ('[%s] %s %s', [campo, operador, Filtro]);
    FormAgua.tsectores.filtered := true;
    FormAgua.tsectores.Refresh;
    txtSector.KeyValue := null;
  end;
end;

procedure TformPartesAguaRiegoG.txtHorasKeyPress(Sender: TObject;
  var Key: Char);
begin
  if key = '.' then
    key := ',';
end;

end.
