unit UnidadGenerarMemoriaAnual;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, Buttons, printers, ExtCtrls;

type
  TformMemoriaAnual = class(TForm)
    tab: TPageControl;
    tabPaso1: TTabSheet;
    tabPaso2: TTabSheet;
    Label1: TLabel;
    BCerrar: TBitBtn;
    BConfigurar: TBitBtn;
    CImpresora: TPrintDialog;
    LImpresora: TLabel;
    Label2: TLabel;
    TxtNCopias: TEdit;
    LProgresoPaso1: TStaticText;
    tabPaso3: TTabSheet;
    BPaso2: TBitBtn;
    Memo1: TMemo;
    BPaso1: TBitBtn;
    Memo2: TMemo;
    Shape1: TShape;
    procedure BCerrarClick(Sender: TObject);
    procedure BPaso2Click(Sender: TObject);
    procedure BConfigurarClick(Sender: TObject);
    procedure BPaso1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formMemoriaAnual: TformMemoriaAnual;

implementation

uses UnidadTotalGeneral, UnidadI, UnidadMenuPrincipal, UnidadProcedimientos;

{$R *.dfm}

procedure TformMemoriaAnual.BCerrarClick(Sender: TObject);
begin
  close;
end;

procedure TformMemoriaAnual.BPaso2Click(Sender: TObject);
begin
  if MessageDlg('Se va a generar el Paso 2, recuerde que se imprimir ' +
      'directamente a la impresora seleccionada.',
      mtConfirmation,[mbok,mbcancel],0) = mrcancel then
    exit;
  screen.Cursor := crHourGlass;
  application.createform(TformTGF, formTGF);
  formtgf.show;
  FormTGF.WindowState := wsMinimized;
  FormTGF.BMemoriaAnualClick(nil);
  screen.Cursor := crDefault;
  MessageDlg('El Paso 2 ha sido generado correctamente, contine ' +
      'generando el siguiente paso.', mtinformation,[mbok],0);
  tabPaso3.Show;
end;

procedure TformMemoriaAnual.BConfigurarClick(Sender: TObject);
begin
  CImpresora.Execute;
  // Mostrar la impresora seleccionada
  LImpresora.Caption := Printer.Printers[Printer.PrinterIndex];
  TxtNCopias.text := inttostr(Printer.Copies);
end;

procedure TformMemoriaAnual.BPaso1Click(Sender: TObject);
begin
  if MessageDlg('Se va a generar el Paso 1, recuerde que se imprimir ' +
      'directamente a la impresora seleccionada.',
      mtConfirmation,[mbok,mbcancel],0) = mrcancel then
    exit;
  screen.Cursor := crHourGlass;
  application.createform(TformTGF, formTGF);
  formtgf.show;
  FormTGF.WindowState := wsMinimized;
  FormTGF.BMemoriaAnualPaso1Click(nil);
  screen.Cursor := crDefault;
  MessageDlg('El Paso 1 ha sido generado correctamente, contine ' +
      'generando el siguiente paso.', mtinformation,[mbok],0);
  tabPaso2.Show;
end;

procedure TformMemoriaAnual.FormCreate(Sender: TObject);
begin
  try
    LImpresora.caption := printer.Printers[printer.printerindex];
  except
    //Silenciosa
  end;
end;

end.
