unit UnidadGenerarTotalAnualObrero;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Mask, ExtCtrls, Db, DBCtrls, DBTables, Grids, DBGrids,
  ComCtrls,FileCtrl, shellapi, Qrctrls, QuickRpt, inifiles, variants, printers;

type
  TformGenerarTotalesObrero = class(TForm)
    TC: TQuery;
    DC: TDataSource;
    DG: TSaveDialog;
    BGenerarTotal: TBitBtn;
    DTotales: TDataSource;
    TTotales: TTable;
    PD: TPanel;
    Tabla: TDBGrid;
    P1: TPanel;
    P2: TPanel;
    TConsultaNomina: TQuery;
    Panel19: TPanel;
    Label14: TLabel;
    Label11: TLabel;
    TxtTotalNomina: TStaticText;
    TxtNumeroObreros: TStaticText;
    TCTercero: TQuery;
    LImpresionOficial: TQuickRep;
    QRBand8: TQRBand;
    QRShape3: TQRShape;
    LPeriodo: TQRLabel;
    QRLabel36: TQRLabel;
    QRBand10: TQRBand;
    QRShape4: TQRShape;
    QRLabel37: TQRLabel;
    QRShape5: TQRShape;
    QRShape7: TQRShape;
    QRMemo1: TQRMemo;
    QRShape9: TQRShape;
    QRShape10: TQRShape;
    QRMemo2: TQRMemo;
    QRMemo4: TQRMemo;
    QRBand14: TQRBand;
    QRSysData6: TQRSysData;
    LEmpresa1: TQRLabel;
    QRSysData7: TQRSysData;
    QRBand15: TQRBand;
    QRSysData9: TQRSysData;
    QRBand16: TQRBand;
    QRDBText13: TQRDBText;
    QRDBText14: TQRDBText;
    QRDBText17: TQRDBText;
    QRDBText19: TQRDBText;
    QRDBText20: TQRDBText;
    QRBand17: TQRBand;
    QRExpr18: TQRExpr;
    QRExpr19: TQRExpr;
    QRExpr20: TQRExpr;
    QRExpr21: TQRExpr;
    DQ: TDataSource;
    TQ: TTable;
    CImpresora: TPrintDialog;
    TTabla: TTable;
    TTotalesID: TAutoIncField;
    TTotalesIDObrero: TIntegerField;
    TTotalesNombre: TStringField;
    TTotalesRetencion: TCurrencyField;
    TTotalesTotal: TCurrencyField;
    TTotalesTotalPercibir: TCurrencyField;
    TTotalesDNI: TStringField;
    QRLabel38: TQRLabel;
    BitBtn4: TBitBtn;
    BImprimir: TBitBtn;
    BGD: TBitBtn;
    BRecalcular: TBitBtn;
    Shape1: TShape;
    Label1: TLabel;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BitBtn4Click(Sender: TObject);
    procedure BGenerarTotalClick(Sender: TObject);
    procedure BGDClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BRecalcularClick(Sender: TObject);
    procedure BImprimirClick(Sender: TObject);
  private
    noCerrar : boolean;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formGenerarTotalesObrero: TformGenerarTotalesObrero;

implementation

uses UnidadCalendario, UnidadSeleccion, UnidadI,  UnidadDatos,
    unidadprocedimientos;


{$R *.DFM}

procedure TformGenerarTotalesObrero.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  if NoCerrar then
    action := caNone
  else
  begin
    tc.close;
    TConsultaNomina.close;
    ttotales.close;
    action := cafree;
  end;
end;

procedure TformGenerarTotalesObrero.BitBtn4Click(Sender: TObject);
begin
  if messagedlg ('Est seguro que desea cancelar la generacin del total anual (190)?',
      mtconfirmation, [mbyes, mbno], 0) = mryes then
  begin
    noCerrar := false;
    close;
  end
  else
    tabla.SetFocus;
end;

procedure TformGenerarTotalesObrero.BGenerarTotalClick(Sender: TObject);
var
  importeTotal, importeTotalBruto, importeTotalRetencion,
      importeTotalPercibir : double;
//  importeTotalCoche : double;
  DNI : string;
  nombre : string;
  numero : integer;
begin
  noCerrar := true;
  screen.cursor := crhourglass;
  formi.b.min := 0;
  formi.L.caption := 'Calculando total anual, espere por favor...';
  formi.show;
  formi.Refresh;
  ttotales.open;
  dtotales.dataset.First;
  while not dtotales.DataSet.eof do
    dtotales.dataset.Delete;
  datos.DObreros.DataSet.Filtered := false;
  datos.DObreros.DataSet.Open;
  //comprobar si existen datos entre las fechas seleccionadas
  With tc do
  begin
    Close;
    SQL.Clear;
    DatabaseName :=  extractfilepath(application.ExeName) + 'Quincena';
    SQL.Add('SELECT *');
    SQL.Add('FROM TotalAnual');
    SQL.add('WHERE (FInicio BETWEEN :pFInicio AND :pFFin) AND (FFin >= :pFInicio) AND (FFin <= :pFFin)');
//    SQL.Add('WHERE (FInicio >= :pFInicio) AND (FFin <= :pFFin)');
    ParamByName('pFInicio').DataType := ftDate;
    ParamByName('pFInicio').Value := vtfcinicio;
    ParamByName('pFFin').DataType := ftDate;
    ParamByName('pFFin').Value := VTFCFin;
    try
      open;
    except
      close;
      screen.Cursor := crDefault;
      formi.close;
      raise;
    end;
    if RecordCount > 0 then
    begin
      screen.Cursor := crDefault;
      formi.Close;
      if not msSin ('ATENCIN: se han encontrado datos ya guardados con fechas ' +
          'comprendidas en el perodo que ha seleccionado: ' + datetostr(VTFCInicio) +
          ' - ' + datetostr(VTFCFin) +', si contina con el proceso se ' +
          'ELIMINARN DEFINITIVAMENTE  ' + inttostr(RecordCount) +
          ' registros. Contine slo si est completamente seguro.' +
          chr(13) + chr(13) + 'Desea continuar?' + chr(13) + chr(13) +
          '   Pulse No para cancelar la generacin.' + chr(13) +
          '   Pulse S para continuar con la generacin del perodo y ELIMINAR los datos anteriores.',
          'Existen datos de este perodo...') then
      begin
        close;
        noCerrar := FALSE;
        exit;
      end
      else
      begin
        Close;
        SQL.Clear;
        DatabaseName :=  extractfilepath(application.ExeName) + 'Quincena';
        SQL.Add('DELETE FROM TotalAnual');
        SQL.add('WHERE (FInicio BETWEEN :pFInicio AND :pFFin) AND (FFin >= :pFInicio) AND (FFin <= :pFFin)');
        ParamByName('pFInicio').DataType := ftDate;
        ParamByName('pFInicio').Value := VTFCInicio;
        ParamByName('pFFin').DataType := ftDate;
        ParamByName('pFFin').Value := VTFCFin;
        try
          ExecSQL;
        except
          close;
          screen.Cursor := crDefault;
          formi.close;
          raise;
        end;
      end;
    end;
  end;

  with TConsultaNomina do
  begin
    close;
    DatabaseName :=  extractfilepath(application.ExeName) + 'Quincena';
    SQL.Clear;
//    SQL.add('select o.IDObrero, SUM(o.coche) SCoche, SUM(Total) STotalBruto, SUM(Retencion) STotalRetencion, SUM(TotalPercibir) STotalPercibir');
    SQL.add('select o.IDObrero, SUM(Total) STotalBruto, SUM(Retencion) STotalRetencion, SUM(TotalPercibir) STotalPercibir');
    SQL.add('from asesor o');
    SQL.add('where (o.FInicio BETWEEN :pFInicio AND :pFFin) AND (o.FFin >= :pFInicio) AND (o.FFin <= :pFFin)');
    SQL.add('GROUP BY o.IDObrero');
    ParamByName('pFInicio').DataType := ftdate;
    ParamByName('pFInicio').value := VTFCInicio;
    ParamByName('pFFin').DataType := ftdate;
    ParamByName('pFFin').value := VTFCFin;
    try
      open;
    except
      screen.Cursor := crDefault;
      formi.close;
      close;
      raise;
    end;
    First;
    importeTotal := 0;
    numero := 0;
    formi.b.max := RecordCount;
    while not eof do
    begin
      formi.b.Position := RecNo;
      if datos.TObreros.Locate('ID',
         fieldbyname('IDObrero').value, []) then
      begin
        if not varisnull(datos.dobreros.dataset.fieldbyname('Apellido1').value) then
          nombre := datos.dobreros.dataset.fieldbyname('Apellido1').value;
        if not varisnull(datos.dobreros.dataset.fieldbyname('Apellido2').value) then
          nombre := nombre + ' ' + datos.dobreros.dataset.fieldbyname('Apellido2').value;
        if not varisnull(datos.dobreros.dataset.fieldbyname('Nombre').value) then
          nombre := nombre + ', ' + datos.dobreros.dataset.fieldbyname('Nombre').value;
        if not varisnull(datos.dobreros.dataset.fieldbyname('DNI').value) then
          DNI := datos.dobreros.dataset.fieldbyname('DNI').value;
        if not varisnull(fieldbyname('STotalBruto').value) then
          importeTotalBruto := fieldbyname('STotalBruto').value
        else
          ImporteTotalBruto := 0;
{        if not varisnull(fieldbyname('SCoche').value) then
          importeTotalCoche := fieldbyname('SCoche').value
        else
          ImporteTotalCoche := 0;}
        if not varisnull(fieldbyname('STotalPercibir').value) then
          importeTotalPercibir := fieldbyname('STotalPercibir').value
        else
          ImporteTotalPercibir := 0;
        if not varisnull(fieldbyname('STotalRetencion').value) then
          importeTotalRetencion := fieldbyname('STotalRetencion').value
        else
          ImporteTotalRetencion := 0;
//        importeTotalBruto := importeTotalBruto + importeTotalCoche;
        //TOTAL PARA Total anual
        dtotales.dataset.insert;
        dtotales.dataset.fieldbyname('Nombre').value := nombre;
        dtotales.dataset.fieldbyname('Total').value := importeTotalBruto;
        dtotales.dataset.fieldbyname('IDObrero').value :=
            fieldbyname('IDObrero').value;
        dtotales.dataset.fieldbyname('DNI').value := DNI;
        dtotales.dataset.fieldbyname('Retencion').value := importeTotalRetencion;
        dtotales.dataset.fieldbyname('TotalPercibir').value := importetotalPercibir;
        try
          dtotales.dataset.post;
        except
          screen.Cursor := crDefault;
          formi.close;
          close;
          raise;
        end;
        importeTotal := importeTotal +
            dtotales.dataset.fieldbyname('TotalPercibir').value;
        numero := numero + 1;
      end;
      next;
    end;
  end;
  dtotales.DataSet.refresh;
  TxtTotalNomina.caption := formatfloat('###,###,###,##0.00;-###,###,###,##0.00;0',
      importetotal);
  TxtNumeroObreros.caption := formatfloat('###,###,###,##0;-###,###,###,##0;0',
      numero);
  screen.cursor:=crdefault;
  try
    TTotales.IndexFieldNames := 'Nombre';
  except
    screen.Cursor := crDefault;
    formi.close;
    raise;
  end;
  screen.Cursor := crDefault;
  formi.close;

  if ttotales.RecordCount <= 0 then
  begin
    noCerrar := true;
    msAtencion ('No hay datos para la generacin del total anual. ' +
        'Compruebe los filtros y vuelva a intentarlo.', 'Atencin...');
    close;
    noCerrar := FALSE;
    exit;
  end;

  ttotales.First;
end;

procedure TformGenerarTotalesObrero.BGDClick(Sender: TObject);
var
  importeTotal, importeTotalBruto, importeTotalRetencion,
      importeTotalPercibir : double;
  numero : integer;
begin
  screen.cursor := crhourglass;
  formi.b.min := 0;
  formi.L.caption := 'Recalculando totales, espere por favor...';
  formi.show;
  formi.Refresh;
  ttotales.open;
  ttotales.First;
  formi.b.max := ttotales.RecordCount;
  numero := 0;
  importeTotal := 0; 
  With ttotales do
  begin
    while not eof do
    begin
      if not varisnull(fieldbyname('Total').value) then
        importeTotalBruto := fieldbyname('Total').value
      else
        ImporteTotalBruto := 0;
      if Not VarIsNull(fieldbyname('Retencion').value) then
        importeTotalRetencion := fieldbyname('Retencion').value
      else
        importeTotalRetencion := 0;
      importeTotalPercibir := importeTotalBruto - importeTotalRetencion;
      //TOTAL PARA Total anual
      edit;
      fieldbyname('Total').value := importeTotalBruto;
      fieldbyname('Retencion').value := importeTotalRetencion;
      fieldbyname('TotalPercibir').value := importeTotalPercibir;
      try
        post;
      except
        screen.Cursor := crDefault;
        formi.close;
        close;
        raise;
      end;
      importeTotal := importeTotal + fieldbyname('TotalPercibir').value;
      numero := numero + 1;
      next;
    end;
  end;
  Tabla.Refresh;
  txtnumeroobreros.Caption := formatfloat('###,###,###,##0;-###,###,###,##0;0', numero);
  TxtTotalNomina.Caption := formatfloat('###,###,###,##0.00;-###,###,###,##0.00;0', importeTotal);
  formi.Close;
  screen.Cursor := crDefault;


  //GUARDAR DATOS EN FICHERO TotalAnual.DB
  if messagedlg ('Se va a guardar el listado anual definitivamente.', mtwarning,
      [mbok , mbcancel], 0) = mrok then
  begin
    screen.Cursor := crHourGlass;
    formi.L.Caption := 'Guardando datos de nmina...';
    formi.B.Visible := false;
    formi.show;
    formi.Refresh;
    ttotales.First;
    TQ.open;
    while not ttotales.eof do
    begin
       tq.insert;
       tq.FieldByName('IDObrero').value :=
           ttotales.fieldbyname('IDObrero').value;
       tq.FieldByName('Retencion').value :=
           ttotales.fieldbyname('Retencion').value;
       tq.FieldByName('Total').value := ttotales.fieldbyname('Total').value;
       tq.FieldByName('TotalPercibir').value :=
           ttotales.fieldbyname('TotalPercibir').value;
       tq.FieldByName('DNI').value := ttotales.fieldbyname('DNI').value;
       try
         tq.post;
       except
         screen.Cursor := crDefault;
         formi.close;
         raise;
       end;
       ttotales.next;
    end;
  end;
  screen.Cursor := crDefault;
  formi.close;
  nocerrar := false;
  close;
end;

procedure TformGenerarTotalesObrero.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if (Key = #13) and Not (ActiveControl is TDBGrid) then
  begin
    Key := #0;
    Perform(WM_NEXTDLGCTL, 0, 0);
  end;
end;

procedure TformGenerarTotalesObrero.FormCreate(Sender: TObject);
var
  tmp : string;
begin
  tctercero.open;
  noCerrar := false;
  ttotales.close;

  if not directoryexists(ExtractFilePath(application.ExeName) + 'Quincena') then
    mkdir(ExtractFilePath(application.ExeName) + 'Quincena');
  if not FileExists(ExtractFilePath(application.ExeName) + 'Quincena\TotalAnual.db') then
  begin
    deletefile(ExtractFilePath(application.ExeName) + 'Quincena\TotalAnual.px');
    deletefile(ExtractFilePath(application.ExeName) + 'Quincena\TotalAnual.XG0');
    deletefile(ExtractFilePath(application.ExeName) + 'Quincena\TotalAnual.XG1');
    deletefile(ExtractFilePath(application.ExeName) + 'Quincena\TotalAnual.YG0');
    deletefile(ExtractFilePath(application.ExeName) + 'Quincena\TotalAnual.YG1');
    with TTabla do
    begin
      DatabaseName := ExtractFilePath(application.ExeName) + 'Quincena';
      TableName := 'TotalAnual.DB';
      TableType := ttParadox;
      with FieldDefs do
      begin
        Clear;
        Add('ID', ftautoinc, 0, false);
        Add('IDObrero', ftInteger, 0, false);
        Add('SalarioBase', ftCurrency, 0, false);
        Add('Retencion', ftCurrency, 0, false);
        Add('PrecioDia', ftCurrency, 0, false);
        Add('Total', ftCurrency, 0, false);
        Add('TotalPercibir', ftCurrency, 0, false);
        Add('ImporteDietas', ftCurrency, 0, false);
        Add('PorcentajeRetencion', ftFloat, 0, false);
        Add('PrecioHora', ftCurrency, 0, false);
        Add('Horas', ftFloat, 0, false);
        Add('Dias', ftInteger, 0, false);
        Add('Coche', ftcurrency, 0, False);
        Add('FInicio', ftDate, 0, False);
        Add('FFin', ftDate, 0, False);
        Add('Banco', ftBoolean, 0, False);
        Add('Nomina', ftBoolean, 0, False);
        Add('DNI', ftString, 20, False);        
      end;
      IndexDefs.Clear;
      IndexDefs.Add('', 'ID', [ixPrimary]);
      IndexDefs.Add('IndFInicio', 'FInicio',[ixCaseInsensitive]);
      IndexDefs.Add('IndIDObrero', 'IDObrero', [ixCaseInsensitive]);
      CreateTable;
    end;
    ttabla.close;
  end;

  TConsultaNomina.Close;
  TConsultaNomina.DatabaseName := ExtractFilePath(application.ExeName) + 'Quincena';
  tmp := extractfilepath(application.exename) + 'TEMP';
  if not directoryexists(tmp) then
    mkdir(tmp);
  deletefile(tmp + '\to.px');
  deletefile(tmp + '\to.db');
  deletefile(tmp + '\to.XG0');
  deletefile(tmp + '\to.YG0');
  with TTotales do
  begin
    DatabaseName := tmp;
    TableName := 'TO.DB';
    TableType := ttParadox;
    with FieldDefs do
    begin
      Clear;
      Add('ID', ftautoinc, 0, false);
      Add('IDObrero', ftInteger, 0, false);
      Add('Nombre', ftString, 255, false);
      Add('SalarioBase', ftCurrency, 0, false);
      Add('Retencion', ftCurrency, 0, false);
      Add('PrecioDia', ftCurrency, 0, false);
      Add('Total', ftCurrency, 0, false);
      Add('TotalPercibir', ftCurrency, 0, false);
      Add('ImporteDietas', ftCurrency, 0, false);
      Add('PorcentajeRetencion', ftFloat, 0, false);
      Add('Horas', ftFloat, 0, false);
      Add('PrecioHora', ftCurrency, 0, false);
      Add('Dias', ftInteger, 0, false);
      Add('Tipo', ftString, 255, False);
      Add('Coche', ftcurrency, 0, False);
      Add('Nomina', ftBoolean, 0, False);
      Add('Banco', ftBoolean, 0, False);
      Add('DNI', ftString, 20, False);      
    end;
    IndexDefs.Clear;
    IndexDefs.Add('', 'ID', [ixPrimary]);
    IndexDefs.Add('IndNombre', 'Nombre',[ixCaseInsensitive]);
    CreateTable;
  end;
  ttotales.close;
  TTotales.DatabaseName := tmp;
  ttotales.TableName := 'to.db';
end;

procedure TformGenerarTotalesObrero.FormShow(Sender: TObject);
begin
  tq.DatabaseName := ExtractFilePath(application.ExeName) + 'Quincena';
  if pd.visible then
  begin
    tabla.SetFocus;
    tabla.selectedindex := 2;
  end;
  BGenerarTotalClick(nil);
end;

procedure TformGenerarTotalesObrero.BRecalcularClick(Sender: TObject);
var
  importeTotal, importeTotalBruto, importeTotalRetencion,
      importeTotalPercibir : double;
  numero : integer;
begin
  screen.cursor := crhourglass;
  formi.b.min := 0;
  formi.L.caption := 'Recalculando totales, espere por favor...';
  formi.show;
  formi.Refresh;
  ttotales.open;
  ttotales.First;
  formi.b.max := ttotales.RecordCount;
  numero := 0;
  importeTotal := 0;
  With ttotales do
  begin
    while not eof do
    begin
      if not varisnull(fieldbyname('Total').value) then
        importeTotalBruto := fieldbyname('Total').value
      else
        ImporteTotalBruto := 0;
      if Not VarIsNull(fieldbyname('Retencion').value) then
        importeTotalRetencion := fieldbyname('Retencion').value
      else
        importeTotalRetencion := 0;
      importeTotalPercibir := importeTotalBruto - importeTotalRetencion;
      //TOTAL PARA Total anual
      edit;
      fieldbyname('Total').value := importeTotalBruto;
      fieldbyname('Retencion').value := importeTotalRetencion;
      fieldbyname('TotalPercibir').value := importeTotalPercibir;
      try
        post;
      except
        screen.Cursor := crDefault;
        formi.close;
        close;
        raise;
      end;
      importeTotal := importeTotal + fieldbyname('TotalPercibir').value;
      numero := numero + 1;
      next;
    end;
  end;
  Tabla.Refresh;
  txtnumeroobreros.Caption := formatfloat('###,###,###,##0;-###,###,###,##0;0', numero);
  TxtTotalNomina.Caption := formatfloat('###,###,###,##0.00;-###,###,###,##0.00;0', importeTotal);
  screen.cursor := crdefault;
  formi.close;
end;

procedure TformGenerarTotalesObrero.BImprimirClick(Sender: TObject);
begin
  if messagedlg ('Se va a imprimir el listado 190 (total anual por obrero), ' +
      'prepare la impresora.',mtwarning,[mbok,mbcancel],0)=mrok then
  begin
    LPeriodo.Caption := 'Desde: ' + datetostr(VTFCInicio) + ' Hasta: ' +
        datetostr(VTFCFin);
    lempresa1.caption :=  inttostr(vtidempresa) + ' - ' +
        vtnombreempresa + ' [' +
        datetostr (vtinicioempresa) +
        ' - ' + datetostr (vtfinempresa) + ']';
    LImpresionOficial.ReportTitle := 'LISTADO TOTAL ANUAL POR OBRERO (190)';
    LImpresionOficial.PreviewModal;
  end;
end;

end.
