unit UnidadGestionUsuarios;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, Grids, DBGrids, ExtCtrls, DBCtrls, Db, DBTables, StdCtrls,
  Buttons, Qrctrls, QuickRpt, ToolWin, Menus, ActnList,bde, Mask, variants;

type
  TFormGestionUsuarios = class(TForm)
    TTabla: TTable;
    DDB: TDataSource;
    LImpresion: TQuickRep;
    TitleBand1: TQRBand;
    QRSubDetail2: TQRSubDetail;
    QRDBText15: TQRDBText;
    QRDBText1: TQRDBText;
    GroupHeaderBand1: TQRBand;
    QRLabel11: TQRLabel;
    QRLabel12: TQRLabel;
    QRLabel13: TQRLabel;
    PageFooterBand1: TQRBand;
    QRSysData1: TQRSysData;
    ScrollBox1: TScrollBox;
    LEmpresa: TQRLabel;
    QRSysData3: TQRSysData;
    PageHeaderBand1: TQRBand;
    LTitulo: TQRSysData;
    Panel1: TPanel;
    Panel2: TPanel;
    Navegador: TDBNavigator;
    BEliminar: TBitBtn;
    Tabla: TDBGrid;
    BNuevo: TBitBtn;
    r: TStaticText;
    CB: TControlBar;
    BB: TToolBar;
    ToolButton1: TToolButton;
    ToolButton3: TToolButton;
    ToolButton2: TToolButton;
    PopupMenu1: TPopupMenu;
    Aadirnuevafinca1: TMenuItem;
    N1: TMenuItem;
    Previsualizar1: TMenuItem;
    N3: TMenuItem;
    Cerrarventana1: TMenuItem;
    ListaAcciones: TActionList;
    ActNuevo: TAction;
    ActEnfocarTabla: TAction;
    ActImprimirListado: TAction;
    ActCerrar: TAction;
    ActEliminarEnvase: TAction;
    Label1: TLabel;
    TTablaID: TAutoIncField;
    TTablaNombre: TStringField;
    TTablaClave: TStringField;
    TTablaGrupo: TStringField;
    TTablaTipo: TStringField;
    TTablaConsulta: TBooleanField;
    TTablaActivo: TBooleanField;
    QRDBText2: TQRDBText;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BCerrarClick(Sender: TObject);
    procedure TablaKeyPress(Sender: TObject; var Key: Char);
    procedure BEliminarClick(Sender: TObject);
    procedure BPrevisualizarClick(Sender: TObject);
    procedure TTablaAfterInsert(DataSet: TDataSet);
    procedure TTablaPostError(DataSet: TDataSet; E: EDatabaseError;
      var Action: TDataAction);
    procedure FormShow(Sender: TObject);
    procedure BNuevoClick(Sender: TObject);
    procedure TTablaAfterScroll(DataSet: TDataSet);
    procedure ActEnfocarTablaExecute(Sender: TObject);
    procedure TTablaAfterPost(DataSet: TDataSet);
    procedure TablaKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormGestionUsuarios: TFormGestionUsuarios;

implementation

uses UnidadDatos, unidadprocedimientos;

{$R *.DFM}

procedure TFormGestionUsuarios.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if (ddb.dataset.state=dsedit) or (ddb.dataset.state=dsinsert) then
    ddb.dataset.post;
  screen.cursor:=crdefault;
  ttabla.close;
  action := cafree;
end;

procedure TFormGestionUsuarios.BCerrarClick(Sender: TObject);
begin
  close;
end;

procedure TFormGestionUsuarios.TablaKeyPress(Sender: TObject;
  var Key: Char);
begin
  if key = '.' then
    if (tabla.Columns[tabla.selectedindex].fieldname='Tara') then
      key := ',';
end;

procedure TFormGestionUsuarios.BEliminarClick(Sender: TObject);
var
  nombre:string;
begin
  if ddb.dataset.recordcount=0 then
    messagedlg('No hay usuarios para eliminar.',mtinformation,[mbok],0)
  else
  begin
    if ddb.dataset.fieldbyname('ID').value = 1 then
    begin
      msinfo ('El usuario administrador no se puede eliminar.',
          'Eliminar usuario...');
      exit;
    end;
    if ddb.dataset.fieldbyname('Activo').value = true then
    begin
      msinfo ('El usuario activo no se puede eliminar.',
          'Eliminar usuario...');
      exit;
    end;
    if ddb.dataset.fieldbyname('Activo').value = true then
    begin
      msinfo ('El usuario actual est activo, no se puede eliminar.',
          'Eliminar usuario...');
      exit;
    end;
    if not (ddb.dataset.fieldbyname('Nombre').value=Null) then
      Nombre:=ddb.dataset.fieldbyname('Nombre').value
    else
      nombre:='';
    if msSi ('Est seguro que desea ELIMINAR el usuario [' + nombre +
        ']?', 'Eliminar usuario...') then
      ddb.dataset.delete;
  end;
end;

procedure TFormGestionUsuarios.BPrevisualizarClick(Sender: TObject);
begin
  lempresa.caption :=  inttostr(vtidempresa) + ' - ' +
        vtnombreempresa + ' [' + datetostr (vtinicioempresa) +
        ' - ' + datetostr (vtfinempresa) + ']';
  limpresion.ReportTitle := 'LISTADO DE USUARIOS';
  limpresion.PreviewModal;
end;

procedure TFormGestionUsuarios.TTablaAfterInsert(DataSet: TDataSet);
begin
  tabla.setfocus;
  tabla.SelectedIndex:=1;
end;


function GetBDEError(E:EDatabaseError):integer;
var
  i:integer;
begin
  if E is EDBEngineError then
  with EDBEngineError(E) do
    for i:=0 to Errorcount-1 do
    begin
      Result:=Errors[i].errorcode;
      if result<>DBIERR_USERCONSTRERR then
        if result=DBIERR_CONSTRAINTFAILED then
          databaseerror(errors[i].message)
        else if errors[i].nativeerror=0 then
          exit;
    end;
  result:=1;
end;

procedure TFormGestionUsuarios.TTablaPostError(DataSet: TDataSet;
  E: EDatabaseError; var Action: TDataAction);
begin
  case GetBDEError(e) of
     DBIERR_KEYVIOL:
       DatabaseError('Nombre de envase ya existente.');
     DBIERR_REQDERR:
       DatabaseError('Faltan datos por introducir en el envase actual (nombre).');
  end;
end;



procedure TFormGestionUsuarios.FormShow(Sender: TObject);
begin
  Session.AddPassword('11111111');
  ttabla.databasename := extractfilepath(application.ExeName);
  ttabla.open;
  r.caption := inttostr(ddb.dataset.recno) + '/'
      + inttostr(ddb.DataSet.recordcount);
  screen.cursor:=crdefault;
end;

procedure TFormGestionUsuarios.BNuevoClick(Sender: TObject);
begin
  ddb.DataSet.insert;
end;




procedure TFormGestionUsuarios.TTablaAfterScroll(DataSet: TDataSet);
begin
  r.caption:=inttostr(ddb.dataset.recno) + ' de ' + inttostr(ddb.DataSet.recordcount);
end;

procedure TFormGestionUsuarios.ActEnfocarTablaExecute(Sender: TObject);
begin
  tabla.setfocus;
end;


procedure TFormGestionUsuarios.TTablaAfterPost(DataSet: TDataSet);
begin
  ttabla.flushbuffers;
end;

procedure TFormGestionUsuarios.TablaKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  // para no aadir al pulsar tecla abajo ni tab en ultima fila
  // y si se pulsa si aadir
  with (Sender as TDbGrid) do
  begin
    if key = 19 then  //si se pulsa Pausa validar
      if (datasource.dataset.state = dsinsert)
          or (datasource.dataset.state = dsedit) then
        datasource.dataset.post;
  end;
end;

end.
