unit UnidadGruposTerceros;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, Grids, DBGrids, ExtCtrls, DBCtrls, Db, DBTables, StdCtrls,
  Buttons, Qrctrls, QuickRpt, ToolWin, Menus, ActnList, variants;

type
  TFormGruposTerceros = class(TForm)
    TTabla: TTable;
    DDB: TDataSource;
    LImpresion: TQuickRep;
    TitleBand1: TQRBand;
    GroupHeaderBand1: TQRBand;
    QRLabel11: TQRLabel;
    QRLabel12: TQRLabel;
    QRLabel13: TQRLabel;
    PageFooterBand1: TQRBand;
    QRSysData1: TQRSysData;
    ScrollBox1: TScrollBox;
    LEmpresa: TQRLabel;
    QRSysData3: TQRSysData;
    PageHeaderBand1: TQRBand;
    LTitulo: TQRSysData;
    Panel1: TPanel;
    Panel2: TPanel;
    Navegador: TDBNavigator;
    BEliminar: TBitBtn;
    Tabla: TDBGrid;
    BNuevo: TBitBtn;
    r: TStaticText;
    CB: TControlBar;
    BB: TToolBar;
    ToolButton1: TToolButton;
    ToolButton3: TToolButton;
    ToolButton2: TToolButton;
    ToolBar2: TToolBar;
    Panel3: TPanel;
    LBuscar: TLabel;
    TxtBuscar: TEdit;
    OpOrdenarNombre: TRadioButton;
    RadioButton2: TRadioButton;
    PopupMenu1: TPopupMenu;
    Aadirnuevafinca1: TMenuItem;
    N1: TMenuItem;
    Previsualizar1: TMenuItem;
    N3: TMenuItem;
    Cerrarventana1: TMenuItem;
    ListaAcciones: TActionList;
    ActNuevo: TAction;
    ActEnfocarTabla: TAction;
    ActImprimirListado: TAction;
    ActCerrar: TAction;
    ActEliminarEnvase: TAction;
    QRBand1: TQRBand;
    QRDBText1: TQRDBText;
    QRDBText15: TQRDBText;
    QRDBText11: TQRDBText;
    Label2: TLabel;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BCerrarClick(Sender: TObject);
    procedure BEliminarClick(Sender: TObject);
    procedure BPrevisualizarClick(Sender: TObject);
    procedure TTablaAfterInsert(DataSet: TDataSet);
    procedure TTablaPostError(DataSet: TDataSet; E: EDatabaseError;
      var Action: TDataAction);
    procedure FormShow(Sender: TObject);
    procedure BNuevoClick(Sender: TObject);
    procedure OpOrdenarNombreClick(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure TxtBuscarChange(Sender: TObject);
    procedure TTablaAfterPost(DataSet: TDataSet);
    procedure DDBDataChange(Sender: TObject; Field: TField);
    procedure TablaKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormGruposTerceros: TFormGruposTerceros;

implementation

uses UnidadDatos, unidadprocedimientos;

{$R *.DFM}

procedure TFormGruposTerceros.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if (ddb.dataset.state=dsedit) or (ddb.dataset.state=dsinsert) then
    ddb.dataset.post;
  ttabla.close;
  screen.cursor:=crdefault;
  action := cafree;
end;

procedure TFormGruposTerceros.BCerrarClick(Sender: TObject);
begin
  close;
end;

procedure TFormGruposTerceros.BEliminarClick(Sender: TObject);
var
  nombre:string;
begin
  if ddb.dataset.recordcount=0 then
    messagedlg('No hay grupos para eliminar.',mtinformation,[mbok],0)
  else
  begin
    datos.dterceros.dataset.open;
    if datos.dterceros.DataSet.Locate('IDGrupo',ddb.DataSet.fieldbyname('ID').value,[]) then
    begin
      messagedlg('El grupo actual no se puede eliminar ya que existe en terceros.',mtwarning,[mbok],0);
      exit;
    end;
    if not (ddb.dataset.fieldbyname('Nombre').value=Null) then
      Nombre:=ddb.dataset.fieldbyname('Nombre').value
    else
      nombre:='';
    if messagedlg('Est seguro que desea ELIMINAR el grupo [' + nombre + ']?',mtconfirmation,[mbno,mbyes],0)=mryes then
      ddb.dataset.delete;
  end;
end;

procedure TFormGruposTerceros.BPrevisualizarClick(Sender: TObject);
begin
  lempresa.caption :=  inttostr(vtidempresa) + ' - ' +
        vtnombreempresa + ' [' + datetostr (vtinicioempresa) +
        ' - ' + datetostr (vtfinempresa) + ']';
  limpresion.ReportTitle:='LISTADO DE GRUPOS DE TERCEROS';
  limpresion.PreviewModal;
end;

procedure TFormGruposTerceros.TTablaAfterInsert(DataSet: TDataSet);
begin
  tabla.setfocus;
  tabla.SelectedIndex:=1;  
end;

procedure TFormGruposTerceros.TTablaPostError(DataSet: TDataSet;
  E: EDatabaseError; var Action: TDataAction);
var
  i: integer;
begin
  if E is EDBEngineError then
  begin
    for i:=0 to EDBEngineError(E).errorcount-1 do
    begin
      if EDBEngineError(E).errors[i].Errorcode=9729 then
      begin
        messagedlg('El envase introducido ya existe. Elimnelo antes de continuar',mtinformation,[mbok],0);
        action := daAbort;
        exit;
      end
      else
      begin
        messagedlg('Hay algn dato incorrecto. Compruebe los datos y vuelva a intentarlo.',mtinformation,[mbok],0);
        action := daAbort;
        exit;
      end;
    end;
  end;
end;



procedure TFormGruposTerceros.FormShow(Sender: TObject);
begin
  opordenarnombreclick(sender);
  ttabla.open;
  r.caption:=inttostr(ddb.dataset.recno) + ' de ' + inttostr(ddb.DataSet.recordcount);
  screen.cursor:=crdefault;
end;

procedure TFormGruposTerceros.BNuevoClick(Sender: TObject);
begin
  ddb.DataSet.insert;
end;




procedure TFormGruposTerceros.OpOrdenarNombreClick(Sender: TObject);
begin
  ttabla.indexfieldnames:='Nombre';
  lbuscar.caption:='Nombre a &buscar:';
end;

procedure TFormGruposTerceros.RadioButton2Click(Sender: TObject);
begin
  ttabla.indexfieldnames:='ID';
  lbuscar.caption:='ID a &buscar:';
end;

procedure TFormGruposTerceros.TxtBuscarChange(Sender: TObject);
begin
  try
    ttabla.findnearest([txtbuscar.text])
  except
    raise;
  end;  
end;

procedure TFormGruposTerceros.TTablaAfterPost(DataSet: TDataSet);
begin
  ttabla.FlushBuffers;
end;

procedure TFormGruposTerceros.DDBDataChange(Sender: TObject;
  Field: TField);
begin
  r.caption:=inttostr(ddb.dataset.recno) + '/'
      + inttostr(ddb.DataSet.recordcount);
end;

procedure TFormGruposTerceros.TablaKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  // para no aadir al pulsar tecla abajo ni tab en ultima fila
  // y si se pulsa si aadir
  with (Sender as TDbGrid) do
  begin
    if key = 19 then  //si se pulsa Pausa validar
      if (datasource.dataset.state = dsinsert)
          or (datasource.dataset.state = dsedit) then
        datasource.dataset.post;
  end;
end;

end.
