unit UnidadImpresionTrazabilidad;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ActnList, StdCtrls, KDaoDataBase, DB, KDaoTable, DBTables, Mask,
  ExtCtrls, Buttons, Grids, DBGrids;

type
  TformImpresionTrazabilidad = class(TForm)
    tImpresion: TKADaoTable;
    dbImpresion: TKADaoDatabase;
    Button1: TButton;
    ActionList1: TActionList;
    actImprimir: TAction;
    dbd: TDataSource;
    tc: TQuery;
    TxtFiltroFecha: TMaskEdit;
    Label14: TLabel;
    Label15: TLabel;
    TxtFiltroFechaHasta: TMaskEdit;
    Panel1: TPanel;
    Button2: TButton;
    actCerrar: TAction;
    bDFinca: TSpeedButton;
    txtDesdeFinca: TEdit;
    Label1: TLabel;
    Label16: TLabel;
    txtHastaFinca: TEdit;
    bHFinca: TSpeedButton;
    Shape6: TShape;
    Shape1: TShape;
    bDVariedad: TSpeedButton;
    txtDesdeVariedad: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    txtHastaVariedad: TEdit;
    bHVariedad: TSpeedButton;
    Shape3: TShape;
    cbTipoCert: TComboBox;
    Label2: TLabel;
    Shape2: TShape;
    GroupBox1: TGroupBox;
    opTratamientos: TRadioButton;
    opAbonados: TRadioButton;
    TTabla: TTable;
    procedure actImprimirExecute(Sender: TObject);
    procedure actCerrarExecute(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure bDFincaClick(Sender: TObject);
    procedure bHFincaClick(Sender: TObject);
    procedure txtDesdeFincaExit(Sender: TObject);
    procedure txtDesdeFincaKeyPress(Sender: TObject; var Key: Char);
    procedure txtHastaFincaExit(Sender: TObject);
    procedure txtHastaFincaKeyPress(Sender: TObject; var Key: Char);
    procedure SpeedButton1Click(Sender: TObject);
    procedure bDVariedadClick(Sender: TObject);
    procedure bHVariedadClick(Sender: TObject);
    procedure txtDesdeVariedadExit(Sender: TObject);
    procedure txtDesdeVariedadKeyPress(Sender: TObject; var Key: Char);
    procedure txtHastaVariedadKeyPress(Sender: TObject; var Key: Char);
    procedure txtHastaVariedadExit(Sender: TObject);
    procedure aplicarFiltroCertificacion;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formImpresionTrazabilidad: TformImpresionTrazabilidad;

implementation

uses UnidadSeleccionInforme, UnidadProcedimientos, UnidadSeleccion;

{$R *.dfm}

procedure TformImpresionTrazabilidad.aplicarFiltroCertificacion();
begin
  //Control seleccin combo
  if cbTipoCert.ItemIndex = 0 then //Frutales
    tc.SQL.Add('  p.VisibleCertificacion = "Frutales" AND ');
  if cbTipoCert.ItemIndex = 1 then //Parrales
    tc.SQL.Add('  p.VisibleCertificacion = "Parrales" AND ');
  if cbTipoCert.ItemIndex = 2 then //Frutales y Parrales
    tc.SQL.Add('  p.VisibleCertificacion = "Frutales y Parrales" AND ');
  if cbTipoCert.ItemIndex = 3 then //Frutales, Frutales y Parrales
    tc.SQL.Add('  (p.VisibleCertificacion = "Frutales" or p.VisibleCertificacion = "Frutales y Parrales") AND ');
  if cbTipoCert.ItemIndex = 4 then //Parrales, Frutales y Parrales
    tc.SQL.Add('  (p.VisibleCertificacion = "Parrales" or p.VisibleCertificacion = "Frutales y Parrales") AND ');
  if cbTipoCert.ItemIndex = 5 then //Todos (Frutales, Parrales, Frutales y Parrales)
    tc.SQL.Add('  p.VisibleCertificacion <> "No" AND ');
  if cbTipoCert.ItemIndex = 6 then //No
    tc.SQL.Add('  p.VisibleCertificacion = "No" AND ');
  //Cuando la opcin del combo es 6, no hacemos filtro
end;

procedure TformImpresionTrazabilidad.actImprimirExecute(Sender: TObject);
var
  f : TForm;
begin
  dbImpresion.Close;
  dbImpresion.Database := ExtractFilePath(Application.ExeName) + 'Temp\impresion.mdb';
  dbImpresion.Connected := true;
  tImpresion.Close;
  tImpresion.TableName := 'tTrazabilidad';
  tImpresion.Open;
  tImpresion.EmptyTable;

  if opTratamientos.Checked then
  begin
    tc.Close;
    tc.SQL.Clear;
    tc.SQL.Add('SELECT fa.ID IDParte, fa.Fecha, pf.IDN, pf.IDProducto, ');
    tc.SQL.Add('  pf.Cantidad, pf.dosis, pf.UnidadDosis, pf.Unidad,');
    tc.SQL.Add('  fp.IDFinca, fp.IDSector, fp.IDVariedad, f.Nombre Finca, ');
    tc.SQL.Add('  s.Nombre Sector, v.Nombre Variedad, p.Nombre Producto, ');
    tc.SQL.Add('  (pf.dosis * fp.Porcentaje)/100 DosisProducto,');
    tc.SQL.Add('  (pf.cantidad * fp.Porcentaje)/100 CantidadProducto');
    tc.SQL.Add('FROM Facturas fa, ProductosFacturas pf, FincasProductos fp, Producto p, ');
    tc.SQL.Add('  Fincas f, SectoresFincas s, Variedades v ');
    tc.SQL.Add('WHERE f.ID = fp.IDFinca AND ');
    tc.SQL.Add('  fp.IDSector = s.ID AND fp.IDVariedadVariedad = v.ID AND');
    tc.SQL.Add('  fp.IDSector = s.ID AND fp.IDVariedadVariedad = v.ID AND');

    aplicarFiltroCertificacion ();

    tc.SQL.Add('  fa.ID = fp.IDFacturasProductos AND fa.ID = pf.ID AND p.ID = pf.IDProducto');
    tc.SQL.Add('  AND fa.Fecha BETWEEN :pFechaDesde AND :pFechaHasta');
    tc.SQL.Add('  AND fp.IDVariedadVariedad BETWEEN :pDV AND :pHV');
    tc.SQL.Add('  AND fp.IDFinca BETWEEN :pDF AND :pHF');
    tc.ParamByName('pFechaDesde').DataType := ftDate;
    tc.ParamByName('pFechaDesde').Value := StrToDate(TxtFiltroFecha.Text);
    tc.ParamByName('pFechaHasta').DataType := ftDate;
    tc.ParamByName('pFechaHasta').Value := StrToDate(TxtFiltroFechaHasta.Text);
    tc.ParamByName('pDV').DataType := ftFloat;
    tc.ParamByName('pDV').Value := StrToFloat(txtDesdeVariedad.Text);
    tc.ParamByName('pHV').DataType := ftFloat;
    tc.ParamByName('pHV').Value := StrToFloat(txtHastaVariedad.Text);
    tc.ParamByName('pDF').DataType := ftFloat;
    tc.ParamByName('pDF').Value := StrToFloat(txtDesdeFinca.Text);
    tc.ParamByName('pHF').DataType := ftFloat;
    tc.ParamByName('pHF').Value := StrToFloat(txtHastaFinca.Text);
    tc.Open;
    while not TC.Eof do
    begin
      tImpresion.Insert;
      tImpresion.FieldByName('Fecha').Value := TC.Fieldbyname ('Fecha').AsDateTime;
      tImpresion.FieldByName('IDFinca').Value := TC.Fieldbyname ('IDFinca').AsFloat;
      tImpresion.FieldByName('IDSector').Value := TC.Fieldbyname ('IDSector').AsFloat;
      tImpresion.FieldByName('IDVariedad').Value := TC.Fieldbyname ('IDVariedad').AsFloat;
      tImpresion.FieldByName('IDProducto').Value := TC.Fieldbyname ('IDProducto').AsFloat;
      tImpresion.FieldByName('Finca').Value := TC.Fieldbyname ('Finca').AsString;
      tImpresion.FieldByName('Sector').Value := TC.Fieldbyname ('Sector').AsString;
      tImpresion.FieldByName('Variedad').Value := TC.Fieldbyname ('Variedad').AsString;
      tImpresion.FieldByName('Producto').Value := TC.Fieldbyname ('Producto').AsString;
      tImpresion.FieldByName('Dosis').Value := TC.Fieldbyname ('DosisProducto').AsFloat;
      tImpresion.FieldByName('Cantidad').Value := TC.Fieldbyname ('CantidadProducto').AsFloat;
      tImpresion.FieldByName('UnidadDosis').Value := TC.Fieldbyname ('UnidadDosis').AsString;
      tImpresion.FieldByName('Unidad').Value := TC.Fieldbyname ('Unidad').AsString;
      tImpresion.FieldByName('IDParte').Value := TC.Fieldbyname ('IDParte').AsFloat;
      //tImpresion.FieldByName('Materia').Value := TC.Fieldbyname ('Materia').AsString;
      //tImpresion.FieldByName('PorcentajeMateria').Value := TC.Fieldbyname ('PorcentajeMateria').AsFloat;
      tImpresion.Post;
      tc.Next;
    end;
    tImpresion.Close;
    dbImpresion.Close;
    TC.Close;
    TTabla.Close;
    Application.ProcessMessages;
    F := application.findcomponent('formSeleccionInforme') as TForm;
    if Assigned(F) then
      f.showmodal
    else
    begin
      application.createform(TformSeleccionInforme, formSeleccionInforme);
      formSeleccionInforme.Tag := 20;
      formSeleccionInforme.showmodal;
    end;
  end;

  
  if opAbonados.Checked then
  begin
    tc.Close;
    tc.SQL.Clear;
    tc.SQL.Add('select sf.id IDSector, sum(vf.numarboles) Pies');
    tc.SQL.Add('from sectoresfincas sf, variedadesfincas vf');
    tc.SQL.Add('where sf.id = vf.idsector');
    tc.SQL.Add('group by id');
    tc.open;
    TTabla.Close;
    TTabla.TableName := 'ttsectores';
    TTabla.Exclusive := true;
    TTabla.EmptyTable;
    TTabla.Exclusive := false;
    TTabla.Open;
    while not tc.Eof do
    begin
      TTabla.Insert;
      TTabla.FieldByName('IDSector').Value := tc.fieldbyname('IDSector').AsFloat;
      TTabla.FieldByName('Pies').Value := tc.fieldbyname('Pies').AsFloat;
      TTabla.Post;
      tc.Next;
    end;
    tc.Close;
    tc.SQL.Clear;
    tc.SQL.Add('SELECT ar.id IDParte, ar.fecha, ar.tecnico, f.nombre Finca, sf.nombre Sector, ');
    tc.SQL.Add('  arp.unidad, p.nombre Producto, f.ID IDFinca, sf.ID IDSector, p.ID IDProducto,');
    tc.SQL.Add('  v.nombre Variedad, v.ID IDVariedad, (vf.numarboles * arp.totalproducto) / ts.pies CantidadProducto');
    tc.SQL.Add('FROM aguariego ar, fincas f, sectoresfincas sf, aguariegoproductos arp, producto p,');
    tc.SQL.Add('  variedadesfincas vf, variedades v, ttsectores ts');
    tc.SQL.Add('WHERE (ar.idfinca = f.id) AND (ar.idsector = sf.id)');
    tc.SQL.Add('  and (ar.id = arp.idagua) and (arp.idproducto = p.id)');
    tc.SQL.Add('  and (sf.id = vf.idsector) and (v.id = vf.idvariedad)');
    tc.SQL.Add('  and (ts.idsector = sf.id) and ');

    aplicarFiltroCertificacion ();    

    tc.SQL.Add(' ar.Fecha BETWEEN :pFechaDesde AND :pFechaHasta');
    tc.SQL.Add('  AND vf.IDVariedad BETWEEN :pDV AND :pHV');
    tc.SQL.Add('  AND f.ID BETWEEN :pDF AND :pHF');
    tc.ParamByName('pFechaDesde').DataType := ftDate;
    tc.ParamByName('pFechaDesde').Value := StrToDate(TxtFiltroFecha.Text);
    tc.ParamByName('pFechaHasta').DataType := ftDate;
    tc.ParamByName('pFechaHasta').Value := StrToDate(TxtFiltroFechaHasta.Text);
    tc.ParamByName('pDV').DataType := ftFloat;
    tc.ParamByName('pDV').Value := StrToFloat(txtDesdeVariedad.Text);
    tc.ParamByName('pHV').DataType := ftFloat;
    tc.ParamByName('pHV').Value := StrToFloat(txtHastaVariedad.Text);
    tc.ParamByName('pDF').DataType := ftFloat;
    tc.ParamByName('pDF').Value := StrToFloat(txtDesdeFinca.Text);
    tc.ParamByName('pHF').DataType := ftFloat;
    tc.ParamByName('pHF').Value := StrToFloat(txtHastaFinca.Text);
    tc.Open;

    while not TC.Eof do
    begin
      tImpresion.Insert;
      tImpresion.FieldByName('Fecha').Value := TC.Fieldbyname ('Fecha').AsDateTime;
      tImpresion.FieldByName('IDFinca').Value := TC.Fieldbyname ('IDFinca').AsFloat;
      tImpresion.FieldByName('IDSector').Value := TC.Fieldbyname ('IDSector').AsFloat;
      tImpresion.FieldByName('IDVariedad').Value := TC.Fieldbyname ('IDVariedad').AsFloat;
      tImpresion.FieldByName('IDProducto').Value := TC.Fieldbyname ('IDProducto').AsFloat;
      tImpresion.FieldByName('Finca').Value := TC.Fieldbyname ('Finca').AsString;
      tImpresion.FieldByName('Sector').Value := TC.Fieldbyname ('Sector').AsString;
      tImpresion.FieldByName('Variedad').Value := TC.Fieldbyname ('Variedad').AsString;
      tImpresion.FieldByName('Producto').Value := TC.Fieldbyname ('Producto').AsString;
      tImpresion.FieldByName('Cantidad').Value := TC.Fieldbyname ('CantidadProducto').AsFloat;
      //tImpresion.FieldByName('Dosis').Value := TC.Fieldbyname ('DosisProducto').AsFloat;
      //tImpresion.FieldByName('UnidadDosis').Value := TC.Fieldbyname ('UnidadDosis').AsString;
      tImpresion.FieldByName('Unidad').Value := TC.Fieldbyname ('Unidad').AsString;
      tImpresion.FieldByName('IDParte').Value := TC.Fieldbyname ('IDParte').AsFloat;
      //tImpresion.FieldByName('Materia').Value := TC.Fieldbyname ('Materia').AsString;
      //tImpresion.FieldByName('PorcentajeMateria').Value := TC.Fieldbyname ('PorcentajeMateria').AsFloat;
      tImpresion.FieldByName('Tecnico').Value := TC.Fieldbyname ('Tecnico').AsString;
      tImpresion.Post;
      tc.Next;
    end;
    tImpresion.Close;
    dbImpresion.Close;
    TC.Close;
    TTabla.Close;
    Application.ProcessMessages;
    F := application.findcomponent('formSeleccionInforme') as TForm;
    if Assigned(F) then
      f.showmodal
    else
    begin
      application.createform(TformSeleccionInforme, formSeleccionInforme);
      if opTratamientos.Checked then
        formSeleccionInforme.Tag := 20;
      if opAbonados.Checked then
        formSeleccionInforme.Tag := 170;
      formSeleccionInforme.showmodal;
    end;
  end;
end;

procedure TformImpresionTrazabilidad.actCerrarExecute(Sender: TObject);
begin
  close;
end;

procedure TformImpresionTrazabilidad.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  action := caFree;
end;

procedure TformImpresionTrazabilidad.FormCreate(Sender: TObject);
begin
  TxtFiltroFecha.Text := DateToStr(VTInicioEmpresa);
  TxtFiltroFechaHasta.Text := DateToStr(VTFinEmpresa);
  cbTipoCert.ItemIndex := 0;

  //si no existe el fichero temporal lo creamos
  if not fileexists(VTRutaEmpresa + '\ttmaterias.db') then
  begin
    with TTabla do
    begin
      close;
      TableName := 'ttmaterias.DB';
      TableType := ttParadox;
      with FieldDefs do
      begin
        Clear;
        Add('IDProducto', ftFloat, 0, false);
        Add('Numero', ftFloat, 0, False);
      end;
      IndexDefs.Clear;
      CreateTable;
      Open;
    end;
  end;

  //si no existe el fichero temporal lo creamos
  if not fileexists(VTRutaEmpresa + '\ttsectores.db') then
  begin
    with TTabla do
    begin
      close;
      TableName := 'ttsectores.db';
      TableType := ttParadox;
      with FieldDefs do
      begin
        Clear;
        Add('IDSector', ftFloat, 0, false);
        Add('Pies', ftFloat, 0, False);
      end;
      IndexDefs.Clear;
      CreateTable;
      Open;
    end;
  end;


end;

procedure TformImpresionTrazabilidad.bDFincaClick(Sender: TObject);
begin
  application.createform(tformseleccion, formseleccion);
  formseleccion.tag := 60;
  formseleccion.ShowModal;
  if claveelegida <> '' then
    txtDesdeFinca.Text := claveelegida;
end;

procedure TformImpresionTrazabilidad.bHFincaClick(Sender: TObject);
begin
  application.createform(tformseleccion, formseleccion);
  formseleccion.tag := 60;
  formseleccion.ShowModal;
  if claveelegida <> '' then
    txtHastaFinca.Text := claveelegida;
end;

procedure TformImpresionTrazabilidad.txtDesdeFincaExit(Sender: TObject);
begin
  if esNumero (txtDesdeFinca.text) < 0 then
  begin
    msinfo('Debe introducir un nmero entre 0 y 99999.',
        'Nmero incorrecto...');
    txtDesdeFinca.SelectAll;
    txtDesdeFinca.SetFocus;
  end;
end;

procedure TformImpresionTrazabilidad.txtDesdeFincaKeyPress(Sender: TObject; var Key: Char);
begin
  if key = '+' then
  begin
    key := chr(0);
    bDFincaClick(NIL);
  end;
end;

procedure TformImpresionTrazabilidad.txtHastaFincaExit(Sender: TObject);
begin
  if esNumero (txtHastaFinca.text) < 0 then
  begin
    msinfo('Debe introducir un nmero entre 0 y 99999.',
        'Nmero incorrecto...');
    txtHastaFinca.SelectAll;
    txtHastaFinca.SetFocus;
  end;
end;

procedure TformImpresionTrazabilidad.txtHastaFincaKeyPress(Sender: TObject; var Key: Char);
begin
  if key = '+' then
  begin
    key := chr(0);
    bHFincaClick(NIL);
  end;
end;

procedure TformImpresionTrazabilidad.SpeedButton1Click(Sender: TObject);
begin
  application.createform(tformseleccion, formseleccion);
  formseleccion.tag := 60;
  formseleccion.ShowModal;
  if claveelegida <> '' then
    txtDesdeFinca.Text := claveelegida;
end;

procedure TformImpresionTrazabilidad.bDVariedadClick(Sender: TObject);
begin
  application.createform(tformseleccion, formseleccion);
  formseleccion.tag := 30;
  formseleccion.ShowModal;
  if claveelegida <> '' then
    txtDesdeVariedad.Text := claveelegida;
end;

procedure TformImpresionTrazabilidad.bHVariedadClick(Sender: TObject);
begin
  application.createform(tformseleccion, formseleccion);
  formseleccion.tag := 30;
  formseleccion.ShowModal;
  if claveelegida <> '' then
    txtHastaVariedad.Text := claveelegida;
end;

procedure TformImpresionTrazabilidad.txtDesdeVariedadExit(Sender: TObject);
begin
  if esNumero (txtDesdeVariedad.text) < 0 then
  begin
    msinfo('Debe introducir un nmero entre 0 y 99999.',
        'Nmero incorrecto...');
    txtDesdeVariedad.SelectAll;
    txtDesdeVariedad.SetFocus;
  end;
end;

procedure TformImpresionTrazabilidad.txtDesdeVariedadKeyPress(
  Sender: TObject; var Key: Char);
begin
  if key = '+' then
  begin
    key := chr(0);
    bDVariedadClick(NIL);
  end;
end;

procedure TformImpresionTrazabilidad.txtHastaVariedadKeyPress(
  Sender: TObject; var Key: Char);
begin
  if key = '+' then
  begin
    key := chr(0);
    bHVariedadClick(NIL);
  end;
end;

procedure TformImpresionTrazabilidad.txtHastaVariedadExit(Sender: TObject);
begin
  if esNumero (txtHastaVariedad.text) < 0 then
  begin
    msinfo('Debe introducir un nmero entre 0 y 99999.',
        'Nmero incorrecto...');
    txtHastaVariedad.SelectAll;
    txtHastaVariedad.SetFocus;
  end;
end;

end.
