unit UnidadInformacionCampos;

interface

uses
  Windows, printers,Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Db, DBTables, QuickRpt, Qrctrls, ExtCtrls;

type
  TFormInformacionCampos = class(TForm)
    ListBox1: TListBox;
    ListBox2: TListBox;
    Memo1: TMemo;
    InfoBtn: TBitBtn;
    BitBtn1: TBitBtn;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure InfoBtnClick(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormInformacionCampos: TFormInformacionCampos;

implementation

uses TypInfo;

{$R *.DFM}

procedure TFormInformacionCampos.FormCreate(Sender: TObject);
begin
  Session.GetAliasNames(ListBox1.Items);
end;

procedure TFormInformacionCampos.ListBox1Click(Sender: TObject);
begin
  Session.GetTableNames(ListBox1.Items[ListBox1.ItemIndex], '', True, False,
    ListBox2.Items);
end;

procedure LeerDefinicion(const ADB, ATable: string; Lista: TStrings);
var
  I: Integer;
  S: string;
begin
  with TTable.Create(nil) do
  try
    DatabaseName := ADB;
    TableName := ATable;
    FieldDefs.Update;
    Lista.BeginUpdate;
    try
      Lista.Add('***** TABLA:  ' + ATable + '  Campos:');
      for I := 0 to FieldDefs.Count - 1 do
        with FieldDefs.Items[I] do
        begin
          S := GetEnumName(TypeInfo(TFieldType), Ord(DataType));
          S := #9 + Name + ' ' + Copy(S, 3, Length(S) - 2);
          if Size <> 0 then
            S := S + '(' + IntToStr(Size) + ')';
          if Required then
            AppendStr(S, ' Requerido');
          if I < FieldDefs.Count - 1 then
            AppendStr(S, ',');
          Lista.Add(S);
        end;
      Lista.Add(')');
    finally
      Lista.EndUpdate;
    end;
  finally
    Free;
  end;
end;

procedure TFormInformacionCampos.InfoBtnClick(Sender: TObject);
begin
  if ListBox2.ItemIndex = -1 then Exit;
  LeerDefinicion(ListBox1.Items[ListBox1.ItemIndex],
    ListBox2.Items[ListBox2.ItemIndex],
    Memo1.Lines);
end;

procedure TFormInformacionCampos.BitBtn1Click(Sender: TObject);
var
  Impresora: textfile;
begin
  with printer do
  begin
    assignprn(Impresora);
    rewrite(impresora);
    writeln(impresora,memo1.text);
    closefile(impresora);
  end;
end;

end.
