unit UnidadProcedimientos;

interface

uses classes, dbierrs, dbtables, SysUtils, registry,
  Windows, Messages, Variants, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ShellCtrls, Buttons, DB, ExtCtrls,
  Grids, DBGrids, shellapi,inifiles;

  function bdeInstalado () : boolean;
  procedure CrearAlias (nombre, ruta : string);
  procedure noRegistrada ();
  function ejecutadaYa (nombreAplicacion : string) : boolean;
  function leeRegistro (desdeClave : HKEY; ruta, cadena : string;
                        crear : boolean) : string;
  procedure escribeRegistro (desdeClave : HKEY; ruta, cadena, valor : string;
                             crear : boolean);
  function pMes (mes : integer) : string;
  function pFecha (dia, mes, ano : word) : tdate;
  function esNumero (valor : string) : integer;
  procedure msError (mensaje, titulo : String);
  procedure msInfo (mensaje, titulo : String);
  function msSi (mensaje, titulo : String) : boolean;
  function msSin (mensaje, titulo : String) : boolean;
  function msOK (mensaje, titulo : String) : boolean;
  function msOKn (mensaje, titulo : String) : boolean;
  procedure msAtencion (mensaje, titulo : String);
  function CalcularDC (Entidad, Cuenta: string) : integer;
  function CalcularPiesVariedad (Variedad : String) : double;
  function CalcularSuperficieVariedad (Variedad : Integer) : double;
  function CalcularPiesTotal () : double;
  function CalcularSuperficieTotal () : double;
  function CalcularKgTotal () : double;
  function CalcularPiesFinca (Finca : Integer) : double;
  function CalcularSuperficieFinca (Finca : Integer) : double;
  function CalcularPiesFincaSectorVariedad (Finca, Sector, Variedad : integer) : double;
  function CalcularSuperficieFincaSectorVariedad (Finca, Sector, Variedad : integer) : double;
  function CalcularPiesFincaVariedad (Finca, Variedad : integer) : double;
  function CalcularPiesSector (Sector : Integer) : double;


  Function CompHD : string;
  procedure Carpeta (Numero: integer);
  function reemplazarTexto (cadena, textoAReemplazar, textoNuevo : string) : string;
  function Redondear (Numero : Double; PrecisionDec : byte) : double;
  function ValidarCIF (Cif : string) : boolean;
  function leBoolINI (clave, cadena : string; defecto : boolean) : boolean;
  function leEntINI (clave, cadena : string; defecto : integer) : integer;
  function leCadINI (clave, cadena : string; defecto : string) : string;
  procedure esBoolINI (clave, cadena : string; valor : boolean);
  procedure esEntINI (clave, cadena : string; valor : integer);
  procedure esCadINI (clave, cadena, valor : string);
  procedure esFloatINI (clave, cadena : string; valor : double);
  procedure esFechaINI (clave, cadena : string; defecto : tdatetime);
  function leFechaINI (clave, cadena : string; defecto : tdatetime) : tdatetime;
  function leFloatINI (clave, cadena : string; defecto : double) : double;
  function fechaEnPeriodo (fecha : tdatetime; mensaje : boolean) : boolean;

  var
    VTIDEmpresa, vtejecucionsiempre:integer;
    VTNombreEmpresa, VTNombreAplicacion, VTVersionAplicacion: String;
    VTRutaEmpresa, VTMonedaEmpresa, VTContrasena, VTUsuario: String;
    VTCambioMonedaEmpresa: double;
    VTInicioEmpresa, VTFinEmpresa, VTFCInicio, VTFCFin : tdatetime;
    VTEtiquetas, VTEstadoCarga, VTMostrarBB,
        VTEnvaseSeparar, VTEmpresaAnterior: integer;
    VTPreciosSinIVA: integer;
    VTKgCaja, VTPorcentajeMinimo, VTPorcentajeMaximo: double;
    VTAvisarObreroCuadrilla : integer;
    VTRutaLogotipo, vtfechas, vtinscripcion: string;
    VTCIF, VTTelefono, VTCP, VTProvincia, VTPoblacion: String;
    VTDomicilio: String;
    VTVersionCompleta : integer;
    vtmostrarempresas : integer;
    vtnumeroserie : string;
    claveElegida : string;
    vtFechaTrabajo : tdatetime;
    cancelarProcesoActual : boolean;

implementation

function ValidarCIF (Cif : string) : boolean;
  var
  Suma, Control : integer;
  n : byte;
begin
  Result:=False;
  Cif:=UpperCase(Cif);
  {El cif debe ser de 9 cifras}
  if Length(Cif)=9 then
  begin
    Suma:= StrToInt(Cif[3])+
    StrToInt(Cif[5])+
    StrToInt(Cif[7]);
    for n := 1 to 4 do
    begin
      Suma:=Suma+ ( (2*StrToInt(Cif[2*n])) mod 10 )+
      ( (2*StrToInt(Cif[2*n])) div 10 );
    end;
    Control := 10-(Suma mod 10);
    if Pos(Cif[1],'XP') <> 0 then
      {Control tipo letra}
      Result:= ( Cif[9] = Chr(64+ Control))
    else
    begin
      {Control tipo nmero}
      if Control =10 then
        Control := 0;
      Result:= ( StrToInt(Cif[9]) = Control);
    end;
  end;
end;

function leBoolINI (clave, cadena : string; defecto : boolean) : boolean;
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    result := readbool (clave, cadena, defecto);
  finally
    free;
  end;
end;

function fechaEnPeriodo (fecha : tdatetime; mensaje : boolean) : boolean;
begin
  if (fecha < vTInicioEmpresa) or
     (fecha > vtfinempresa) then
  begin
    if mensaje then
    begin
      msatencion ('La fecha ' + datetostr(fecha) + ' no est comprendida ' +
          'en el perodo de trabajo de la empresa activa ' +
          ' de ' + datetostr(vtinicioempresa) +
          ' a ' + datetostr(vtfinempresa) + #13 + #13 +
          '   Es recomendable utilizar fechas comprendidas en este perodo.',
          'Fecha fuera de perodo...');
    end;
    fechaEnPeriodo := False;
  end
  else
    fechaenperiodo := true;
end;

function leEntINI (clave, cadena : string; defecto : integer) : integer;
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    result := readInteger (clave, cadena, defecto);
  finally
    free;
  end;
end;

function leCadINI (clave, cadena : string; defecto : string) : string;
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    result := readString (clave, cadena, defecto);
  finally
    free;
  end;
end;

procedure esBoolINI (clave, cadena : string; valor : boolean);
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    writeBool (clave, cadena, valor);
  finally
    free;
  end;
end;

procedure esEntINI (clave, cadena : string; valor : integer);
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    writeInteger (clave, cadena, valor);
  finally
    free;
  end;
end;

procedure esCadINI (clave, cadena, valor : string);
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    writeString (clave, cadena, valor);
  finally
    free;
  end;
end;

procedure esFloatINI (clave, cadena : string; valor : double);
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    WriteFloat (clave, cadena, valor);
  finally
    free;
  end;
end;

procedure esFechaINI (clave, cadena : string; defecto : tdatetime);
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    WriteDate (clave, cadena, defecto);
  finally
    free;
  end;
end;

function leFechaINI (clave, cadena : string; defecto : tdatetime) : tdatetime;
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    result := ReadDate (clave, cadena, defecto);
  finally
    free;
  end;
end;

function leFloatINI (clave, cadena : string; defecto : double) : double;
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    result := readfloat (clave, cadena, defecto);
  finally
    free;
  end;
end;


function Redondear (Numero : Double; PrecisionDec : byte) : double;
  function Potencia(Base : Double; Exponente : byte) : Double;
  begin
    Result := Exp(Exponente * ln(Base));
  end;
begin
  result := Round(Numero * Potencia(10, PrecisionDec)) / Potencia (10, PrecisionDec);
end;

//para saber si est instaldo el BDE
function fDbiGetSysVersion(SysVerList: TStringList): SYSVersion;
var
  Month, Day, iHour, iMin, iSec: Word;
  Year: SmallInt;
begin
  Check(DbiGetSysVersion(Result));
  if (SysVerList <> nil) then
  begin
    with SysVerList do
    begin
      Clear;
      Add(Format('ENGINE VERSION=%d', [Result.iVersion]));
      Add(Format('INTERFACE LEVEL=%d', [Result.iIntfLevel]));
      Check(DbiDateDecode(Result.dateVer, Month, Day, Year));
      Add(Format('VERSION DATE=%s', [DateToStr(EncodeDate
                (Year, Month, Day))]));
      Check(DbiTimeDecode(Result.timeVer, iHour, iMin, iSec));
      Add(Format('VERSION TIME=%s', [TimeToStr(EncodeTime
                (iHour, iMin, iSec div 1000, iSec div 100))]));
    end;
  end;
end;

//Para saber si est el BDE instalado
function bdeInstalado () : boolean;
var
  hStrList : TStringList;
  Ver : SYSVersion;
begin
{  Reg := TRegistry.Create;
  Reg.RootKey := HKEY_CURRENT_USER;
  reg.RootKey := HKEY_LOCAL_MACHINE;
  reg.OpenKey('SOFTWARE\Borland\Database Engine', False);
  s := '';
  try
    s := reg.ReadString('CONFIGFILE01');
  finally
    reg.CloseKey;
  end;
  if s = '' then
  begin
    bdeinstalado := false;
    exit;
  end;}
  hStrList := TStringList.Create;
  try
    Ver := fDbiGetSysVersion(hStrList);
  except
    bdeInstalado := false;
    exit;
  end;
  bdeInstalado := true;
end;


//Mostrar mensaje de Aplicacin no registrada
procedure noRegistrada ();
begin
    Application.MessageBox ('Atencin: esta aplicacin no est registrada, para registrarla ' +
        'consulte con AjpdSoft.' + chr(13) + chr(13) +
        '   E-Mail: incidencias@ajpdsoft.com' + chr(13) + chr(13) +
        '   Web: http://www.ajpdsoft.com', 'Aplicacin no registrada...', (MB_OK + MB_ICONSTOP));
   application.terminate;
   exit;
   halt;
end;


//Crear un alias persistente
procedure CrearAlias (nombre, ruta : string);
Var
  AliasFound: Boolean;
  TmpCursor: hDBICur;
  Rslt: DBIResult;
  Database: DBDesc;
Begin
  Check(DbiInit(nil));
  try
    Check(DbiOpenDatabaseList(TmpCursor));
    AliasFound := False;
    repeat
      rslt:= DbiGetNextRecord(TmpCursor, dbiNOLOCK, @Database, nil);
      if (rslt <> DBIERR_EOF) then
        if StrPas(Database.szName) = nombre then
        begin
          {Ya existe el alias}
          AliasFound := True;
          Break
        end;
    until rslt <> DBIERR_NONE;
    Check(DbiCloseCursor(TmpCursor));
    if not AliasFound then
      {If the alias was not found, add it to IDAPI.CFG}
      Check(DbiAddAlias(nil,PChar(nombre), szPARADOX,
         PChar(ruta), True));
  finally
    DbiExit;
  end;
end;



//Comprueba si la aplicacin est ejecutndose ya
function ejecutadaYa (nombreAplicacion : string) : boolean;
var
  MiMutex : Thandle;
begin
  mimutex := CreateMutex(nil, true, pchar(nombreAplicacion));
  if MiMutex = 0 then
    result := false
  else
  begin
    if GetLastError = ERROR_ALREADY_EXISTS then
      result := true
    else
      result := false;  
  end;
end;


//Leer valor del Regedit
function leeRegistro (desdeClave : HKEY; ruta, cadena : string;
                      crear : boolean) : string;
var
  reg : TRegistry;
begin
  Reg := TRegistry.Create;
  try
    Reg.RootKey := desdeClave;
    Reg.OpenKey(ruta, crear);
    leeRegistro := Reg.ReadString(cadena);
  finally
    reg.Free;
  end;
end;


//Escribe valor en el Regedit
procedure escribeRegistro (desdeClave : HKEY; ruta, cadena, valor : string;
                      crear : boolean);
var
  reg : TRegistry;
begin
  Reg := TRegistry.Create;
  try
    Reg.RootKey := desdeClave;
    Reg.OpenKey(ruta, crear);
    Reg.WriteString(cadena, valor);
  finally
    reg.Free;
  end;
end;


//Comprueba si un valor es numrico
function esNumero (valor : string) : integer;
var
  numero : integer;
begin
  try
    numero := strtoint(valor);
  except
    result := -1;
    exit;
  end;
  result := numero;
end;


//Devuelve la fecha a partir de da, mes, ao
function pFecha (dia, mes, ano : word) : tdate;
begin
  result := EncodeDate (ano,mes,dia);
end;


//Devuelve el nombre del mes segn el nmero
function pMes (mes : integer) : string;
begin
  case mes of
    1 : result := 'Enero';
    2 : result := 'Febrero';
    3 : result := 'Marzo';
    4 : result := 'Abril';
    5 : result := 'Mayo';
    6 : result := 'Junio';
    7 : result := 'Julio';
    8 : result := 'Agosto';
    9 : result := 'Septiembre';
    10 : result := 'Octubre';
    11 : result := 'Noviembre';
    12 : result := 'Diciembre';
  end;
end;


//MENSAJES
procedure msError (mensaje, titulo : String);
begin
  application.MessageBox(pchar(mensaje),
      pchar(titulo), (MB_OK + MB_ICONSTOP));
end;

procedure msInfo (mensaje, titulo : String);
begin
  application.MessageBox(pchar(mensaje),
      pchar(titulo), (MB_OK + MB_ICONINFORMATION));
end;

function msSi (mensaje, titulo : String) : boolean;
begin
  if application.MessageBox (pchar(mensaje),
      pchar(titulo), (MB_YESNO + MB_ICONQUESTION)) = IDYES then
    result := true
  else
    result := false;
end;

function msSin (mensaje, titulo : String) : boolean;
begin
  if application.MessageBox (pchar(mensaje),
      pchar(titulo), (MB_YESNO + MB_DEFBUTTON2 + MB_ICONQUESTION)) = IDYES then
    result := true
  else
    result := false;
end;


function msOK (mensaje, titulo : String) : boolean;
begin
  if application.MessageBox (pchar(mensaje),
      pchar(titulo), (MB_OKCANCEL + MB_ICONWARNING)) = IDOK then
    result := true
  else
    result := false;
end;

function msOKn (mensaje, titulo : String) : boolean;
begin
  if application.MessageBox (pchar(mensaje),
      pchar(titulo), (MB_OKCANCEL + MB_DEFBUTTON2 + MB_ICONWARNING)) = IDOK then
    result := true
  else
    result := false;
end;


procedure msAtencion (mensaje, titulo : String);
begin
  application.MessageBox(pchar(mensaje),
      pchar(titulo), (MB_OK + MB_ICONWARNING));
end;


//Calcula el dgito de control pasando como parmetro la Entidad
//y la oficina juntas y la cuenta
function CalcularDC (Entidad, Cuenta: string) : integer;
const
  Pesos: array[0..9] of integer = (6,3,7,9,10,5,8,4,2,1);
var
  n : byte;
  iTemp : integer;
begin
  iTemp := 0;
  for n := 0 to 7 do
  begin
    iTemp := iTemp + StrToInt(Copy(Entidad, 8 - n, 1)) * Pesos[n];
  end;
  Result := 11 - iTemp Mod 11;
  if (Result > 9) then
    Result := 1 - Result mod 10;
  iTemp := 0;
  For n := 0 to 9 do
   iTemp := iTemp + StrToInt(Copy(Cuenta, 10 - n, 1)) * Pesos[n];
  iTemp := 11 - iTemp mod 11;
  if (iTemp > 9) then
    iTemp := 1 - iTemp mod 10;
  Result := Result * 10 + iTemp;
end;

//Calcula el nmero de pies de una variedad pasada como parmetro
function CalcularPiesVariedad (Variedad : String) : double;
var
  ttabla : TQuery;
begin
  ttabla := tquery.create(nil);
  ttabla.DatabaseName := 'ACampo';
  with ttabla do
  begin
    SQL.Clear;
    SQL.Add('Select sum(v.NumArboles) as Total');
    SQL.Add('from variedadesfincas v');
    SQL.Add('where v.IDVariedad IN (');
    SQL.Add('Select ID');
    SQL.Add('from variedades');
    SQL.Add('where nombre = :pVariedad)');
    ParamByName('pVariedad').DataType := ftString;
    ParamByName('pVariedad').Value := variedad;
    open;
    if not varisnull(FieldByName('Total').value) then
      result :=  FieldByName('Total').value
    else
      result := 0;
    close;
  end;
end;

//Calcula el nmero de pies de una finca, sector y variedad pasados como parmetro
function CalcularPiesFincaSectorVariedad (Finca, Sector, Variedad : integer) : double;
var
  ttabla : TQuery;
begin
  ttabla := tquery.create(nil);
  ttabla.DatabaseName := 'ACampo';
  with ttabla do
  begin
    SQL.Clear;
    SQL.Add('Select sum(v.NumArboles) as Total');
    SQL.Add('from variedadesfincas v');
    SQL.Add('where v.IDVariedad = :pIDVariedad and v.IDSector = :pIDSector and v.IDFinca = :pIDFinca');
    ParamByName('pIDFinca').DataType := ftInteger;
    ParamByName('pIDFinca').Value := Finca;
    ParamByName('pIDVariedad').DataType := ftInteger;
    ParamByName('pIDVariedad').Value := Variedad;
    ParamByName('pIDSector').DataType := ftInteger;
    ParamByName('pIDSector').Value := Sector;
    open;
    if not varisnull(FieldByName('Total').value) then
      result :=  FieldByName('Total').value
    else
      result := 0;
    close;
  end;
end;

//Calcula el nmero de pies de una finca y variedad pasados como parmetro
function CalcularPiesFincaVariedad (Finca, Variedad : integer) : double;
var
  ttabla : TQuery;
begin
  ttabla := tquery.create(nil);
  ttabla.DatabaseName := 'ACampo';
  with ttabla do
  begin
    SQL.Clear;
    SQL.Add('Select sum(v.NumArboles) as Total');
    SQL.Add('from variedadesfincas v');
    SQL.Add('where v.IDVariedad = :pIDVariedad and v.IDFinca = :pIDFinca');
    ParamByName('pIDFinca').DataType := ftInteger;
    ParamByName('pIDFinca').Value := Finca;
    ParamByName('pIDVariedad').DataType := ftInteger;
    ParamByName('pIDVariedad').Value := Variedad;
    open;
    if not varisnull(FieldByName('Total').value) then
      result :=  FieldByName('Total').value
    else
      result := 0;
    close;
  end;
end;

//Calcula la superficie de una finca, sector y variedad pasados como parmetro
function CalcularSuperficieFincaSectorVariedad (Finca, Sector, Variedad : integer) : double;
var
  ttabla : TQuery;
begin
  ttabla := tquery.create(nil);
  ttabla.DatabaseName := 'ACampo';
  with ttabla do
  begin
    SQL.Clear;
    SQL.Add('Select sum(v.Superficie) as Total');
    SQL.Add('from variedadesfincas v');
    SQL.Add('where v.IDVariedad = :pIDVariedad and v.IDSector = :pIDSector and v.IDFinca = :pIDFinca');
    ParamByName('pIDFinca').DataType := ftInteger;
    ParamByName('pIDFinca').Value := Finca;
    ParamByName('pIDVariedad').DataType := ftInteger;
    ParamByName('pIDVariedad').Value := Variedad;
    ParamByName('pIDSector').DataType := ftInteger;
    ParamByName('pIDSector').Value := Sector;
    open;
    if not varisnull(FieldByName('Total').value) then
      result :=  FieldByName('Total').value
    else
      result := 0;
    close;
  end;
end;

//Calcula el nmero de pies de una finca pasada como parmetro
function CalcularPiesFinca (Finca : Integer) : double;
var
  ttabla : TQuery;
begin
  ttabla := tquery.create(nil);
  ttabla.DatabaseName := 'ACampo';
  with ttabla do
  begin
    SQL.Clear;
    SQL.Add('Select sum(v.NumArboles) as Total');
    SQL.Add('from variedadesfincas v');
    SQL.Add('where v.IDFinca = :pIDFinca');
    ParamByName('pIDFinca').DataType := ftInteger;
    ParamByName('pIDFinca').Value := Finca;
    open;
    if not varisnull(FieldByName('Total').value) then
      result :=  FieldByName('Total').value
    else
      result := 0;
    close;  
  end;
end;


//Calcula el nmero de pies de un sector pasada como parmetro
function CalcularPiesSector (Sector : Integer) : double;
var
  ttabla : TQuery;
begin
  ttabla := tquery.create(nil);
  ttabla.DatabaseName := 'ACampo';
  with ttabla do
  begin
    SQL.Clear;
    SQL.Add('Select sum(v.NumArboles) as Total');
    SQL.Add('from variedadesfincas v');
    SQL.Add('where v.IDSector = :pIDSector');
    ParamByName('pIDSector').DataType := ftInteger;
    ParamByName('pIDSector').Value := Sector;
    open;
    if not varisnull(FieldByName('Total').value) then
      result :=  FieldByName('Total').value
    else
      result := 0;
    close;
  end;
end;

//Calcula el nmero de pies total de la empresa
function CalcularPiesTotal () : double;
var
  ttabla : TQuery;
begin
  ttabla := tquery.create(nil);
  ttabla.DatabaseName := 'ACampo';
  with ttabla do
  begin
    SQL.Clear;
    SQL.Add('Select sum(v.NumArboles) as Total');
    SQL.Add('from variedadesfincas v');
    open;
    if not varisnull(FieldByName('Total').value) then
      result :=  FieldByName('Total').value
    else
      result := 0;
    close;  
  end;
end;

//Calcula la superficie total de la empresa
function CalcularSuperficieTotal () : double;
var
  ttabla : TQuery;
begin
  ttabla := tquery.create(nil);
  ttabla.DatabaseName := 'ACampo';
  with ttabla do
  begin
    SQL.Clear;
    SQL.Add('Select sum(v.Superficie) as Total');
    SQL.Add('from variedadesfincas v');
    open;
    if not varisnull(FieldByName('Total').value) then
      result :=  FieldByName('Total').value
    else
      result := 0;
    close;
  end;
end;

//Calcula los KGs totales de la empresa
function CalcularKgTotal () : double;
var
  ttabla : TQuery;
begin
  ttabla := tquery.create(nil);
  ttabla.DatabaseName := 'ACampo';
  with ttabla do
  begin
    SQL.Clear;
    SQL.Add('Select sum(v.PesoNeto) as Total');
    SQL.Add('from variedadesvales v');
    open;
    if not varisnull(FieldByName('Total').value) then
      result :=  FieldByName('Total').value
    else
      result := 0;
    close;
  end;
end;

//Calcula la superficie una finca pasada como parmetro
function CalcularSuperficieFinca (Finca : Integer) : double;
var
  ttabla : TQuery;
begin
  ttabla := tquery.create(nil);
  ttabla.DatabaseName := 'ACampo';
  with ttabla do
  begin
    SQL.Clear;
    SQL.Add('Select sum(v.Superficie) as Total');
    SQL.Add('from variedadesfincas v');
    SQL.Add('where v.IDFinca = :pIDFinca');
    ParamByName('pIDFinca').DataType := ftInteger;
    ParamByName('pIDFinca').Value := Finca;
    open;
    if not varisnull(FieldByName('Total').value) then
      result :=  FieldByName('Total').value
    else
      result := 0;
    close;
  end;
end;

//Calcula la superficie una variedad pasada como parmetro
function CalcularSuperficieVariedad (Variedad : Integer) : double;
var
  ttabla : TQuery;
begin
  ttabla := tquery.create(nil);
  ttabla.DatabaseName := 'ACampo';
  with ttabla do
  begin
    SQL.Clear;
    SQL.Add('Select sum(v.Superficie) as Total');
    SQL.Add('from variedadesfincas v');
    SQL.Add('where v.IDVariedad = :pIDVariedad');
    ParamByName('pIDVariedad').DataType := ftInteger;
    ParamByName('pIDVariedad').Value := Variedad;
    open;
    if not varisnull(FieldByName('Total').value) then
      result :=  FieldByName('Total').value
    else
      result := 0;
    close;
  end;
end;

//Devuelve el Nmero de serie del HD
Function CompHD : string;
Var
  VolumeNameBuffer : array [0..MAX_PATH] of Char;
  VolumeSerialNumber : DWord;
  MaximumComponentLength : DWord;
  FileSystemFlags : DWord;
Begin
  GetVolumeInformation( '\',VolumeNameBuffer,
    DWORD(sizeof(VolumeNameBuffer)),@VolumeSerialNumber,
    MaximumComponentLength,FileSystemFlags,nil,0);
  result := IntToHEX(VolumeSerialNumber,8);
End;


procedure Carpeta (Numero: integer);
  //Blocked function
  function GetWinDir: String;
  var
     Buffer: array[0..MAX_PATH] of Char;
  begin
       GetWindowsDirectory(Buffer, SizeOf(Buffer));
       SetString(Result, Buffer, StrLen(Buffer));
  end;
var
   Arg: String;
begin
  case numero of
    // My Computer
    0: Arg := ' ::{20D04FE0-3AEA-1069-A2D8-08002B30309D}';
    // Network Neighborhood
    1: Arg := ' ::{208D2C60-3AEA-1069-A2D7-08002B30309D}';
    // Control Panel
    2: Arg := ' ::{20D04FE0-3AEA-1069-A2D8-08002B30309D}\::{21EC2020-3AEA-1069-A2DD-8002B30309D}';
    // Dial-up Networking
    3: Arg := ' ::{20D04FE0-3AEA-1069-A2D8-08002B30309D}\::{992CFFA0-F557-101A-88EC-00DD010CCC48}';
    // Recycle Bin
    4: Arg := ' ::{645FF040-5081-101B-9F08-00AA002F954E}';
    // Printers
    5: Arg := ' ::{20D04FE0-3AEA-1069-A2D8-08002B30309D}\::{2227A280-3AEA-1069-A2DE-08002B30309D}';
    // Scheduled Tasks
    6: Arg := ' ::{20D04FE0-3AEA-1069-A2D8-08002B30309D}\::{D6277990-4C6A-11CF-8D87-00AA0060F5BF}';
  end; //case
  ShellExecute(Application.Handle, 'Open', PChar(GetWinDir + '\explorer.exe'), PChar(Arg), nil, SW_SHOW);
end;

function reemplazarTexto (cadena, textoAReemplazar, textoNuevo : string) : string;
var
  aPos : Integer;
begin
  aPos := Pos(textoAReemplazar, Cadena);
  Result := '';
  while (aPos <> 0) do begin
    Result := Result + Copy(Cadena, 1, aPos - 1) + textoNuevo;
    Delete(Cadena, 1, aPos + Length(textoAReemplazar) - 1);
    aPos := Pos(textoAReemplazar, Cadena);
  end;
  Result := Result + Cadena;
end;


end.
