unit UnidadReorganizar;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, Buttons, ExtCtrls, dbtables, bde, db, FileCtrl;

type
  TFormReorganizar = class(TForm)
    PCompactar: TProgressBar;
    Panel1: TPanel;
    BAceptar: TBitBtn;
    BCancelar: TBitBtn;
    TTabla: TTable;
    PReindexar: TProgressBar;
    lstFicheros: TFileListBox;
    LFichero: TLabel;
    opCompactar: TRadioButton;
    opReindexar: TRadioButton;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BAceptarClick(Sender: TObject);
    procedure BCancelarClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormReorganizar: TFormReorganizar;

  procedure Compactar (const ADatabase, ATable:String);
  procedure Reindexar (Tabla : ttable);

implementation

uses UnidadDatos, UnidadMenuPrincipal, unidadprocedimientos;

{$R *.DFM}

procedure TFormReorganizar.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  screen.Cursor := crdefault;
end;

procedure Reindexar (Tabla : ttable);
begin
  Check (dbiregenindexes (tabla.Handle));
end;

procedure Compactar (const ADatabase, ATable:String);
var
  ADB:TDataBase;
  SaveKC:Boolean;
  PdxStruct: CRTblDesc;
begin
  with TTable.Create(nil) do
  try
    close;
    DataBaseName:=ADataBase;
    TableName:=ATable;
    Exclusive:=True;
    Open;
    ADB:=DataBase;
    SaveKC:=ADB.KeepConnection;
    ADB.KeepConnection:=True;
    try
      Close;
      FillChar(PdxStruct,SizeOf(PdxStruct),0);
      StrPCopy(PdxStruct.szTblName,ATable);
      PdxStruct.bPack:=True;
      Check(DbiDoRestructure(ADB.Handle,1,@PdxStruct,nil,nil,nil,False));
    finally
      ADB.KeepConnection:=SaveKC;
    end;
  finally
    Free;
  end;
end;

procedure TFormReorganizar.BAceptarClick(Sender: TObject);
var
  ruta : string;
  i : integer;
begin
  ruta := VTRutaEmpresa;
  lstFicheros.Directory := ruta;
  lstficheros.refresh;
  TTabla.DatabaseName := 'ACampo';
  TTabla.DatabaseName := ruta;
  if lstFicheros.Count > 0 then
  begin
    PCompactar.Max := lstFicheros.Count;
    PCompactar.Min := 0;
    PReindexar.Max := lstFicheros.Count;
    PReindexar.Min := 0;
    PCompactar.Visible := OpCompactar.Checked;
    PReindexar.Visible := OpReindexar.Checked;
    for i := 0 to lstFicheros.Count do
    begin
      lstFicheros.ItemIndex := i;
      if OpCompactar.Checked then
      begin
        LFichero.Caption := 'Compactando ' + extractfilename(lstFicheros.FileName);
        PCompactar.Position := i;
        compactar ('ACampo',  extractfilename(lstFicheros.FileName));
      end;
      if OpReindexar.Checked then
      begin
        PReindexar.Position := i;
        LFichero.Caption := 'Reindexando ' + extractfilename(lstFicheros.FileName);
        TTabla.Close;
        TTabla.DatabaseName := 'ACampo';
        TTabla.exclusive := true;
        TTabla.TableName := extractfilename(lstFicheros.FileName);
        TTabla.open;
        reindexar (ttabla);
      end;
      Refresh;
    end;
  end;
  LFichero.Caption := 'Fin del proceso';
  MessageDlg ('Proceso finalizado correctamente.', mtinformation, [mbok],0);
  close;
end;

procedure TFormReorganizar.BCancelarClick(Sender: TObject);
begin
  close;
end;

end.
