unit UnidadSeleccion;
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, ToolWin, Grids, DBGrids, Db, DBTables,
  ActnList, Menus, variants;

type
  TFormSeleccion = class(TForm)
    Tabla: TDBGrid;
    Panel1: TPanel;
    TC: TQuery;
    DC: TDataSource;
    ActionList1: TActionList;
    ActSeleccionar: TAction;
    ActCerrar: TAction;
    TxtBuscar: TEdit;
    LB: TLabel;
    GroupBox1: TGroupBox;
    Op1: TRadioButton;
    Op2: TRadioButton;
    Op3: TRadioButton;
    Op4: TRadioButton;
    PopupMenu1: TPopupMenu;
    Seleccionar1: TMenuItem;
    Salir1: TMenuItem;
    N1: TMenuItem;
    CB: TControlBar;
    BB: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ActRefrescar: TAction;
    Nuevo1: TMenuItem;
    Refrescar1: TMenuItem;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TablaKeyPress(Sender: TObject; var Key: Char);
    procedure FormShow(Sender: TObject);

    procedure seleccionar ();
    procedure ActCerrarExecute(Sender: TObject);
    procedure TxtBuscarChange(Sender: TObject);
    procedure TxtBuscarKeyPress(Sender: TObject; var Key: Char);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure TxtBuscarKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ActRefrescarExecute(Sender: TObject);
    procedure ActSeleccionarExecute(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormSeleccion: TFormSeleccion;

implementation

uses UnidadProcedimientos;

{$R *.DFM}

procedure TFormSeleccion.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  tc.close;
  screen.cursor := crdefault;
  action := cafree;
end;

procedure TFormSeleccion.TablaKeyPress(Sender: TObject; var Key: Char);
begin
  if (key = 'c') or (key = 'C') or (key = chr(13))then
    actseleccionarexecute(nil);
end;

procedure TFormSeleccion.FormShow(Sender: TObject);
begin
  claveelegida := '';
  ActRefrescarexecute(nil);
  txtbuscar.setfocus;
end;

procedure tformseleccion.seleccionar ();
begin
  if (tag in [20, 30, 10, 40, 50, 60, 70]) then  //terceros, variedades, obreros, cuadrillas, trabajos, fincas, especies
  begin
    if not varisnull(tc.fieldbyname('ID').value) then
      claveElegida :=
          tc.fieldbyname('ID').value
  end;
  close;
end;
procedure TFormSeleccion.ActCerrarExecute(Sender: TObject);
begin
  close;
end;

procedure TFormSeleccion.TxtBuscarChange(Sender: TObject);
begin
  if (tag in [20, 30, 40, 60, 70]) then //Terceros, variedades, cuadrillas, trabajos, fincas, especie
  begin
    if Op1.Checked then
      tc.Locate ('Nombre', txtbuscar.text, [loCaseInsensitive, loPartialKey]);
    if Op2.Checked then
    begin
      try
        tc.Locate ('ID', txtbuscar.text, [loCaseInsensitive, loPartialKey]);
      except
        //silenciosa
      end;
    end;
  end;
  if (tag in [10]) then //obreros
  begin
    if Op1.Checked then //apellido1
      tc.Locate ('Apellido1', txtbuscar.text, [loCaseInsensitive, loPartialKey]);
    if Op2.Checked then  //codigo
    begin
      try
        tc.Locate ('ID', txtbuscar.text, [loCaseInsensitive, loPartialKey]);
      except
        //silenciosa
      end;
    end;
    if Op3.Checked then//dni
      tc.Locate ('DNI', txtbuscar.text, [loCaseInsensitive, loPartialKey]);
  end;
  if (tag in [50]) then //trabajos
  begin
    if Op1.Checked then //apellido1
      tc.Locate ('Trabajo', txtbuscar.text, [loCaseInsensitive, loPartialKey]);
    if Op2.Checked then  //codigo
    begin
      try
        tc.Locate ('ID', txtbuscar.text, [loCaseInsensitive, loPartialKey]);
      except
        //silenciosa
      end;
    end;
  end;

end;

procedure TFormSeleccion.TxtBuscarKeyPress(Sender: TObject; var Key: Char);
begin
  if key = chr(13) then
  begin
    key := #0;
    tabla.setfocus;
  end;
end;

procedure TFormSeleccion.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if key = chr(27) then  //escape
    ActCerrarExecute(nil);
end;

procedure TFormSeleccion.TxtBuscarKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key = 40 then  //tecla cursor abajo
    tabla.setfocus;
end;

procedure TFormSeleccion.ActRefrescarExecute(Sender: TObject);
begin
  tc.close;
  tc.sql.clear;
  if tag = 10 then //obreros
  begin
    Caption := 'Seleccin de obrero...';
    tc.sql.add('SELECT ID, Apellido1, Apellido2, Nombre, DNI');
    tc.sql.add('FROM ObrerosCuadrillas');
    op1.visible := true;
    op2.visible := true;
    op3.visible := true;
    op1.caption := '&Apellidos y nombre';
    op2.caption := 'Cdig&o';
    op3.caption := '&NIF';
    if Op1.Checked then  //apellidos
    begin
      tc.sql.add('Order by apellido1, apellido2, nombre');
      lb.Caption := '&Buscar por Apellido 1';
    end;
    if Op2.Checked then  //codigo
    begin
      lb.Caption := '&Buscar por Cdigo';
      tc.sql.add('Order by ID');
    end;
    if Op3.Checked then  //codigo
    begin
      lb.Caption := '&Buscar por NIF';
      tc.sql.add('Order by DNI');
    end;
  end;
  if tag = 40 then //cuadrillas
  begin
    Caption := 'Seleccin de cuadrilla...';
    tc.sql.add('SELECT ID, Nombre');
    tc.sql.add('FROM Cuadrillas');
    op1.visible := true;
    op2.visible := true;
    op1.caption := '&Nombre';
    op2.caption := 'Cdig&o';
    if Op1.Checked then  //nombre
    begin
      tc.sql.add('Order by nombre');
      lb.Caption := '&Buscar por nombre';
    end;
    if Op2.Checked then  //codigo
    begin
      lb.Caption := '&Buscar por Cdigo';
      tc.sql.add('Order by ID');
    end;
  end;
  if tag = 30 then //variedades
  begin
    Caption := 'Seleccin de variedad...';
    tc.sql.add('SELECT ID, Nombre');
    tc.sql.add('FROM Variedades');
    op1.visible := true;
    op2.visible := true;
    op1.caption := '&Nombre';
    op2.caption := 'Cdig&o';
    if Op1.Checked then  //nombre
    begin
      tc.sql.add('Order by nombre');
      lb.Caption := '&Buscar por nombre';
    end;
    if Op2.Checked then  //codigo
    begin
      lb.Caption := '&Buscar por Cdigo';
      tc.sql.add('Order by ID');
    end;
  end;

  if tag = 20 then //Terceros
  begin
    Caption := 'Seleccin de tercero...';
    tc.sql.add('SELECT ID, Nombre');
    tc.sql.add('FROM Terceros');
    op1.visible := true;
    op2.visible := true;
    op1.caption := '&Nombre';
    op2.caption := 'Cdig&o';
    if Op1.Checked then  //nombre
    begin
      tc.sql.add('Order by nombre');
      lb.Caption := '&Buscar por nombre';
    end;
    if Op2.Checked then  //codigo
    begin
      lb.Caption := '&Buscar por Cdigo';
      tc.sql.add('Order by ID');
    end;
  end;

  if tag = 50 then //Trabajos
  begin
    Caption := 'Seleccin de trabajo...';
    tc.sql.add('SELECT ID, Trabajo');
    tc.sql.add('FROM TrabajoRealizado');
    op1.visible := true;
    op2.visible := true;
    op1.caption := '&Nombre';
    op2.caption := 'Cdig&o';
    if Op1.Checked then  //nombre
    begin
      tc.sql.add('Order by trabajo');
      lb.Caption := '&Buscar por nombre';
    end;
    if Op2.Checked then  //codigo
    begin
      lb.Caption := '&Buscar por Cdigo';
      tc.sql.add('Order by ID');
    end;
  end;

  if tag = 60 then //Fincas
  begin
    Caption := 'Seleccin de fincas...';
    tc.sql.add('SELECT ID, Nombre');
    tc.sql.add('FROM Fincas');
    op1.visible := true;
    op2.visible := true;
    op1.caption := '&Nombre';
    op2.caption := 'Cdig&o';
    if Op1.Checked then  //nombre
    begin
      tc.sql.add('Order by Nombre');
      lb.Caption := '&Buscar por nombre';
    end;
    if Op2.Checked then  //codigo
    begin
      lb.Caption := '&Buscar por Cdigo';
      tc.sql.add('Order by ID');
    end;
  end;

  if tag = 70 then //Especies
  begin
    Caption := 'Seleccin de especie...';
    tc.sql.add('SELECT ID, Nombre');
    tc.sql.add('FROM VariedadesTipo');
    op1.visible := true;
    op2.visible := true;
    op1.caption := '&Nombre';
    op2.caption := 'Cdig&o';
    if Op1.Checked then  //nombre
    begin
      tc.sql.add('Order by Nombre');
      lb.Caption := '&Buscar por nombre';
    end;
    if Op2.Checked then  //codigo
    begin
      lb.Caption := '&Buscar por Cdigo';
      tc.sql.add('Order by ID');
    end;
  end;


  try
    tc.open;
  except
    raise;
  end;
  if tag = 10 then //obreros
  begin
    tc.fieldbyname('id').DisplayWidth := 5;
    TC.fieldbyname('Nombre').DisplayWidth := 20;
    TC.fieldbyname('Apellido1').DisplayWidth := 20;
    TC.fieldbyname('Apellido2').DisplayWidth := 20;
    TC.fieldbyname('DNI').DisplayWidth := 10;
    TC.fieldbyname('DNI').Displaylabel := 'NIF';    
    TC.fieldbyname('Apellido1').Displaylabel := 'Apellido 1';
    TC.fieldbyname('Apellido2').Displaylabel := 'Apellido 2';
  end;
  txtbuscar.setfocus;
end;

procedure TFormSeleccion.ActSeleccionarExecute(Sender: TObject);
begin
  seleccionar();
end;

end.
