unit UnidadSeleccionAlbaranFactura;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, ToolWin, Grids, DBGrids, Db, DBTables,
  ActnList, Menus, variants;

type
  TFormAlbaranesFactura = class(TForm)
    Tabla: TDBGrid;
    CB: TControlBar;
    BB: TToolBar;
    ToolButton2: TToolButton;
    ToolBar2: TToolBar;
    Panel1: TPanel;
    LBuscar: TLabel;
    TxtBuscar: TEdit;
    OpOrdenarNombre: TRadioButton;
    RadioButton2: TRadioButton;
    ToolButton1: TToolButton;
    ToolButton3: TToolButton;
    ActionList1: TActionList;
    ActCerrar: TAction;
    ActAnadirObrerosAParte: TAction;
    PopupMenu1: TPopupMenu;
    Aadirobrerosalparte1: TMenuItem;
    Aadirobrerosalparte2: TMenuItem;
    ActMostrarTodos: TAction;
    ToolButton4: TToolButton;
    N2: TMenuItem;
    ActSeleccionarTodos: TAction;
    RadioButton1: TRadioButton;
    Mostrartodos1: TMenuItem;
    N: TStaticText;
    OpOrdenarDistribuidor: TRadioButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    Seleccionartodos1: TMenuItem;
    ToolButton7: TToolButton;
    ActQuitar: TAction;
    procedure TxtBuscarChange(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure OpOrdenarNombreClick(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ActMostrarTodosExecute(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ActAnadirObrerosAParteExecute(Sender: TObject);
    procedure ActSeleccionarTodosExecute(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure OpOrdenarDistribuidorClick(Sender: TObject);
    procedure ActQuitarExecute(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormAlbaranesFactura: TFormAlbaranesFactura;

implementation

uses MFacturasProductos, UnidadFacturas, UnidadDatos, unidadprocedimientos;

{$R *.DFM}

procedure TFormAlbaranesFactura.TxtBuscarChange(Sender: TObject);
begin
  try
    mofacturasproductos.talbaranes.findnearest([txtbuscar.text])
  except
    raise;
  end;
end;

procedure TFormAlbaranesFactura.RadioButton2Click(Sender: TObject);
begin
  mofacturasproductos.talbaranes.indexfieldnames := 'ID';
  lbuscar.caption := 'ID:';
end;

procedure TFormAlbaranesFactura.OpOrdenarNombreClick(Sender: TObject);
begin
  mofacturasproductos.talbaranes.indexfieldnames := 'Fecha';
  lbuscar.caption := 'Fecha:';
end;

procedure TFormAlbaranesFactura.ToolButton2Click(Sender: TObject);
begin
  close;
end;

procedure TFormAlbaranesFactura.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  MoFacturasProductos.talbaranes.tag := 0;
  mofacturasproductos.Free;
  screen.cursor:=crdefault;
  action:=cafree;
end;

procedure TFormAlbaranesFactura.ActMostrarTodosExecute(Sender: TObject);
begin
  mofacturasproductos.talbaranes.filter :=
      '[Facturado] = ' +
      quotedstr('No');
  mofacturasproductos.talbaranes.filtered := true;
  mofacturasproductos.talbaranes.refresh;
end;

procedure TFormAlbaranesFactura.FormShow(Sender: TObject);
begin
  opordenarnombreclick(sender);
  n.caption := inttostr(mofacturasproductos.dalbaranes.dataset.recno) + '/'
      + inttostr(mofacturasproductos.dalbaranes.DataSet.recordcount);
  MoFacturasProductos.talbaranes.tag := 0;
  screen.cursor := crdefault;
end;

procedure TFormAlbaranesFactura.ActAnadirObrerosAParteExecute(Sender: TObject);
var
  BM: Tbookmarkstr;
  i:integer;
begin
  if tabla.SelectedRows.count=0 then
    msinfo ('Debe seleccionar, al menos, un albarn.', 'Seleccin...')
  else
  begin
    if msOK ('Se van a aadir [' + inttostr(tabla.SelectedRows.count) +
        '] albaranes a la factura actual.' +
        #13 + #13 + '   Pulse Aceptar para continuar.' +
        #13 + '   Pulse Cancelar para anular el proceso.',
        'Seleccin...') then
    begin
      screen.cursor := crhourglass;
      datos.tproductos.filtered := false;
      datos.tproductos.open;
      mofacturasproductos.talbaranes.DisableControls;
      bm := mofacturasproductos.talbaranes.Bookmark;
      for i:= 0 to tabla.SelectedRows.count - 1 do
      begin
        mofacturasproductos.talbaranes.Bookmark := tabla.selectedrows.items[i];
        mofacturasproductos.dalbaranes.dataset.refresh;
        mofacturasproductos.talbaranesproductos.open;
        mofacturasproductos.talbaranesproductos.filter :=
            '[IDFactura] = ' +
            quotedstr(mofacturasproductos.dalbaranes.dataset.fieldbyname('ID').value);
        mofacturasproductos.talbaranesproductos.filtered := true;
        mofacturasproductos.talbaranesproductos.refresh;
        mofacturasproductos.dalbaranesproductos.dataSet.first;
        while not mofacturasproductos.dalbaranesproductos.dataSet.eof do
        begin
          formfacturasproductos.dproductos.DataSet.insert;
          if not varisnull(mofacturasproductos.dalbaranesproductos.dataset.fieldbyname('ID').value) then
            formfacturasproductos.dproductos.dataset.fieldbyname('IDProducto').value :=
               mofacturasproductos.dalbaranesproductos.dataset.fieldbyname('IDProducto').value;
          if datos.tproductos.locate('ID', mofacturasproductos.dalbaranesproductos.dataset.fieldbyname('ID').value, []) then
          begin
            if not varisnull(datos.dproductos.dataset.fieldbyname('UnidadDosis').value) then
              formfacturasproductos.dproductos.dataset.fieldbyname('UnidadDosis').value :=
                  datos.dproductos.dataset.fieldbyname('UnidadDosis').value;
          end;
          if not varisnull(mofacturasproductos.dalbaranesproductos.dataset.fieldbyname('Cantidad').value) then
            formfacturasproductos.dproductos.dataset.fieldbyname('Cantidad').value :=
               mofacturasproductos.dalbaranesproductos.dataset.fieldbyname('Cantidad').value;
          if not varisnull(mofacturasproductos.dalbaranes.dataset.fieldbyname('Numero').value) then
            formfacturasproductos.dproductos.dataset.fieldbyname('Nota').value :=
               'Nota de entrega: ' + mofacturasproductos.dalbaranes.dataset.fieldbyname('Numero').value;
          formfacturasproductos.dproductos.dataset.post;
          mofacturasproductos.dAlbaranesProductos.DataSet.next;
        end;
        mofacturasproductos.dalbaranes.dataset.edit;
        mofacturasproductos.dalbaranes.dataset.fieldbyname('Facturado').value := 'S';
        mofacturasproductos.dalbaranes.dataset.post;
      end;
      mofacturasproductos.talbaranes.EnableControls;
      screen.cursor:=crdefault;
        close;
    end;
  end;
end;


procedure TFormAlbaranesFactura.ActSeleccionarTodosExecute(Sender: TObject);
begin
  tabla.DataSource.DataSet.first;
  while not tabla.DataSource.DataSet.Eof do
  begin
    tabla.SelectedRows.CurrentRowSelected := True;
    tabla.datasource.DataSet.Next;
  end;
end;


procedure TFormAlbaranesFactura.RadioButton1Click(Sender: TObject);
begin
  mofacturasproductos.talbaranes.indexfieldnames := 'Numero';
  lbuscar.caption := 'Numero:';
end;

procedure TFormAlbaranesFactura.OpOrdenarDistribuidorClick(
  Sender: TObject);
begin
  mofacturasproductos.talbaranes.indexfieldnames:='IDTercero';
  lbuscar.caption:='ID Distribuidor:';
end;


procedure TFormAlbaranesFactura.ActQuitarExecute(Sender: TObject);
begin
  tabla.DataSource.DataSet.first;
  while not tabla.DataSource.DataSet.Eof do
  begin
    tabla.SelectedRows.CurrentRowSelected := false;
    tabla.datasource.DataSet.Next;
  end;
end;

end.
