unit UnidadSeleccionInforme;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, DB, DBTables, ComObj;

type
  TformSeleccionInforme = class(TForm)
    lsInformes: TListBox;
    Label1: TLabel;
    Button2: TButton;
    bEjecutar: TButton;
    TC: TQuery;
    StaticText1: TStaticText;
    procedure bEjecutarClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formSeleccionInforme: TformSeleccionInforme;

implementation

{$R *.dfm}

procedure TformSeleccionInforme.bEjecutarClick(Sender: TObject);
var
  bdAccess, informe : string;
  Access: Variant;
const
  acViewNormal = $00000000;
  acViewDesign = $00000001;
  acViewPreview = $00000002;
  acQuitPrompt = $00000000;
  acQuitSaveAll = $00000001;
  acQuitSaveNone = $00000002;
begin
  if lsInformes.ItemIndex > -1 then
  begin
    TC.Close;
    //obtenemos la BD a utilizar para el informe
    informe := lsInformes.Items[lsInformes.ItemIndex];
    TC.SQL.Clear;
    TC.SQL.Add('SELECT * FROM Informes WHERE Nombre = :pNombre');
    TC.ParamByName('pNombre').DataType := ftString;
    TC.ParamByName('pNombre').Value := informe;
    TC.Open;
    if TC.RecordCount > 0 then
    begin
      bdAccess := tc.fieldbyname('BD').value;
      if FileExists(bdAccess) then
      begin
        {Abrimos access}
        try
          Access := GetActiveOleObject('Access.Application');
        except
          Access := CreateOleObject('Access.Application');
        end;
        try
          Access.Visible := True;
        except
          //silenciosa
          //MessageDlg('MS Access no se ha podido abrir, asegurse que no est ' +
          //    'abierto ya, si es as cirrelo e intntelo de nuevo.', mterror, [mbok], 0);
        end;
        //abrimos la BD en modo NO exclusivo
        Access.OpenCurrentDatabase(bdAccess, false);
        //ejecutamos el informe
        Access.DoCmd.OpenReport(informe, acViewPreview, EmptyParam, EmptyParam);
        MessageDlg('El informe ha sido generado correctamente en MS Access. ' +
            'Cuando lo haya imprimido pulse en Aceptar y la ' +
            'aplicacin cerrar MS Access automticamente.', mtInformation, [mbok], 0);
        //cerramos la BD
        try
          Access.CloseCurrentDatabase;
        except
          //silenciosa, pues si se produce este error es porque el usuario ha cerrado Access
        end;
        //Cerramos Access
        try
          Access.Quit(acQuitSaveAll);
        except
          //silenciosa, pues si se produce este error es porque el usuario ha cerrado Access
        end;
      end
      else
        MessageDlg('La base de datos Access [' + bdAccess + '] para el informe [' +
            informe + '] no existe. Debe crearla antes de continuar.', mterror, [mbok], 0);
    end
    else
      MessageDlg('El informe seleccionado no existe en la tabla de Mantenimiento ' +
          'de Informes de MS Access. Debe crearlo antes de continuar.', mterror, [mbok], 0);
  end
  else
    MessageDlg('Debe seleccionar un Informe para visualizar/imprimir.', mterror, [mbok], 0);
end;

procedure TformSeleccionInforme.FormShow(Sender: TObject);
begin
  lsInformes.Clear;
  TC.Close;
  TC.DatabaseName := ExtractFilePath(Application.ExeName) + 'Temp';
  //Totales de vales de fruta
  if Tag = 10 then
  begin
    TC.SQL.Clear;
    TC.SQL.Add('SELECT * FROM Informes WHERE Formulario = :pFormulario');
    TC.ParamByName('pFormulario').DataType := ftString;
    TC.ParamByName('pFormulario').Value := 'Totales vales de fruta';
    TC.Open;
    while not TC.Eof do
    begin
      lsInformes.Items.Add(TC.fieldbyname('Nombre').value);
      TC.Next;
    end;
  end;

  //Trazabilidad  - tratamientos areos
  if Tag = 20 then
  begin
    TC.SQL.Clear;
    TC.SQL.Add('SELECT * FROM Informes WHERE Formulario = :pFormulario');
    TC.ParamByName('pFormulario').DataType := ftString;
    TC.ParamByName('pFormulario').Value := 'Trazabilidad';
    TC.Open;
    while not TC.Eof do
    begin
      lsInformes.Items.Add(TC.fieldbyname('Nombre').value);
      TC.Next;
    end;
  end;

  //Totales de gastos finca, sector variedad
  if Tag = 30 then
  begin
    TC.SQL.Clear;
    TC.SQL.Add('SELECT * FROM Informes WHERE Formulario = :pFormulario');
    TC.ParamByName('pFormulario').DataType := ftString;
    TC.ParamByName('pFormulario').Value := 'Gastos por finca, variedad, categora y tipo de gasto';
    TC.Open;
    while not TC.Eof do
    begin
      lsInformes.Items.Add(TC.fieldbyname('Nombre').value);
      TC.Next;
    end;
  end;


  //Vales de fruta
  if Tag = 40 then
  begin
    TC.SQL.Clear;
    TC.SQL.Add('SELECT * FROM Informes WHERE Formulario = :pFormulario');
    TC.ParamByName('pFormulario').DataType := ftString;
    TC.ParamByName('pFormulario').Value := 'Vales de fruta';
    TC.Open;
    while not TC.Eof do
    begin
      lsInformes.Items.Add(TC.fieldbyname('Nombre').value);
      TC.Next;
    end;
  end;

  //Partes de trabajo
  if Tag = 50 then
  begin
    TC.SQL.Clear;
    TC.SQL.Add('SELECT * FROM Informes WHERE Formulario = :pFormulario');
    TC.ParamByName('pFormulario').DataType := ftString;
    TC.ParamByName('pFormulario').Value := 'Partes de trabajo';
    TC.Open;
    while not TC.Eof do
    begin
      lsInformes.Items.Add(TC.fieldbyname('Nombre').value);
      TC.Next;
    end;
  end;

  //Partes de tratamientos
  if Tag = 60 then
  begin
    TC.SQL.Clear;
    TC.SQL.Add('SELECT * FROM Informes WHERE Formulario = :pFormulario');
    TC.ParamByName('pFormulario').DataType := ftString;
    TC.ParamByName('pFormulario').Value := 'Partes de tratamientos';
    TC.Open;
    while not TC.Eof do
    begin
      lsInformes.Items.Add(TC.fieldbyname('Nombre').value);
      TC.Next;
    end;
  end;

  //Partes de agua de riego
  if Tag = 70 then
  begin
    TC.SQL.Clear;
    TC.SQL.Add('SELECT * FROM Informes WHERE Formulario = :pFormulario');
    TC.ParamByName('pFormulario').DataType := ftString;
    TC.ParamByName('pFormulario').Value := 'Partes de agua de riego';
    TC.Open;
    while not TC.Eof do
    begin
      lsInformes.Items.Add(TC.fieldbyname('Nombre').value);
      TC.Next;
    end;
  end;

  //Gastos de sectores/variedades
  if Tag = 80 then
  begin
    TC.SQL.Clear;
    TC.SQL.Add('SELECT * FROM Informes WHERE Formulario = :pFormulario');
    TC.ParamByName('pFormulario').DataType := ftString;
    TC.ParamByName('pFormulario').Value := 'Gastos de sectores/variedades';
    TC.Open;
    while not TC.Eof do
    begin
      lsInformes.Items.Add(TC.fieldbyname('Nombre').value);
      TC.Next;
    end;
  end;

  //Gastos comunes de fincas
  if Tag = 90 then
  begin
    TC.SQL.Clear;
    TC.SQL.Add('SELECT * FROM Informes WHERE Formulario = :pFormulario');
    TC.ParamByName('pFormulario').DataType := ftString;
    TC.ParamByName('pFormulario').Value := 'Gastos comunes de fincas';
    TC.Open;
    while not TC.Eof do
    begin
      lsInformes.Items.Add(TC.fieldbyname('Nombre').value);
      TC.Next;
    end;
  end;

  //Gastos generales
  if Tag = 100 then
  begin
    TC.SQL.Clear;
    TC.SQL.Add('SELECT * FROM Informes WHERE Formulario = :pFormulario');
    TC.ParamByName('pFormulario').DataType := ftString;
    TC.ParamByName('pFormulario').Value := 'Gastos generales';
    TC.Open;
    while not TC.Eof do
    begin
      lsInformes.Items.Add(TC.fieldbyname('Nombre').value);
      TC.Next;
    end;
  end;


  //Nueva inversin/Amortizaciones
  if Tag = 110 then
  begin
    TC.SQL.Clear;
    TC.SQL.Add('SELECT * FROM Informes WHERE Formulario = :pFormulario');
    TC.ParamByName('pFormulario').DataType := ftString;
    TC.ParamByName('pFormulario').Value := 'Nueva inversin/Amortizaciones';
    TC.Open;
    while not TC.Eof do
    begin
      lsInformes.Items.Add(TC.fieldbyname('Nombre').value);
      TC.Next;
    end;
  end;

  //Pagos a terceros
  if Tag = 120 then
  begin
    TC.SQL.Clear;
    TC.SQL.Add('SELECT * FROM Informes WHERE Formulario = :pFormulario');
    TC.ParamByName('pFormulario').DataType := ftString;
    TC.ParamByName('pFormulario').Value := 'Pagos a terceros';
    TC.Open;
    while not TC.Eof do
    begin
      lsInformes.Items.Add(TC.fieldbyname('Nombre').value);
      TC.Next;
    end;
  end;

  //Otros ingresos
  if Tag = 130 then
  begin
    TC.SQL.Clear;
    TC.SQL.Add('SELECT * FROM Informes WHERE Formulario = :pFormulario');
    TC.ParamByName('pFormulario').DataType := ftString;
    TC.ParamByName('pFormulario').Value := 'Otros ingresos';
    TC.Open;
    while not TC.Eof do
    begin
      lsInformes.Items.Add(TC.fieldbyname('Nombre').value);
      TC.Next;
    end;
  end;

  //Productos fitosanitarios
  if Tag = 140 then
  begin
    TC.SQL.Clear;
    TC.SQL.Add('SELECT * FROM Informes WHERE Formulario = :pFormulario');
    TC.ParamByName('pFormulario').DataType := ftString;
    TC.ParamByName('pFormulario').Value := 'Productos fitosanitarios';
    TC.Open;
    while not TC.Eof do
    begin
      lsInformes.Items.Add(TC.fieldbyname('Nombre').value);
      TC.Next;
    end;
  end;

  //Facturas de productos fitosanitarios
  if Tag = 150 then
  begin
    TC.SQL.Clear;
    TC.SQL.Add('SELECT * FROM Informes WHERE Formulario = :pFormulario');
    TC.ParamByName('pFormulario').DataType := ftString;
    TC.ParamByName('pFormulario').Value := 'Facturas de productos fitosanitarios';
    TC.Open;
    while not TC.Eof do
    begin
      lsInformes.Items.Add(TC.fieldbyname('Nombre').value);
      TC.Next;
    end;
  end;

  //Albaranes de productos fitosanitarios
  if Tag = 160 then
  begin
    TC.SQL.Clear;
    TC.SQL.Add('SELECT * FROM Informes WHERE Formulario = :pFormulario');
    TC.ParamByName('pFormulario').DataType := ftString;
    TC.ParamByName('pFormulario').Value := 'Albaranes de productos fitosanitarios';
    TC.Open;
    while not TC.Eof do
    begin
      lsInformes.Items.Add(TC.fieldbyname('Nombre').value);
      TC.Next;
    end;
  end;

  //Trazabilidad
  if Tag = 170 then
  begin
    TC.SQL.Clear;
    TC.SQL.Add('SELECT * FROM Informes WHERE Formulario = :pFormulario');
    TC.ParamByName('pFormulario').DataType := ftString;
    TC.ParamByName('pFormulario').Value := 'Trazabilidad - Abonados';
    TC.Open;
    while not TC.Eof do
    begin
      lsInformes.Items.Add(TC.fieldbyname('Nombre').value);
      TC.Next;
    end;
  end;

  //mostramos todos los informes
  if Tag = 0 then
  begin
    TC.SQL.Clear;
    TC.SQL.Add('SELECT * FROM Informes');
    TC.Open;
    while not TC.Eof do
    begin
      lsInformes.Items.Add(TC.fieldbyname('Nombre').value);
      TC.Next;
    end;
  end;
end;

procedure TformSeleccionInforme.Button2Click(Sender: TObject);
begin
  close;
end;

procedure TformSeleccionInforme.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action := caFree;
end;

end.
