unit UnidadSeleccionValesFacturas;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, ToolWin, Grids, DBGrids, Db, DBTables,
  ActnList, Menus, DBCtrls, Mask, Buttons, variants;

type
  TFormValesFactura = class(TForm)
    CB: TControlBar;
    BB: TToolBar;
    ToolButton2: TToolButton;
    ToolBar2: TToolBar;
    Panel1: TPanel;
    LBuscar: TLabel;
    TxtBuscar: TEdit;
    OpOrdenarNombre: TRadioButton;
    ToolButton1: TToolButton;
    ToolButton3: TToolButton;
    ActionList1: TActionList;
    ActCerrar: TAction;
    ActAnadirObrerosAParte: TAction;
    PopupMenu1: TPopupMenu;
    Aadirobrerosalparte1: TMenuItem;
    Aadirobrerosalparte2: TMenuItem;
    ActMostrarTodos: TAction;
    ToolButton4: TToolButton;
    N2: TMenuItem;
    RadioButton1: TRadioButton;
    Mostrartodos1: TMenuItem;
    N: TStaticText;
    OpOrdenarDistribuidor: TRadioButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ActTodos: TAction;
    AcQuitar: TAction;
    PA: TPanel;
    Label8: TLabel;
    Label11: TLabel;
    TxtFiltroFecha: TMaskEdit;
    TxtFiltroFechaHasta: TMaskEdit;
    TxtVariedad: TDBLookupComboBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    LKg: TLabel;
    LImporte: TLabel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    TC: TQuery;
    BCalcular: TBitBtn;
    LPrecio: TLabel;
    Label5: TLabel;
    Panel2: TPanel;
    Shape1: TShape;
    Tabla: TDBGrid;
    procedure TxtBuscarChange(Sender: TObject);
    procedure OpOrdenarNombreClick(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ActMostrarTodosExecute(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ActAnadirObrerosAParteExecute(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure OpOrdenarDistribuidorClick(Sender: TObject);
    procedure ActTodosExecute(Sender: TObject);
    procedure AcQuitarExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BCalcularClick(Sender: TObject);
    procedure TxtVariedadKeyPress(Sender: TObject; var Key: Char);
    procedure TxtFiltroFechaKeyPress(Sender: TObject; var Key: Char);
    procedure TxtFiltroFechaHastaKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormValesFactura: TFormValesFactura;

implementation

uses MFacturasFruta, UnidadFacturacionFruta, UnidadDatos, unidadprocedimientos;

{$R *.DFM}

procedure TFormValesFactura.TxtBuscarChange(Sender: TObject);
begin
  try
    mofacturasfruta.tvales.findnearest([txtbuscar.text])
  except
    raise;
  end;
end;

procedure TFormValesFactura.OpOrdenarNombreClick(Sender: TObject);
begin
  mofacturasfruta.tvales.indexfieldnames:='Fecha';
  lbuscar.caption:='Fecha:';
end;

procedure TFormValesFactura.ToolButton2Click(Sender: TObject);
begin
  close;
end;

procedure TFormValesFactura.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  if Tag = 20 then
  begin
    mofacturasfruta.tVales.Tag := 0;
    mofacturasfruta.Free;
  end;
  screen.cursor := crdefault;
  action := cafree;
end;

procedure TFormValesFactura.ActMostrarTodosExecute(Sender: TObject);
begin
  mofacturasfruta.tvales.filter := '';
  mofacturasfruta.tvales.filtered := false;
  mofacturasfruta.tvales.refresh;
end;

procedure TFormValesFactura.FormShow(Sender: TObject);
begin
  if tag = 20 then
  begin
    opordenarnombreclick(sender);
    n.caption:=inttostr(mofacturasfruta.dvales.dataset.recno) + '/'
        + inttostr(mofacturasfruta.dvales.DataSet.recordcount);
    tabla.Align := alClient;
  end;
  if tag = 10 then
  begin
    cb.visible := false;
    tabla.Visible := false;
    pa.Visible := true;
    TxtFiltroFecha.Text := DateToStr(VTInicioEmpresa);
    TxtFiltroFechaHasta.Text := DateToStr(VTFinEmpresa);    
    TxtFiltroFecha.setfocus;
  end;
  screen.cursor := crdefault;
end;

procedure TFormValesFactura.ActAnadirObrerosAParteExecute(Sender: TObject);
var
  BM: Tbookmarkstr;
  i:integer;
begin
  if tabla.SelectedRows.count=0 then
    msinfo ('Debe seleccionar, al menos, un vale.', 'Seleccin...')
  else
  begin
    if msok ('Se van a aadir [' + inttostr(tabla.SelectedRows.count) +
        '] vales a la factura actual.' +
        #13 + #13 + '   Pulse Aceptar para continuar.' +
        #13 + '   Pulse Cancelar para anular el proceso.',
        'Seleccin de vales...') then
    begin
      screen.cursor := crhourglass;
      mofacturasfruta.tvales.DisableControls;
      bm:=mofacturasfruta.tvales.Bookmark;
      for i := 0 to tabla.SelectedRows.count - 1 do
      begin
        mofacturasfruta.tvales.Bookmark := tabla.selectedrows.items[i];
        mofacturasfruta.dvales.dataset.refresh;
        mofacturasfruta.tvalesvariedades.open;
        mofacturasfruta.tvalesvariedades.filter := '[IDVale] = ' +
            quotedstr(mofacturasfruta.dvales.dataset.fieldbyname('ID').value);
        mofacturasfruta.tvalesvariedades.filtered := true;
        mofacturasfruta.tvalesvariedades.refresh;
        mofacturasfruta.dvalesvariedades.dataSet.first;
        while not mofacturasfruta.dvalesvariedades.dataSet.eof do
        begin
          formfacturacionfruta.basedatosconceptos.DataSet.insert;
          if not varisnull(mofacturasfruta.dvalesvariedades.dataset.fieldbyname('ID').value) then
          begin
            formfacturacionfruta.basedatosconceptos.dataset.fieldbyname('IDVariedad').value:=
               mofacturasfruta.dvalesvariedades.dataset.fieldbyname('IDVariedad').value;
          end;
          if not varisnull(mofacturasfruta.dvalesvariedades.dataset.fieldbyname('PesoNeto').value) then
            formfacturacionfruta.basedatosconceptos.dataset.fieldbyname('Kg').value:=
               mofacturasfruta.dvalesvariedades.dataset.fieldbyname('PesoNeto').value;
          if not varisnull(mofacturasfruta.dvales.dataset.fieldbyname('Numero').value) and
            not varisnull(mofacturasfruta.dvalesvariedades.dataset.fieldbyname('LVariedad').value) then
            formfacturacionfruta.basedatosconceptos.dataset.fieldbyname('Concepto').value:=
               'Vale: ' + mofacturasfruta.dvales.dataset.fieldbyname('Numero').value +
               '(' + mofacturasfruta.dvalesvariedades.dataset.fieldbyname('LVariedad').value + ')';
          if not varisnull(mofacturasfruta.dvales.dataset.fieldbyname('Fecha').value) then
            formfacturacionfruta.basedatosconceptos.dataset.fieldbyname('Fecha').value:=
               mofacturasfruta.dvales.dataset.fieldbyname('Fecha').value;
          if not varisnull(mofacturasfruta.dvalesvariedades.dataset.fieldbyname('PrecioConIVA').value) then
            formfacturacionfruta.basedatosconceptos.dataset.fieldbyname('Precio').value:=
               mofacturasfruta.dvalesvariedades.dataset.fieldbyname('PrecioConIVA').value;
          formfacturacionfruta.basedatosconceptos.dataset.post;
          mofacturasfruta.dvalesvariedades.DataSet.next;
        end;
        mofacturasfruta.dvales.dataset.edit;
        mofacturasfruta.dvales.dataset.fieldbyname('Facturado').value := 'True';
        mofacturasfruta.dvales.dataset.post;
      end;
//      mofacturasfruta.tvales.bookmark := bm;
      mofacturasfruta.tvales.EnableControls;
      screen.cursor := crdefault;
        close;
    end;
  end;
end;


procedure TFormValesFactura.RadioButton1Click(Sender: TObject);
begin
  mofacturasfruta.tvales.indexfieldnames:='Numero';
  lbuscar.caption:='Numero:';
end;

procedure TFormValesFactura.OpOrdenarDistribuidorClick(
  Sender: TObject);
begin
  mofacturasfruta.tvales.indexfieldnames:='IDTercero';
  lbuscar.caption:='ID Distribuidor:';
end;


procedure TFormValesFactura.ActTodosExecute(Sender: TObject);
begin
  tabla.DataSource.DataSet.first;
  while not tabla.DataSource.DataSet.Eof do
  begin
    tabla.SelectedRows.CurrentRowSelected := True;
    tabla.datasource.DataSet.Next;
  end;
end;

procedure TFormValesFactura.AcQuitarExecute(Sender: TObject);
begin
  tabla.DataSource.DataSet.first;
  while not tabla.DataSource.DataSet.Eof do
  begin
    tabla.SelectedRows.CurrentRowSelected := false;
    tabla.datasource.DataSet.Next;
  end;
end;

procedure TFormValesFactura.FormCreate(Sender: TObject);
begin
  if tag = 20 then
    tabla.Align := alClient;
end;

procedure TFormValesFactura.BitBtn1Click(Sender: TObject);
begin
  close;
end;

procedure TFormValesFactura.BitBtn2Click(Sender: TObject);
var
  precio, importe, kg : double;
begin
  if not varisnull(tc.FieldByName('importe').value) then
    importe := tc.FieldByName('importe').value
  else
    importe := 0;
  if not varisnull(tc.FieldByName('peso').value) then
    kg := tc.FieldByName('peso').value
  else
    kg := 0;
  if (kg > 0) and (importe > 0) then
    Precio := importe / kg
  else
    precio := 0;
  with FormFacturacionFruta.BaseDatosConceptos.DataSet do
  begin
    Insert;
    FieldByName('Concepto').value := txtvariedad.Text;
    FieldByName('Kg').value := kg;
    FieldByName('Importe').value := importe;
    FieldByName('Precio').value := precio;
  end;
  close;
end;

procedure TFormValesFactura.BCalcularClick(Sender: TObject);
var
  precio, importe, kg : double;
begin
  tc.close;
  tc.sql.Clear;
  tc.SQL.add('select sum(PesoNeto) as peso, SUM(importeTotal) as importe');
  tc.sql.add('from variedadesvales');
  tc.sql.add('where idvariedad = :pidvariedad');
  tc.ParamByName('pidvariedad').AsInteger := txtvariedad.KeyValue;
  tc.open;
  if not varisnull(tc.FieldByName('importe').value) then
    importe := tc.FieldByName('importe').value
  else
    importe := 0;
  if not varisnull(tc.FieldByName('peso').value) then
    kg := tc.FieldByName('peso').value
  else
    kg := 0;
  if (kg > 0) and (importe > 0) then
    Precio := importe / kg
  else
    precio := 0;
  LPrecio.Caption := formatfloat('###,###,###,##0.00;-###,###,###,##0.00;0',
      precio) + ' ' + vTMonedaEmpresa;
  limporte.caption := formatfloat('###,###,###,##0.00;-###,###,###,##0.00;0',
      importe) + ' ' +
      vTMonedaEmpresa;
  lkg.caption := formatfloat('###,###,###,##0.00;-###,###,###,##0.00;0',
      kg) + ' Kg.';
end;

procedure TFormValesFactura.TxtVariedadKeyPress(Sender: TObject;
  var Key: Char);
begin
  if key = chr(13) then
    bcalcularclick(nil);                
end;

procedure TFormValesFactura.TxtFiltroFechaKeyPress(Sender: TObject;
  var Key: Char);
begin
  if key = chr(13) then
    TxtFiltroFechaHasta.setfocus;
end;

procedure TFormValesFactura.TxtFiltroFechaHastaKeyPress(Sender: TObject;
  var Key: Char);
begin
  if key = chr(13) then
    TxtVariedad.setfocus;
end;

end.
