unit UnidadTiposGastos;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, Grids, DBGrids, ExtCtrls, DBCtrls, Db, DBTables, StdCtrls,
  Buttons, Qrctrls, QuickRpt, ToolWin, Menus, ActnList, variants;

type
  TFormTiposGastos = class(TForm)
    TTabla: TTable;
    DDB: TDataSource;
    LImpresion: TQuickRep;
    TitleBand1: TQRBand;
    QRSubDetail2: TQRSubDetail;
    QRDBText15: TQRDBText;
    QRDBText1: TQRDBText;
    GroupHeaderBand1: TQRBand;
    QRLabel11: TQRLabel;
    QRLabel12: TQRLabel;
    PageFooterBand1: TQRBand;
    QRSysData1: TQRSysData;
    ScrollBox1: TScrollBox;
    LEmpresa: TQRLabel;
    QRSysData3: TQRSysData;
    PageHeaderBand1: TQRBand;
    LTitulo: TQRSysData;
    CB: TControlBar;
    BB: TToolBar;
    ToolButton1: TToolButton;
    ToolButton3: TToolButton;
    ToolButton2: TToolButton;
    ToolBar2: TToolBar;
    Panel1: TPanel;
    LBuscar: TLabel;
    TxtBuscar: TEdit;
    OpOrdenarNombre: TRadioButton;
    RadioButton2: TRadioButton;
    Panel2: TPanel;
    Navegador: TDBNavigator;
    BEliminar: TBitBtn;
    Panel3: TPanel;
    Tabla: TDBGrid;
    N: TStaticText;
    BAnadir: TBitBtn;
    PopupMenu1: TPopupMenu;
    Aadirnuevafinca1: TMenuItem;
    N1: TMenuItem;
    Previsualizar1: TMenuItem;
    N3: TMenuItem;
    Cerrarventana1: TMenuItem;
    Label1: TLabel;
    ListaAcciones: TActionList;
    ActNuevo: TAction;
    ActImprimirListado: TAction;
    ActCerrar: TAction;
    ActEliminar: TAction;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure BCerrarClick(Sender: TObject);
    procedure BEliminarClick(Sender: TObject);
    procedure BPrevisualizarClick(Sender: TObject);
    procedure TTablaAfterInsert(DataSet: TDataSet);
    procedure TTablaPostError(DataSet: TDataSet; E: EDatabaseError;
      var Action: TDataAction);
    procedure RadioButton2Click3(Sender: TObject);
    procedure TxtBuscarChange3(Sender: TObject);
    procedure BAnadirClick(Sender: TObject);
    procedure OpOrdenarNombreClick(Sender: TObject);
    procedure TTablaAfterPost(DataSet: TDataSet);
    procedure DDBDataChange(Sender: TObject; Field: TField);
    procedure TablaKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormTiposGastos: TFormTiposGastos;

implementation

uses UnidadDatos, unidadprocedimientos;

{$R *.DFM}

procedure TFormTiposGastos.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if (ddb.dataset.state=dsedit) or (ddb.dataset.state=dsinsert) then
    ddb.dataset.post;
  ttabla.close;
  screen.cursor:=crdefault;
  action := cafree;
end;

procedure TFormTiposGastos.FormShow(Sender: TObject);
begin
  opordenarnombreclick(sender);
  ttabla.Open;
  screen.cursor:=crdefault;
end;

procedure TFormTiposGastos.BCerrarClick(Sender: TObject);
begin
  close;
end;


procedure TFormTiposGastos.BEliminarClick(Sender: TObject);
var
  nombre:string;
begin
  if ddb.dataset.recordcount=0 then
    messagedlg('No hay tipos de gastos para eliminar.',mtinformation,[mbok],0)
  else
  begin
    datos.dgastosgenerales.dataset.open;
    if datos.dgastosgenerales.DataSet.Locate('IDTipoGasto',ddb.DataSet.fieldbyname('ID').value,[]) then
    begin
      messagedlg('El tipo de gasto actual no se puede eliminar ya que existe en gastos generales.',mtinformation,[mbok],0);
      exit;
    end;
    datos.dgastosfincas.dataset.open;
    if datos.dgastosfincas.DataSet.Locate('IDTipoGasto',ddb.DataSet.fieldbyname('ID').value,[]) then
    begin
      messagedlg('El tipo de gasto actual no se puede eliminar ya que existe en gastos comunes de fincas.',mtinformation,[mbok],0);
      exit;
    end;
    datos.DNuevaInversion.dataset.open;
    if datos.tnuevainversion.Locate('IDTipoGasto',
        ddb.DataSet.fieldbyname('ID').value,[]) then
    begin
      messagedlg('El tipo de gasto actual no se puede eliminar ya que existe en gastos de nueva inverisn.',mtinformation,[mbok],0);
      exit;
    end;
    if not (ddb.dataset.fieldbyname('Gasto').value=Null) then
      Nombre:=ddb.dataset.fieldbyname('Gasto').value
    else
      nombre:='';
    if messagedlg('Est seguro que desea ELIMINAR el gasto [' + nombre + ']?',mtconfirmation,[mbno,mbyes],0)=mryes then
      ddb.dataset.delete;
  end;   
end;

procedure TFormTiposGastos.BPrevisualizarClick(Sender: TObject);
begin
  lempresa.caption :=  inttostr(vtidempresa) + ' - ' +
        vtnombreempresa + ' [' + datetostr (vtinicioempresa) +
        ' - ' + datetostr (vtfinempresa) + ']';
  limpresion.ReportTitle:='LISTADO DE TIPOS DE GASTOS';
  limpresion.PreviewModal;
end;

procedure TFormTiposGastos.TTablaAfterInsert(DataSet: TDataSet);
begin
  tabla.setfocus;
  tabla.SelectedIndex:=1;  
end;

procedure TFormTiposGastos.TTablaPostError(DataSet: TDataSet;
  E: EDatabaseError; var Action: TDataAction);
var
  i: integer;
begin
  if E is EDBEngineError then
  begin
    for i:=0 to EDBEngineError(E).errorcount-1 do
    begin
      if EDBEngineError(E).errors[i].Errorcode=9729 then
      begin
        messagedlg('El gasto introducido ya existe. Elimnelo antes de continuar',mtinformation,[mbok],0);
        action := daAbort;
        exit;
      end
      else
      begin
        messagedlg('Hay algn dato incorrecto. Compruebe los datos y vuelva a intentarlo.',mtinformation,[mbok],0);
        action := daAbort;
        exit;
      end;
    end;
  end;
end;









procedure TFormTiposGastos.RadioButton2Click3(Sender: TObject);
begin
  ttabla.indexfieldnames:='ID';
  lbuscar.caption:='ID a &buscar:';
end;


procedure TFormTiposGastos.TxtBuscarChange3(Sender: TObject);
begin
  try
    ttabla.findnearest([txtbuscar.text])
  except
    raise;  
  end;  
end;

procedure TFormTiposGastos.BAnadirClick(Sender: TObject);
begin
  ddb.dataset.Insert;
end;


procedure TFormTiposGastos.OpOrdenarNombreClick(Sender: TObject);
begin
  ttabla.indexfieldnames:='Gasto';
  lbuscar.caption:='Nombre a &buscar:';
end;


procedure TFormTiposGastos.TTablaAfterPost(DataSet: TDataSet);
begin
  ttabla.FlushBuffers;
end;

procedure TFormTiposGastos.DDBDataChange(Sender: TObject; Field: TField);
begin
  n.caption:=inttostr(ddb.dataset.recno) +
    '/' + inttostr(ddb.DataSet.recordcount);
end;

procedure TFormTiposGastos.TablaKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  // para no aadir al pulsar tecla abajo ni tab en ultima fila
  // y si se pulsa si aadir
  with (Sender as TDbGrid) do
  begin
    if key = 19 then  //si se pulsa Pausa validar
      if (datasource.dataset.state = dsinsert)
          or (datasource.dataset.state = dsedit) then
        datasource.dataset.post;
  end;
end;

end.
