unit UnidadTotalGastosIngreros;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, DBGrids, Db, DBTables, StdCtrls, ExtCtrls, ActnList, Buttons, 
  Qrctrls, QuickRpt, ComCtrls, ToolWin, Menus, variants;

type
  TFormTGI = class(TForm)
    CTotales: TQuery;
    Tabla: TDBGrid;
    TTabla: TTable;
    DB: TDataSource;
    TTablaTipo: TStringField;
    TTablaImporte: TCurrencyField;
    Panel2: TPanel;
    OpIngresos: TCheckBox;
    OpIngresosDetallado: TCheckBox;
    OpGastos: TCheckBox;
    OpGastosDetallado: TCheckBox;
    ActionList1: TActionList;
    ActCalcular: TAction;
    BCalcular: TBitBtn;
    Panel14: TPanel;
    Panel16: TPanel;
    Label20: TLabel;
    TxtTotalIngresos: TStaticText;
    Panel18: TPanel;
    Label13: TLabel;
    TxtDiferencia: TStaticText;
    Panel1: TPanel;
    Label1: TLabel;
    TxtTotalGastos: TStaticText;
    LImpresion: TQuickRep;
    QRBand4: TQRBand;
    QRBand5: TQRBand;
    QRSysData1: TQRSysData;
    QRBand8: TQRBand;
    QRSysData3: TQRSysData;
    QRSysData7: TQRSysData;
    LEmpresa: TQRLabel;
    QRBand2: TQRBand;
    QRDBText5: TQRDBText;
    QRDBText6: TQRDBText;
    QRBand6: TQRBand;
    QRLabel47: TQRLabel;
    QRLabel48: TQRLabel;
    LGastos: TQRLabel;
    LIngresos: TQRLabel;
    LDiferencia: TQRLabel;
    QRLabel1: TQRLabel;
    QRLabel2: TQRLabel;
    QRLabel3: TQRLabel;
    QRShape1: TQRShape;
    BImprimir: TBitBtn;
    Label2: TLabel;
    TxtGastosKg: TStaticText;
    Label3: TLabel;
    TxtIngresosKg: TStaticText;
    TxtGastosPie: TStaticText;
    Label4: TLabel;
    Label5: TLabel;
    TxtIngresosPie: TStaticText;
    Label6: TLabel;
    TxtDiferenciaKg: TStaticText;
    TxtDiferenciaPie: TStaticText;
    Label7: TLabel;
    Panel3: TPanel;
    Panel4: TPanel;
    QRShape2: TQRShape;
    QRShape3: TQRShape;
    QRLabel4: TQRLabel;
    LGastosKg: TQRLabel;
    LGastosPie: TQRLabel;
    QRLabel6: TQRLabel;
    LIngresosPie: TQRLabel;
    QRLabel7: TQRLabel;
    QRLabel8: TQRLabel;
    LIngresosKg: TQRLabel;
    LDiferenciaPie: TQRLabel;
    QRLabel11: TQRLabel;
    QRLabel12: TQRLabel;
    LDiferenciaKg: TQRLabel;
    CB: TControlBar;
    BB: TToolBar;
    ToolButton2: TToolButton;
    ToolButton1: TToolButton;
    ToolButton4: TToolButton;
    ActCerrar: TAction;
    ActImprimir: TAction;
    ToolButton3: TToolButton;
    PopupMenu1: TPopupMenu;
    Calcular1: TMenuItem;
    Imprimir1: TMenuItem;
    N1: TMenuItem;
    Cerrar1: TMenuItem;
    Shape1: TShape;
    Shape2: TShape;
    Shape5: TShape;
    procedure Button1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);

    procedure calcular(inicial, letra, tipo : string; detallado : boolean);
    procedure calcularAbreviado (inicial, letra, tipo, descrip : string; detallado : boolean);
    procedure BImprimirClick(Sender: TObject);
    procedure ActCerrarExecute(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure OpGastosClick(Sender: TObject);
    procedure OpIngresosClick(Sender: TObject);

  private
    impIngresos, impGastos : double;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormTGI: TFormTGI;

implementation

uses UnidadProcedimientos, UnidadI;

{$R *.DFM}

procedure tformtgi.calcular(inicial, letra, tipo : string; detallado : boolean);
var
  valor, buscar : string;
  importe, importeacumulado : double;
begin
  while not ctotales.eof do
  begin
    if not varisnull(ctotales.fieldbyname('Gasto').value) then
      valor := ctotales.fieldbyname('Gasto').value
    else
      valor := '';
    if not varisnull(ctotales.fieldbyname('Importe').value) then
      importe := ctotales.fieldbyname('Importe').value
    else
      importe := 0;
    if tipo = 'Gastos' then
      impGastos := impGastos + importe
    else
      impIngresos := impIngresos + importe;
    if detallado then
      buscar := inicial + '.' + letra + '. ' + valor
    else
      buscar := inicial + '. ' + tipo;
    if detallado then
    begin
      //para el total del tipo de gasto
      if ttabla.Locate ('Tipo', buscar, []) then
      begin
        if not varisnull(TTablaImporte.AsFloat) then
          importeacumulado := TTablaImporte.AsFloat
        else
          importeacumulado := 0;
        ttabla.edit;
        TTablaImporte.AsFloat := importe + importeacumulado;
      end
      else
      begin
        ttabla.Insert;
        TTablaImporte.AsFloat := importe;
        TTablaTipo.Asstring :=  inicial + '.' + letra + '. ' + valor;
      end;
    end
    else
    begin
      if not ttabla.Locate('Tipo', inicial + '. ' + tipo, []) then
      begin
        ttabla.insert;
        TTablaTipo.Asstring := inicial + '. ' + tipo;
        TTablaImporte.AsFloat := importe;
      end
      else
      begin
        if not varisnull(TTablaImporte.AsFloat) then
          importeacumulado := TTablaImporte.AsFloat
        else
          importeacumulado := 0;
        ttabla.edit;
        TTablaImporte.AsFloat := importeacumulado + importe;
      end;
    end;
    ttabla.post;
    ctotales.Next;
  end;
end;


procedure tformtgi.calcularAbreviado (inicial, letra, tipo, descrip : string; detallado : boolean);
var
  importe, importeAcumulado : double;
begin
  if not varisnull(ctotales.fieldbyname('Importe').value) then
    importe := ctotales.fieldbyname('Importe').value
  else
    importe := 0;
  if tipo = 'Gastos' then
    impGastos := impGastos + importe
  else
    impIngresos := impIngresos + importe;
  if detallado then
  begin
    ttabla.Insert;
    TTablaTipo.Asstring := inicial + '.' + letra + '. ' + descrip;
    TTablaImporte.AsFloat := importe;
  end
  else
  begin
    if not ttabla.Locate ('Tipo', inicial + '. ' + tipo, []) then
    begin
      ttabla.insert;
      TTablaTipo.Asstring := inicial + '. ' + tipo;
      TTablaImporte.AsFloat := importe;
    end
    else
    begin
      if not varisnull(ttablaimporte.asfloat) then
        importeacumulado := ttablaimporte.asfloat
      else
        importeacumulado := 0;
      ttabla.edit;
      TTablaImporte.AsFloat := importe + importeacumulado;
    end;
  end;
  ttabla.post;
end;

procedure TFormTGI.Button1Click(Sender: TObject);
var
  numeroPies, totalKg : double;
  impGA, impGB, impGC, impGD : double;
  impIA, impIB : double;
begin
  screen.Cursor := crHourGlass;
  formi.B.Visible := false;
  formi.l.Caption := 'Calculando total...';
  formi.show;
  formi.refresh;
  try
    tabla.Visible := false;
    impGastos := 0;
    impIngresos := 0;
    impga := 0;
    impgb := 0;
    impgc := 0;
    ttabla.close;
    ttabla.Exclusive := true;
    ttabla.EmptyTable;
    ttabla.Exclusive := false;
    ttabla.open;
    if OpGastos.Checked then  //calcular gastos
    begin
      formi.l.Caption := 'Calculando GASTOS de partes de trabajo...';
      formi.refresh;
      //gastos partes de trabajo
      ctotales.close;
      ctotales.SQL.Clear;
      ctotales.SQL.add ('SELECT t.Trabajo Gasto, SUM(gg.ImporteTotal) Importe');
      ctotales.SQL.add ('FROM trabajorealizado t, parte gg');
      ctotales.SQL.add ('WHERE gg.IDTrabajo = t.id');
      ctotales.SQL.add ('GROUP BY t.Trabajo');
      ctotales.open;
      ctotales.first;
      calcular ('     G', 'A', 'Gastos', OpGastosDetallado.Checked);
      //para el total del grupo de tipos de gastos
      if OpGastosDetallado.Checked then
      begin
        impGA := impGastos;
        ttabla.Insert;
        TTablaImporte.AsFloat := impGA;
        TTablaTipo.Asstring :=  '  G.A. Mano de obra (partes de trabajo)';
      end;
      //partes de productos
      formi.l.Caption := 'Calculando GASTOS de partes de tratamientos...';
      formi.refresh;
      ctotales.close;
      ctotales.SQL.Clear;
      ctotales.SQL.add ('SELECT SUM(TotalFactura) Importe');
      ctotales.SQL.add ('FROM facturas');
      ctotales.open;
      calcularAbreviado('     G', 'B1', 'Gastos',
          'Productos fitosanitarios y nutricionales para tratamientos',
          OpGastosDetallado.checked);
      //partes de agua de riego
      formi.l.Caption := 'Calculando GASTOS de partes de agua de riego...';
      formi.refresh;
      ctotales.close;
      ctotales.SQL.Clear;
      ctotales.SQL.add ('SELECT SUM(ImporteTotalParte) Importe');
      ctotales.SQL.add ('FROM aguariego');
      ctotales.open;
      calcularAbreviado('     G', 'B2', 'Gastos',
          'Productos fitosanitarios y nutricionales para riego', OpGastosDetallado.checked);
      //para el total del grupo de tipos de gastos
      if OpGastosDetallado.Checked then
      begin
        impGB := impGastos - impGA;
        ttabla.Insert;
        TTablaImporte.AsFloat := impGB;
        TTablaTipo.Asstring := '  G.B. Total';
      end;

      //gastos generales
      formi.l.Caption := 'Calculando GASTOS generales...';
      formi.refresh;
      ctotales.close;
      ctotales.SQL.Clear;
      ctotales.SQL.add ('SELECT t.Gasto, SUM(gg.Importe) Importe');
      ctotales.SQL.add ('FROM tipogasto t, gastosgenerales gg');
      ctotales.SQL.add ('WHERE gg.IDTipoGasto=t.id');
      ctotales.SQL.add ('GROUP BY t.Gasto');
      ctotales.open;
      ctotales.first;
      calcular ('     G', 'C', 'Gastos', OpGastosDetallado.Checked);
      formi.l.Caption := 'Calculando GASTOS comunes de fincas...';
      formi.refresh;
      //gastos comunes
      ctotales.close;
      ctotales.SQL.Clear;
      ctotales.SQL.add ('SELECT t.Gasto, SUM(gg.Importe) Importe');
      ctotales.SQL.add ('FROM tipogasto t, gastosfincas gg');
      ctotales.SQL.add ('WHERE gg.IDTipoGasto = t.id');
      ctotales.SQL.add ('GROUP BY t.Gasto');
      ctotales.open;
      ctotales.first;
      calcular ('     G', 'C', 'Gastos', OpGastosDetallado.Checked);
      formi.l.Caption := 'Calculando GASTOS de sectores/variedades...';
      formi.refresh;
      //gastos variedades
      ctotales.close;
      ctotales.SQL.Clear;
      ctotales.SQL.add ('SELECT t.Gasto, SUM(gg.Importe) Importe');
      ctotales.SQL.add ('FROM tipogasto t, gastosvariedades gg');
      ctotales.SQL.add ('WHERE gg.IDTipoGasto = t.id');
      ctotales.SQL.add ('GROUP BY t.Gasto');
      ctotales.open;
      ctotales.first;
      calcular ('     G', 'C', 'Gastos', OpGastosDetallado.Checked);

      //para el total del grupo de tipos de gastos
      if OpGastosDetallado.Checked then
      begin
        impGC := impGastos - impGA - impGB;
        ttabla.Insert;
        TTablaImporte.AsFloat := impGC;
        TTablaTipo.Asstring := '  G.C. Total';
      end;

      formi.l.Caption := 'Calculando GASTOS de taller de maquinaria...';
      formi.refresh;
      
      //gastos maquinaria
      ctotales.close;
      ctotales.SQL.Clear;
      ctotales.SQL.add ('SELECT SUM(Importe) Importe');
      ctotales.SQL.add ('FROM gastosmaquinaria');
      ctotales.open;
      calcularAbreviado('     G', 'D1', 'Gastos',
          'Taller (reparaciones y mantenimiento', OpGastosDetallado.checked);

      //gastos de desgaste de maquinaria (segn horas de trabajo)
      formi.l.Caption := 'Calculando GASTOS de desgastes de maquinaria...';
      formi.refresh;
      ctotales.close;
      ctotales.SQL.Clear;
      ctotales.SQL.add ('SELECT SUM(h.horas * m.preciohora) Importe');
      ctotales.SQL.add ('FROM horasmaquinaria h, maquinaria m');
      ctotales.SQL.add ('WHERE h.IDMaquinaria = m.ID');
      ctotales.open;
      calcularAbreviado('     G', 'D2', 'Gastos', 'Desgaste de Maquinaria',
          OpGastosDetallado.checked);

      //para el total del grupo de tipos de gastos
      if OpGastosDetallado.Checked then
      begin
        impGD := impGastos - impGA - impGB - impGC;
        ttabla.Insert;
        TTablaImporte.AsFloat := impGD;
        TTablaTipo.Asstring := '  G.D. Total';
      end;
      //para el total de gastos
      if OpGastosDetallado.Checked then
      begin
        ttabla.Insert;
        TTablaImporte.AsFloat := impGastos;
        TTablaTipo.Asstring := 'G. Total GASTOS';
      end;
    end;

    //INGRESOS:
    if OpIngresos.Checked then
    begin
      formi.l.Caption := 'Calculando INGRESOS de vales de fruta...';
      formi.refresh;
      //vales
      ctotales.close;
      ctotales.SQL.Clear;
      //ctotales.SQL.add ('SELECT SUM(ImporteTotal) Importe');
      ctotales.SQL.add ('SELECT SUM((vv.ImporteTotal/vv.PesoNeto) * (vv.PesoNeto - (va.PorcentajeDestrio * vv.PesoNeto)/100)) Importe');      
      ctotales.SQL.add ('FROM variedadesvales vv, variedades va');
      ctotales.SQL.add ('WHERE vv.idvariedad = va.id');
      ctotales.open;
      calcularabreviado('     I', 'A', 'Ingresos', 'Vales de fruta',
          OpIngresosDetallado.Checked);
      impIA := impIngresos;
      formi.l.Caption := 'Calculando INGRESOS de otros ingresos...';
      formi.refresh;
      //otros ingresos
      ctotales.close;
      ctotales.SQL.Clear;
      ctotales.SQL.add ('SELECT t.Nombre Gasto, SUM(gg.Importe) Importe');
      ctotales.SQL.add ('FROM tipoingreso t, otrosingresosgenerales gg');
      ctotales.SQL.add ('WHERE gg.IDTipoIngreso = t.id');
      ctotales.SQL.add ('GROUP BY t.Nombre');
      ctotales.open;
      ctotales.first;
      calcular('     I', 'B', 'Ingresos', OpIngresosDetallado.Checked);
      //para el total de grupo de ingresos
      if OpIngresosDetallado.Checked then
      begin
        impIB := impIngresos - impIA;
        ttabla.Insert;
        TTablaImporte.AsFloat := impIB;
        TTablaTipo.Asstring := '  I.B. Total';
      end;

      //para el total de ingresos
      if OpIngresosDetallado.Checked then
      begin
        ttabla.Insert;
        TTablaImporte.AsFloat := impIngresos;
        TTablaTipo.Asstring := 'I. Total INGRESOS';
      end;
    end;

    ctotales.close;
    ctotales.SQL.clear;
    ctotales.sql.add ('select sum(numArboles) Pies');
    ctotales.sql.add('from variedadesfincas');
    ctotales.open;
    if not varisnull(ctotales.fieldbyname('Pies').value) then
      numeroPies := ctotales.fieldbyname('Pies').value
    else
      numeroPies := 0;
    ctotales.close;
    ctotales.SQL.clear;
    ctotales.sql.add ('select sum(PesoNeto) Peso');
    ctotales.sql.add('from variedadesVales');
    ctotales.open;
    if not varisnull(ctotales.fieldbyname('Peso').value) then
      totalKg := ctotales.fieldbyname('Peso').value
    else
      totalKg := 0;
    Tabla.DataSource := db;
    ttabla.first;



    TxtTotalIngresos.caption := formatfloat('###,###,###,##0;-###,###,###,##0;0',
        impIngresos) + ' ' + vtmonedaempresa;
    TxtTotalGastos.caption := formatfloat('###,###,###,##0;-###,###,###,##0;0',
        impGastos) + ' ' + vtmonedaempresa;
    TxtDiferencia.caption := formatfloat('###,###,###,##0;-###,###,###,##0;0',
        impingresos - impgastos) + ' ' + vtmonedaempresa;
    if numeropies = 0 then
      txtgastospie.Caption := '0 ' + vtmonedaempresa
    else
      TxtGastosPie.caption := formatfloat('###,###,###,##0.00;-###,###,###,##0.00;0',
          impgastos/numeropies) + ' ' + vtmonedaempresa;
    if totalkg = 0 then
      txtgastoskg.Caption := '0 ' + vtmonedaempresa
    else
      TxtGastoskg.caption := formatfloat('###,###,###,##0.00;-###,###,###,##0.00;0',
          impgastos/totalkg) + ' ' + vtmonedaempresa;
    if numeropies = 0 then
      txtingresospie.Caption := '0 ' + vtmonedaempresa
    else
      TxtingresosPie.caption := formatfloat('###,###,###,##0.00;-###,###,###,##0.00;0',
          impingresos/numeropies) + ' ' + vtmonedaempresa;
    if totalkg = 0 then
      txtingresoskg.Caption := '0 ' + vtmonedaempresa
    else
      Txtingresoskg.caption := formatfloat('###,###,###,##0.00;-###,###,###,##0.00;0',
          impingresos/totalkg) + ' ' + vtmonedaempresa;
    if numeropies = 0 then
      txtdiferenciapie.Caption := '0 ' + vtmonedaempresa
    else
      TxtDiferenciaPie.caption := formatfloat('###,###,###,##0.00;-###,###,###,##0.00;0',
          (impingresos-impgastos)/numeropies) + ' ' + vtmonedaempresa;
    if totalkg = 0 then
      txtdiferenciakg.Caption := '0 ' + vtmonedaempresa
    else
      TxtDiferenciakg.caption := formatfloat('###,###,###,##0.00;-###,###,###,##0.00;0',
          (impingresos-impgastos)/totalkg) + ' ' + vtmonedaempresa;
    ActImprimir.Enabled := true;
    tabla.Visible := true;    
  except
    screen.Cursor := crDefault;
    formi.close;
    raise
  end;
  screen.Cursor := crDefault;
  formi.close;
end;

procedure TFormTGI.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  screen.Cursor := crDefault;
  action := cafree;
end;

procedure TFormTGI.FormCreate(Sender: TObject);
var
  tmp : string;
begin
  tmp := extractfilepath(application.exename) + 'TEMP';
  if not directoryexists(tmp) then
    mkdir(tmp);
  if not fileexists(tmp + '\tt.db') then
  begin
    with TTabla do
    begin
      DatabaseName := tmp;
      TableName := 'TT.DB';
      TableType := ttParadox;
      with FieldDefs do
      begin
        Clear;
        Add('ID', ftautoinc, 0, false);
        Add('Tipo', ftString, 200, False);
        Add('Importe', ftcurrency, 0, False);
      end;
      IndexDefs.Clear;
      IndexDefs.Add('IndiceID', 'ID', [ixPrimary, ixUnique]);
      CreateTable;
      Open;
    end;
  end;
  ttabla.DatabaseName := tmp;
end;

procedure TFormTGI.BImprimirClick(Sender: TObject);
begin
  if TxtDiferencia.Caption = '' then
    msInfo ('No hay datos para imprimir, pulse "Calcular" antes de imprimir.',
        'Informacin...')
  else
  begin
    lgastos.caption := txttotalgastos.Caption;
    LIngresos.Caption := TxtTotalIngresos.Caption;
    LDiferencia.Caption := TxtDiferencia.Caption;
    lgastospie.caption := txtgastospie.Caption;
    lgastoskg.caption := txtgastoskg.Caption;
    LIngresospie.Caption := TxtIngresospie.Caption;
    LIngresoskg.Caption := TxtIngresoskg.Caption;
    LDiferenciakg.Caption := TxtDiferenciakg.Caption;
    LDiferenciapie.Caption := TxtDiferenciapie.Caption;
    lempresa.caption :=  inttostr(vtidempresa) + ' - ' +
          vtnombreempresa + ' [' + datetostr (vtinicioempresa) +
          ' - ' + datetostr (vtfinempresa) + ']';
    limpresion.ReportTitle := 'LISTADO DE TOTALES FINALES (GASTOS E INGRESOS)';
    limpresion.PreviewModal;
  end;
end;

procedure TFormTGI.ActCerrarExecute(Sender: TObject);
begin
  close;
end;

procedure TFormTGI.FormShow(Sender: TObject);
begin
  screen.cursor:=crdefault;
end;

procedure TFormTGI.OpGastosClick(Sender: TObject);
begin
  if (not OpGastos.Checked) and (not OpIngresos.Checked) then
    actCalcular.Enabled := false
  else
    actCalcular.Enabled := true;
  OpGastosDetallado.visible := OpGastos.Checked;
  if not opgastosdetallado.Visible then
    opgastosdetallado.Checked := false;
end;

procedure TFormTGI.OpIngresosClick(Sender: TObject);
begin
  if (not OpGastos.Checked) and (not OpIngresos.Checked) then
    actCalcular.Enabled := false
  else
    actCalcular.Enabled := true;
  OpIngresosDetallado.visible := OpIngresos.Checked;
  if not OpIngresosDetallado.Visible then
    OpIngresosDetallado.Checked := false;
end;

end.
