unit UnidadTotales;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, ToolWin, ExtCtrls, StdCtrls, Grids, DBGrids, DBCtrls, Mask,
  Buttons;

type
  TFormTotales = class(TForm)
    CB: TControlBar;
    BB: TToolBar;
    ToolButton2: TToolButton;
    ToolButton1: TToolButton;
    ToolButton4: TToolButton;
    GroupBox1: TGroupBox;
    Label7: TLabel;
    Label13: TLabel;
    Label18: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    BCalcularResultado: TBitBtn;
    TxtPeriodo: TPanel;
    Label16: TLabel;
    Label17: TLabel;
    TxtDesde: TMaskEdit;
    TxtHasta: TMaskEdit;
    TxtTipoGasto: TDBLookupComboBox;
    OpTodosGastos: TCheckBox;
    OpSinPeriodo: TCheckBox;
    TxtTerceros: TDBLookupComboBox;
    OpTodosTerceros: TCheckBox;
    BImprimirTotales: TBitBtn;
    TablaTotales: TDBGrid;
    Panel1: TPanel;
    Panel8: TPanel;
    Label12: TLabel;
    TxtTotal: TStaticText;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure ToolButton4Click(Sender: TObject);
    procedure BCalcularResultadoClick(Sender: TObject);
    procedure BImprimirTotalesClick(Sender: TObject);
    procedure OpSinPeriodoClick(Sender: TObject);
    procedure OpTodosGastosClick(Sender: TObject);
    procedure OpTodosTercerosClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormTotales: TFormTotales;

implementation

{$R *.DFM}

procedure TFormTotales.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  screen.cursor:=crdefault;
  action:=cafree;
end;

procedure TFormTotales.FormShow(Sender: TObject);
begin
  try
    tlistaproductos.Open;
    tfincas.open;
    tsectores.open;
    ttotalproductos.open;
    txtdesde.text:=datetostr(formmenuprincipal.vtinicioempresa);
    txthasta.text:=datetostr(formmenuprincipal.vtfinempresa);
    if formmenuprincipal.VTMostrarBBVentanas=1 then
      cb.visible:=true
    else
      cb.visible:=false;
    if formmenuprincipal.vtflat=1 then
    begin
      bb.flat:=true;
    end
    else
    begin
      bb.flat:=false;
    end;
  except
  end;
  screen.cursor:=crdefault;
end;

procedure TFormTotales.ToolButton4Click(Sender: TObject);
begin
  close;
end;

procedure TFormTotales.BCalcularResultadoClick(Sender: TObject);
var
  Filtro, campo, operador, FechaDesde, fechahasta: string;
  ImporteTotal, Importe: double;
begin
   if (dgasto.dataset.state=dsinsert) or (dgasto.dataset.state=dsedit) then
     dgasto.dataset.post;
   ttotales.open;
   datos.dgastosgenerales.dataset.open;
   dtotales.dataset.First;
   while not dtotales.DataSet.eof do
   begin
     dtotales.dataset.Delete;
   end;
   datos.tgastosgenerales.filter:='';
   //Filtrar el periodo
   if not (opsinperiodo.Checked) then
   begin
     fechadesde:=quotedstr(txtdesde.text);
     fechahasta:=quotedstr(txthasta.text);
     operador:='>=';
     campo:='Fecha';
     datos.tgastosgenerales.filter:=Format ('[%s] %s %s', [Campo, operador, Fechadesde]);
     operador:='<=';
     datos.tgastosgenerales.filter:=Format ('%s AND [%s] %s %s', [datos.tgastosgenerales.filter, Campo, operador, fechahasta]);
   end;
   //Filtrar el tipo de gasto
   if not (optodosgastos.Checked) then
   begin
     filtro:=quotedstr(txttipogasto.keyvalue);
     operador:='=';
     campo:='IDTipoGasto';
     if datos.tgastosgenerales.filter='' then
       datos.tgastosgenerales.filter:=Format ('[%s] %s %s', [Campo, operador, filtro])
     else
       datos.tgastosgenerales.filter:=Format ('%s AND [%s] %s %s', [datos.tgastosgenerales.filter, Campo, operador, filtro]);
   end;
   //Filtrar el tercero
   if not (optodosterceros.Checked) then
   begin
     filtro:=quotedstr(txtterceros.keyvalue);
     operador:='=';
     campo:='IDTercero';
     if datos.tgastosgenerales.filter='' then
       datos.tgastosgenerales.filter:=Format ('[%s] %s %s', [Campo, operador, filtro])
     else
       datos.tgastosgenerales.filter:=Format ('%s AND [%s] %s %s', [datos.tgastosgenerales.filter, Campo, operador, filtro]);
   end;
   datos.tgastosgenerales.filtered:=true;
   datos.tgastosgenerales.Refresh;
   datos.dgastosgenerales.dataset.first;
   importetotal:=0;
   while not datos.dgastosgenerales.dataset.eof do
   begin
     if not varisnull(datos.dgastosgenerales.dataset.fieldbyname('Importe').value) then
       Importe:=datos.dgastosgenerales.dataset.fieldbyname('Importe').value
     else
       importe:=0;
     dtotales.dataset.insert;
     dtotales.dataset.fieldbyname('Fecha').value:=datos.dgastosgenerales.dataset.fieldbyname('Fecha').value;
     dtotales.dataset.fieldbyname('Gasto').value:=datos.dgastosgenerales.dataset.fieldbyname('LGasto').value;
     dtotales.dataset.fieldbyname('Tercero').value:=datos.dgastosgenerales.dataset.fieldbyname('LTercero').value;
     if not varisnull(datos.dgastosgenerales.dataset.fieldbyname('Nota').value) then
       dtotales.dataset.fieldbyname('Nota').value:=datos.dgastosgenerales.dataset.fieldbyname('Nota').value;
     dtotales.dataset.fieldbyname('Importe').value:=importe;
     dtotales.dataset.post;
     ImporteTotal:=ImporteTotal+Importe;
     datos.dgastosgenerales.dataset.next;
   end;
   txttotal.caption:=formatfloat('###,###,###,##0;-###,###,###,##0;0',importetotal) + ' ' + formmenuprincipal.vtmonedaempresa;
end;

procedure TFormTotales.BImprimirTotalesClick(Sender: TObject);
begin
  lempresa2.caption:=formmenuprincipal.vtnombreempresa;
  if not txtperiodo.Visible then
    ldesde.caption:='Todos los das'
  else
    ldesde.caption:='Desde el ' + txtdesde.text + '  Hasta el ' + txthasta.text;
  if not txttipogasto.Visible then
    lgasto.caption:='Todos los gastos'
  else
    lgasto.caption:=dtiposgastos.dataset.fieldbyname('Gasto').value;
  if not txtterceros.Visible then
    ltercero.caption:='Todos los terceros'
  else
    ltercero.caption:=dterceros.dataset.fieldbyname('Nombre').value;
  limportetotal.caption:=txttotal.caption;
  limpresiontotales.ReportTitle:='LISTADO DE TOTALES DE GASTOS GENERALES';
  limpresiontotales.Preview;
end;

procedure TFormTotales.OpSinPeriodoClick(Sender: TObject);
begin
  if opsinperiodo.Checked then
    txtperiodo.visible:=false
  else
    txtperiodo.visible:=true;
end;

procedure TFormTotales.OpTodosGastosClick(Sender: TObject);
begin
  if optodosgastos.Checked then
    txttipogasto.visible:=false
  else
    txttipogasto.visible:=true;
end;



procedure TFormTotales.OpTodosTercerosClick(Sender: TObject);
begin
  if optodosterceros.Checked then
    txtterceros.visible:=false
  else
    txtterceros.visible:=true;
end;

end.
