unit UnidadTotalesGastosGenerales;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, ToolWin, ExtCtrls, Qrctrls, QuickRpt, StdCtrls, Grids, DBGrids,
  DBCtrls, Mask, Buttons, Db, DBTables, ActnList, variants;

type
  TFormTotalesGastosGenerales = class(TForm)
    CB: TControlBar;
    BB: TToolBar;
    ToolButton2: TToolButton;
    ToolButton1: TToolButton;
    ToolButton4: TToolButton;
    TablaTotales: TDBGrid;
    Panel1: TPanel;
    Panel8: TPanel;
    Label12: TLabel;
    TxtTotal: TStaticText;
    LImpresionTotales: TQuickRep;
    QRBand2: TQRBand;
    QRShape2: TQRShape;
    QRLabel13: TQRLabel;
    LDesde: TQRLabel;
    QRLabel4: TQRLabel;
    LGasto: TQRLabel;
    QRLabel20: TQRLabel;
    LTercero: TQRLabel;
    QRBand3: TQRBand;
    QRDBText4: TQRDBText;
    QRDBText7: TQRDBText;
    QRDBText3: TQRDBText;
    QRDBText10: TQRDBText;
    QRDBText11: TQRDBText;
    QRBand4: TQRBand;
    QRLabel15: TQRLabel;
    QRLabel17: TQRLabel;
    QRLabel11: TQRLabel;
    QRLabel19: TQRLabel;
    QRLabel18: TQRLabel;
    QRBand5: TQRBand;
    QRSysData6: TQRSysData;
    QRSysData5: TQRSysData;
    LEmpresa2: TQRLabel;
    PageHeaderBand2: TQRBand;
    LTitulo2: TQRSysData;
    TTotales: TTable;
    DTotales: TDataSource;
    TTerceros: TTable;
    DTerceros: TDataSource;
    TTiposGastos: TTable;
    DTiposGastos: TDataSource;
    Panel2: TPanel;
    Label7: TLabel;
    TxtTipoGasto: TDBLookupComboBox;
    OpTodosGastos: TCheckBox;
    Label13: TLabel;
    TxtTerceros: TDBLookupComboBox;
    Label3: TLabel;
    OpTodosTerceros: TCheckBox;
    Label4: TLabel;
    TxtPeriodo: TPanel;
    Label16: TLabel;
    Label17: TLabel;
    TxtDesde: TMaskEdit;
    TxtHasta: TMaskEdit;
    OpSinPeriodo: TCheckBox;
    Label18: TLabel;
    BCalcularResultado: TBitBtn;
    OpTodos: TCheckBox;
    Panel3: TPanel;
    BImprimirTotales: TBitBtn;
    SummaryBand1: TQRBand;
    QRExpr1: TQRExpr;
    ActionList1: TActionList;
    ActCalcular: TAction;
    ActImprimir: TAction;
    ActCerrar: TAction;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure ToolButton4Click(Sender: TObject);
    procedure BCalcularResultadoClick(Sender: TObject);
    procedure BImprimirTotalesClick(Sender: TObject);
    procedure OpSinPeriodoClick(Sender: TObject);
    procedure OpTodosTercerosClick(Sender: TObject);
    procedure OpTodosClick(Sender: TObject);
    procedure OpTodosGastosClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormTotalesGastosGenerales: TFormTotalesGastosGenerales;

implementation

uses UnidadDatos, UnidadI, unidadprocedimientos;

{$R *.DFM}

procedure TFormTotalesGastosGenerales.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  tterceros.close;
  ttiposgastos.close;
  screen.cursor:=crdefault;
  action:=cafree;
end;

procedure TFormTotalesGastosGenerales.FormShow(Sender: TObject);
begin
  tterceros.IndexFieldNames := 'Nombre';
  ttiposgastos.IndexFieldNames := 'Gasto';
  tterceros.open;
  ttiposgastos.open;
  txtdesde.text:=datetostr(vtinicioempresa);
  txthasta.text:=datetostr(vtfinempresa);
  screen.cursor:=crdefault;
end;

procedure TFormTotalesGastosGenerales.ToolButton4Click(Sender: TObject);
begin
  close;
end;

procedure TFormTotalesGastosGenerales.BCalcularResultadoClick(Sender: TObject);
var
  Filtro, campo, operador, FechaDesde, fechahasta: string;
  ImporteTotal, Importe: double;
begin
  try
     screen.cursor:=crhourglass;
     formi.b.min := 0;
     formi.L.caption := 'Calculando totales, espere por favor...';
     formi.show;
     formi.Refresh;
     ttotales.open;
     datos.dgastosgenerales.dataset.open;
     ttotales.close;
     ttotales.Exclusive := true;
     ttotales.EmptyTable;
     ttotales.Exclusive := false;
     ttotales.open;
     datos.tgastosgenerales.filter:='';
     //Filtrar el periodo
     if not (opsinperiodo.Checked) then
     begin
       fechadesde:=quotedstr(txtdesde.text);
       fechahasta:=quotedstr(txthasta.text);
       operador:='>=';
       campo:='Fecha';
       datos.tgastosgenerales.filter:=Format ('[%s] %s %s', [Campo, operador, Fechadesde]);
       operador:='<=';
       datos.tgastosgenerales.filter:=Format ('%s AND [%s] %s %s', [datos.tgastosgenerales.filter, Campo, operador, fechahasta]);
     end;
     //Filtrar el tipo de gasto
     if not (optodosgastos.Checked) then
     begin
       filtro:=quotedstr(txttipogasto.keyvalue);
       operador:='=';
       campo:='IDTipoGasto';
       if datos.tgastosgenerales.filter='' then
         datos.tgastosgenerales.filter:=Format ('[%s] %s %s', [Campo, operador, filtro])
       else
         datos.tgastosgenerales.filter:=Format ('%s AND [%s] %s %s', [datos.tgastosgenerales.filter, Campo, operador, filtro]);
     end;
     //Filtrar el tercero
     if not (optodosterceros.Checked) then
     begin
       filtro:=quotedstr(txtterceros.keyvalue);
       operador:='=';
       campo:='IDTercero';
       if datos.tgastosgenerales.filter='' then
         datos.tgastosgenerales.filter:=Format ('[%s] %s %s', [Campo, operador, filtro])
       else
         datos.tgastosgenerales.filter:=Format ('%s AND [%s] %s %s', [datos.tgastosgenerales.filter, Campo, operador, filtro]);
     end;
     datos.tgastosgenerales.filtered:=true;
     datos.tgastosgenerales.Refresh;
     datos.dgastosgenerales.dataset.first;
     importetotal:=0;
     formi.b.max:=datos.dgastosgenerales.dataset.recordcount;
     while not datos.dgastosgenerales.dataset.eof do
     begin
       formi.b.position:=datos.tgastosgenerales.recno;
       if not varisnull(datos.dgastosgenerales.dataset.fieldbyname('Importe').value) then
         Importe:=datos.dgastosgenerales.dataset.fieldbyname('Importe').value
       else
         importe:=0;
       dtotales.dataset.insert;
       dtotales.dataset.fieldbyname('Fecha').value:=datos.dgastosgenerales.dataset.fieldbyname('Fecha').value;
       dtotales.dataset.fieldbyname('Gasto').value:=datos.dgastosgenerales.dataset.fieldbyname('LGasto').value;
       dtotales.dataset.fieldbyname('Tercero').value:=datos.dgastosgenerales.dataset.fieldbyname('LTercero').value;
       if not varisnull(datos.dgastosgenerales.dataset.fieldbyname('Nota').value) then
         dtotales.dataset.fieldbyname('Nota').value:=datos.dgastosgenerales.dataset.fieldbyname('Nota').value;
       dtotales.dataset.fieldbyname('Importe').value:=importe;
       dtotales.dataset.post;
       ImporteTotal:=ImporteTotal+Importe;
       datos.dgastosgenerales.dataset.next;
     end;
     txttotal.caption:=formatfloat('###,###,###,##0;-###,###,###,##0;0',importetotal) + ' ' + vtmonedaempresa;
  except
    formi.close;
    screen.cursor:=crdefault;
    raise;
  end;
  formi.close;
  screen.cursor:=crdefault;
end;

procedure TFormTotalesGastosGenerales.BImprimirTotalesClick(Sender: TObject);
begin
  lempresa2.caption:=inttostr(vtidempresa) + ' - ' +
     vtnombreempresa + ' [' + datetostr (vtinicioempresa) +
     ' - ' + datetostr (vtfinempresa) + ']';
  if not txtperiodo.Visible then
    ldesde.caption:='Todos los das'
  else
    ldesde.caption:='Desde el ' + txtdesde.text + '  Hasta el ' + txthasta.text;
  if not txttipogasto.Visible then
    lgasto.caption:='Todos los gastos'
  else
    lgasto.caption:=dtiposgastos.dataset.fieldbyname('Gasto').value;
  if not txtterceros.Visible then
    ltercero.caption:='Todos los terceros'
  else
    ltercero.caption:=dterceros.dataset.fieldbyname('Nombre').value;
  limpresiontotales.ReportTitle:='LISTADO DE TOTALES DE GASTOS GENERALES';
  limpresiontotales.PreviewModal;
end;

procedure TFormTotalesGastosGenerales.OpSinPeriodoClick(Sender: TObject);
begin
  txtperiodo.visible := not opsinperiodo.Checked;
end;

procedure TFormTotalesGastosGenerales.OpTodosTercerosClick(Sender: TObject);
begin
  txtterceros.visible := not optodosterceros.Checked;
end;


procedure TFormTotalesGastosGenerales.OpTodosClick(Sender: TObject);
begin
  optodosgastos.Checked := optodos.Checked;
  optodosterceros.Checked := optodos.Checked;
  opsinperiodo.checked := optodos.Checked;
end;

procedure TFormTotalesGastosGenerales.OpTodosGastosClick(Sender: TObject);
begin
  txttipogasto.visible := not optodosgastos.Checked;
end;

end.
