unit UnidadTrabajo;

interface

uses
  Windows, Messages, Classes, SysUtils, Graphics, Controls, StdCtrls, Forms,
  Dialogs, DBCtrls, DB, DBGrids, Grids, DBTables, ExtCtrls, Buttons,
  ComCtrls, Qrctrls, QuickRpt, ToolWin, Menus, ActnList,bde, variants;

type
  TFormTrabajo = class(TForm)
    DBD: TDataSource;
    ScrollBox1: TScrollBox;
    TTabla: TTable;
    LImpresion: TQuickRep;
    TitleBand1: TQRBand;
    QRSubDetail2: TQRSubDetail;
    QRDBText15: TQRDBText;
    QRDBText1: TQRDBText;
    GroupHeaderBand1: TQRBand;
    QRLabel11: TQRLabel;
    QRLabel12: TQRLabel;
    QRBand6: TQRBand;
    QRSysData4: TQRSysData;
    QRSysData7: TQRSysData;
    LEmpresa: TQRLabel;
    PageHeaderBand1: TQRBand;
    LTitulo: TQRSysData;
    CB: TControlBar;
    BB: TToolBar;
    ToolButton1: TToolButton;
    ToolButton3: TToolButton;
    ToolButton2: TToolButton;
    ToolBar2: TToolBar;
    Panel1: TPanel;
    LBuscar: TLabel;
    TxtBuscar: TEdit;
    OpOrdenarNombre: TRadioButton;
    RadioButton2: TRadioButton;
    Panel2: TPanel;
    Panel3: TPanel;
    Navegador: TDBNavigator;
    BAnadir: TBitBtn;
    BEliminar: TBitBtn;
    Tabla: TDBGrid;
    N: TStaticText;
    PopupMenu1: TPopupMenu;
    Aadirnuevafinca1: TMenuItem;
    N1: TMenuItem;
    Previsualizar1: TMenuItem;
    N3: TMenuItem;
    Cerrarventana1: TMenuItem;
    ActionList1: TActionList;
    ActNuevo: TAction;
    ActImprimir: TAction;
    ActCerrar: TAction;
    ActEliminar: TAction;
    Label1: TLabel;
    procedure BCerrarClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure TTablaAfterInsert(DataSet: TDataSet);
    procedure TTablaPostError(DataSet: TDataSet; E: EDatabaseError;
      var Action: TDataAction);
    procedure BEliminarClick(Sender: TObject);
    procedure BPrevisualizarClick(Sender: TObject);
    procedure BAnadirClick(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure OpOrdenarNombreClick(Sender: TObject);
    procedure TxtBuscarChange(Sender: TObject);
    procedure TTablaAfterPost(DataSet: TDataSet);
    procedure DBDDataChange(Sender: TObject; Field: TField);
    procedure TablaKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  FormTrabajo: TFormTrabajo;

implementation

uses UnidadDatos, unidadprocedimientos;

{$R *.DFM}


procedure TFormTrabajo.BEliminarClick(Sender: TObject);
var
  nombre:string;
begin
  if dbd.DataSet.recordcount=0 then
    messagedlg('No hay trabajos para eliminar.',mtinformation,[mbok],0)
  else
  begin
    datos.dpartes.dataset.open;
    if datos.dpartes.DataSet.Locate('IDTrabajo',dbd.DataSet.fieldbyname('ID').value,[]) then
    begin
      messagedlg('El trabajo no se puede eliminar ya que existe en partes de trabajo.',mtinformation,[mbok],0);
      exit;
    end;
    if not (dbd.dataset.fieldbyname('Trabajo').value=Null) then
      Nombre:=dbd.dataset.fieldbyname('Trabajo').value
    else
      nombre:='';
    if messagedlg('Est seguro que desea ELIMINAR el trabajo [' + nombre + ']?',mtconfirmation,[mbno,mbyes],0)=mryes then
      dbd.dataset.delete;
  end;
end;

procedure TFormTrabajo.BPrevisualizarClick(Sender: TObject);
begin
  lempresa.caption :=  inttostr(vtidempresa) + ' - ' +
        vtnombreempresa + ' [' + datetostr (vtinicioempresa) +
        ' - ' + datetostr (vtfinempresa) + ']';
  limpresion.ReportTitle := 'LISTADO DE TRABAJOS REALIZADOS';
  limpresion.PreviewModal;
end;

procedure TFormTrabajo.BCerrarClick(Sender: TObject);
begin
  close;
end;

procedure TFormTrabajo.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  if (dbd.dataset.state=dsinsert) or (dbd.dataset.state=dsedit) then
    dbd.DataSet.post;
  ttabla.close;
  screen.cursor:=crdefault;
  action := caFree;
end;

procedure TFormTrabajo.FormShow(Sender: TObject);
begin
  opordenarnombreclick(sender);
  ttabla.Open;
  screen.cursor:=crdefault;
end;

procedure TFormTrabajo.TTablaAfterInsert(DataSet: TDataSet);
begin
  tabla.setfocus;
  tabla.SelectedIndex:=1;
end;


function GetBDEError(E:EDatabaseError):integer;
var
  i:integer;
begin
  if E is EDBEngineError then
  with EDBEngineError(E) do
    for i:=0 to Errorcount-1 do
    begin
      Result:=Errors[i].errorcode;
      if result<>DBIERR_USERCONSTRERR then
        if result=DBIERR_CONSTRAINTFAILED then
          databaseerror(errors[i].message)
        else if errors[i].nativeerror=0 then
          exit;
    end;
  result:=1;
end;

procedure TFormTrabajo.TTablaPostError(DataSet: TDataSet;
  E: EDatabaseError; var Action: TDataAction);
begin
  case GetBDEError(e) of
     DBIERR_KEYVIOL:
       DatabaseError('Nombre de trabajo ya existente.');
     DBIERR_REQDERR:
       DatabaseError('Faltan datos por introducir en el tipo de trabajo actual (nombre).');
  end;
end;

procedure TFormTrabajo.BAnadirClick(Sender: TObject);
begin
  dbd.dataset.Insert;
end;

procedure TFormTrabajo.OpOrdenarNombreClick(Sender: TObject);
begin
  ttabla.indexfieldnames:='Trabajo';
  lbuscar.caption:='Nombre a &buscar:';
end;

procedure TFormTrabajo.RadioButton2Click(Sender: TObject);
begin
   ttabla.indexfieldnames:='ID';
   lbuscar.caption:='ID a &buscar:';
end;


procedure TFormTrabajo.TxtBuscarChange(Sender: TObject);
begin
  try
    ttabla.findnearest([txtbuscar.text])
  except
    raise;
  end;
end;


procedure TFormTrabajo.TTablaAfterPost(DataSet: TDataSet);
begin
  ttabla.FlushBuffers;
end;

procedure TFormTrabajo.DBDDataChange(Sender: TObject; Field: TField);
begin
  n.caption:=inttostr(dbd.dataset.recno) +
       ' de ' + inttostr(dbd.DataSet.recordcount);
end;

procedure TFormTrabajo.TablaKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  // para no aadir al pulsar tecla abajo ni tab en ultima fila
  // y si se pulsa si aadir
  with (Sender as TDbGrid) do
  begin
    if key = 19 then  //si se pulsa Pausa validar
      if (datasource.dataset.state = dsinsert)
          or (datasource.dataset.state = dsedit) then
        datasource.dataset.post;
  end;
end;

end.
