unit UnidadUsuarios;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ActnList, StdCtrls, ExtCtrls, ComCtrls, ToolWin, DBCtrls, Mask,
  Buttons, Grids, DBGrids, Db, DBTables, inifiles;

type
  TFormUsuarios = class(TForm)
    PopupMenu1: TPopupMenu;
    ActionList1: TActionList;
    CB: TControlBar;
    BB: TToolBar;
    ToolButton1: TToolButton;
    ActControlarSuprimir: TAction;
    ActNuevo: TAction;
    ActEliminar: TAction;
    ActModificar: TAction;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ActRefrescar: TAction;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ActCerrar: TAction;
    Tabla: TDBGrid;
    ActImprimir: TAction;
    Aadir1: TMenuItem;
    Eliminar1: TMenuItem;
    Modificar1: TMenuItem;
    N1: TMenuItem;
    Refrescar1: TMenuItem;
    N2: TMenuItem;
    Cerrar1: TMenuItem;
    ToolButton8: TToolButton;
    ActBuscar: TAction;
    ToolButton9: TToolButton;
    Buscar1: TMenuItem;
    Imprimir1: TMenuItem;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ActControlarSuprimirExecute(Sender: TObject);
    procedure ActNuevoExecute(Sender: TObject);
    procedure ActEliminarExecute(Sender: TObject);
    procedure TablaKeyPress(Sender: TObject; var Key: Char);
    procedure ActModificarExecute(Sender: TObject);
    procedure TablaDblClick(Sender: TObject);
    procedure ActRefrescarExecute(Sender: TObject);
    procedure ActCerrarExecute(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure ActImprimirExecute(Sender: TObject);
    procedure ActBuscarExecute(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormUsuarios: TFormUsuarios;

implementation

uses UnidadMenuPrincipal, UnidadImprimir,
  UnidadLocalizar, UnidadDatos, UnidadGUsuario;

{$R *.DFM}

var
  fp : tformmenuprincipal;
procedure TFormUsuarios.FormClose(Sender: TObject;
  var Action: TCloseAction);
var
  i:integer;
begin
  //Guardar el ancho de las columnas
  with TIniFile.Create(ChangeFileExt(ParamStr(0), '.INI')) do
  try
    for I := 0 to tabla.Columns.Count - 1 do
    begin
      with tabla.Columns.Items[I] do
        WriteInteger('Tabla Usuarios', FieldName, Width);
    end;
  finally
    Free;
  end;
  try
   datos.tusuario.close;
  finally
    screen.cursor := crdefault;
    action := cafree;
  end;
end;

procedure TFormUsuarios.FormShow(Sender: TObject);
begin
  datos.TUsuario.open;
  if formmenuprincipal.vtmostrarbbventanas=1 then
    cb.visible:=true
  else
    cb.visible:=false;
  if formmenuprincipal.vtflat=1 then
  begin
    bb.flat:=true;
  end
  else
  begin
    bb.flat:=false;
  end;
  screen.cursor:=crdefault;
end;

procedure TFormUsuarios.FormCreate(Sender: TObject);
var
  I: Integer;
begin
  with TIniFile.Create(ChangeFileExt(ParamStr(0), '.INI')) do
  try
    for I := 0 to tabla.Columns.Count - 1 do
      with tabla.Columns.Items[I] do
        Width := ReadInteger('Tabla Usuarios', FieldName, Width);
  finally
    Free;
  end;
end;

procedure TFormUsuarios.ActControlarSuprimirExecute(Sender: TObject);
begin
  //
end;

procedure TFormUsuarios.ActNuevoExecute(Sender: TObject);
begin
  datos.TUsuario.Insert;
  application.createform(tformusuariog, formusuariog);
  Formusuariog.Caption := 'Aadir Usuario...';
  formusuariog.ShowModal;
end;

procedure TFormUsuarios.ActEliminarExecute(Sender: TObject);
var
  nombre : String;
begin
  if datos.Tusuario.RecordCount <= 0 then
    fp.msInfo ('No hay usuarios para eliminar.', 'Eliminar...')
  else
  begin
    if datos.TUsuarioTipo.Value = 'Administrador' then
      fp.msInfo ('No se puede eliminar el usuario Administrador.', 'Eliminar...')
    else
    begin
      if not varisnull(datos.TUsuarioNombre.Value) then
        nombre := datos.TUsuarioNombre.Value
      else
        nombre := '';
      if fp.msSi ('Est seguro que desea eliminar el usuario: ' +
          nombre + '?', 'Eliminar...') then
      begin
        try
          datos.TUsuario.delete;
        except
          raise;
        end;
      end;
    end;  
  end;
end;

procedure TFormUsuarios.TablaKeyPress(Sender: TObject;
  var Key: Char);
begin
  if key = chr(13) then
    ActModificarExecute(nil);
end;

procedure TFormUsuarios.ActModificarExecute(Sender: TObject);
begin
  application.createform(tformusuariog, formusuariog);
  Formusuariog.Txtcodigo.Enabled := false;
  datos.TUsuario.edit;
  Formusuariog.Caption := 'Modificar usuario...';
  formusuariog.ShowModal;
end;

procedure TFormUsuarios.TablaDblClick(Sender: TObject);
begin
  ActModificarExecute(nil);
end;

procedure TFormUsuarios.ActRefrescarExecute(Sender: TObject);
begin
  datos.TUsuario.Refresh;
end;

procedure TFormUsuarios.ActCerrarExecute(Sender: TObject);
begin
  close;
end;

procedure TFormUsuarios.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if key = '-' then
    ActEliminarExecute(nil);
  if key = '+' then
    ActNuevoExecute(nil);
  if key = '*' then
    ActModificarExecute(nil);
  if key = chr(27) then  //escape
    ActCerrarExecute(nil);
end;

procedure TFormUsuarios.ActImprimirExecute(Sender: TObject);
begin
  application.createform(tformImprimir, formImprimir);
  formimprimir.Tag := 20;
  formImprimir.showmodal;
end;

procedure TFormUsuarios.ActBuscarExecute(Sender: TObject);
begin
  application.createform(tformLocalizar, formLocalizar);
  FormLocalizar.Tag := 20;
  formLocalizar.showmodal;
end;

end.
