unit UnidadVariedades;

interface

uses
  Windows, Messages, Classes, SysUtils, Graphics, Controls, StdCtrls, Forms,
  Dialogs, DBCtrls, DB, Mask, DBTables, ExtCtrls, ComCtrls, Buttons, Grids,
  DBGrids, Qrctrls, QuickRpt, Menus, ImgList, ToolWin,bde, ActnList, variants;

type
  TFormVariedades = class(TForm)
    DBD: TDataSource;
    TTabla: TTable;
    LImpresion: TQuickRep;
    TitleBand1: TQRBand;
    QRSubDetail2: TQRSubDetail;
    QRDBText11: TQRDBText;
    QRDBText12: TQRDBText;
    QRDBText15: TQRDBText;
    QRDBText1: TQRDBText;
    GroupHeaderBand1: TQRBand;
    QRLabel11: TQRLabel;
    QRLabel12: TQRLabel;
    QRLabel13: TQRLabel;
    QRLabel14: TQRLabel;
    PageFooterBand1: TQRBand;
    QRSysData1: TQRSysData;
    PopupMenu1: TPopupMenu;
    Aadirnuevafinca1: TMenuItem;
    N1: TMenuItem;
    Previsualizar1: TMenuItem;
    N3: TMenuItem;
    Cerrarventana1: TMenuItem;
    QRSysData3: TQRSysData;
    LEmpresa: TQRLabel;
    PageHeaderBand1: TQRBand;
    LTitulo: TQRSysData;
    ScrollBox1: TScrollBox;
    Panel2: TPanel;
    Navegador: TDBNavigator;
    BAnadir: TBitBtn;
    BEliminar: TBitBtn;
    N: TStaticText;
    Panel3: TPanel;
    Tabla: TDBGrid;
    CB: TControlBar;
    BB: TToolBar;
    ToolButton1: TToolButton;
    ToolButton3: TToolButton;
    ToolButton2: TToolButton;
    ToolBar2: TToolBar;
    Panel1: TPanel;
    LBuscar: TLabel;
    TxtBuscar: TEdit;
    OpOrdenarNombre: TRadioButton;
    RadioButton2: TRadioButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    Pasarpreciosavales1: TMenuItem;
    N2: TMenuItem;
    TTipo: TTable;
    DTipo: TDataSource;
    TTablaID: TAutoIncField;
    TTablaNombre: TStringField;
    TTablaPrecio: TFloatField;
    TTablaNota: TStringField;
    TTablaTipo: TStringField;
    TTablaIDTipo: TIntegerField;
    TTablaLTipo: TStringField;
    QRDBText2: TQRDBText;
    QRLabel1: TQRLabel;
    RadioButton1: TRadioButton;
    BActualizar: TBitBtn;
    ActionList1: TActionList;
    ActImprimir: TAction;
    ActPrecios: TAction;
    ActCerrar: TAction;
    ActNuevo: TAction;
    Label1: TLabel;
    ActEliminar: TAction;
    ToolButton6: TToolButton;
    ActActualizarPrecioVariedad: TAction;
    TTablaPorcentajeDestrio: TFloatField;
    procedure BitBtn1Click(Sender: TObject);
    procedure BAnadirClick(Sender: TObject);
    procedure TTablaAfterInsert(DataSet: TDataSet);
    procedure TTablaAfterScroll(DataSet: TDataSet);
    procedure TxtBuscarChange(Sender: TObject);
    procedure TTablaPostError(DataSet: TDataSet; E: EDatabaseError;
      var Action: TDataAction);
    procedure BEliminarClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BPrevisualizarClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure OpOrdenarNombreClick(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure TablaKeyPress(Sender: TObject; var Key: Char);
    procedure BPreciosClick(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure BActualizarClick(Sender: TObject);
    procedure Panel2DblClick(Sender: TObject);
    procedure DBDDataChange(Sender: TObject; Field: TField);
    procedure TTablaAfterPost(DataSet: TDataSet);
    procedure ActActualizarPrecioVariedadExecute(Sender: TObject);
    procedure TablaKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure TTablaBeforePost(DataSet: TDataSet);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  FormVariedades: TFormVariedades;

implementation

uses UnidadDatos, UnidadI, MValesFruta, unidadprocedimientos;


{$R *.DFM}

procedure TFormVariedades.BitBtn1Click(Sender: TObject);
begin
  close;
end;

procedure TFormVariedades.BAnadirClick(Sender: TObject);
begin
  dbd.dataset.Insert;
end;


procedure TFormVariedades.TTablaAfterScroll(DataSet: TDataSet);
begin
  n.caption:=inttostr(dbd.dataset.recno) + ' de ' + inttostr(dbd.DataSet.recordcount);
end;



procedure TFormVariedades.TxtBuscarChange(Sender: TObject);
begin
  try
    ttabla.findnearest([txtbuscar.text])
  except
    raise;
  end;
end;




function GetBDEError(E:EDatabaseError):integer;
var
  i:integer;
begin
  if E is EDBEngineError then
  with EDBEngineError(E) do
    for i:=0 to Errorcount-1 do
    begin
      Result:=Errors[i].errorcode;
      if result<>DBIERR_USERCONSTRERR then
        if result=DBIERR_CONSTRAINTFAILED then
          databaseerror(errors[i].message)
        else if errors[i].nativeerror=0 then
          exit;
    end;
  result:=1;
end;

procedure TFormVariedades.TTablaPostError(DataSet: TDataSet; E: EDatabaseError;
  var Action: TDataAction);
begin
  case GetBDEError(e) of
     DBIERR_KEYVIOL:
       DatabaseError('Nombre de variedad ya existente.');
     DBIERR_REQDERR:
       DatabaseError('Faltan datos por introducir en la variedad actual (nombre y tipo/especie).');
  end;
end;




procedure TFormVariedades.TTablaAfterInsert(DataSet: TDataSet);
begin
  tabla.setfocus;
  tabla.SelectedIndex:=1;  
end;

procedure TFormVariedades.BEliminarClick(Sender: TObject);
var
  nombre: string;
begin
  if dbd.DataSet.recordcount=0 then
    messagedlg('No hay variedades para eliminar.',mtinformation,[mbok],0)
  else
  begin
    if not (dbd.dataset.fieldbyname('Nombre').value=Null) then
      Nombre:=dbd.dataset.fieldbyname('Nombre').value
    else
      nombre:='';
    datos.tvariedadesfinca.open;
    if datos.tvariedadesfinca.Locate('IDVariedad',dbd.DataSet.fieldbyname('ID').value,[]) then
      messagedlg('La variedad [' + nombre + '] No se puede eliminar ya que existe en fincas.',mtinformation,[mbok],0)
    else
      if messagedlg('Est seguro que desea ELIMINAR la variedad [' + nombre + ']?',mtconfirmation,[mbno,mbyes],0)=mryes then
        dbd.dataset.delete;
  end;
end;

procedure TFormVariedades.FormShow(Sender: TObject);
begin
  opordenarnombreclick(sender);
  ttabla.open;
  ttipo.open;
  screen.cursor:=crdefault;
end;


procedure TFormVariedades.BPrevisualizarClick(Sender: TObject);
begin
  lempresa.caption :=  inttostr(vtidempresa) + ' - ' +
        vtnombreempresa + ' [' + datetostr (vtinicioempresa) +
        ' - ' + datetostr (vtfinempresa) + ']';
  limpresion.ReportTitle:='LISTADO DE VARIEDADES';
  limpresion.PreviewModal;
end;


procedure TFormVariedades.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  if (dbd.dataset.state=dsinsert) or (dbd.dataset.state=dsedit) then
    dbd.DataSet.post;
  ttipo.close;
  ttabla.close;
  screen.cursor:=crdefault;
  action:=caFree;
end;

procedure TFormVariedades.OpOrdenarNombreClick(Sender: TObject);
begin
  ttabla.indexfieldnames:='Nombre';
  lbuscar.caption:='Nombre a &buscar:';
end;

procedure TFormVariedades.RadioButton2Click(Sender: TObject);
begin
  ttabla.indexfieldnames:='ID';
  lbuscar.caption:='ID a &buscar:';
end;

procedure TFormVariedades.TablaKeyPress(Sender: TObject; var Key: Char);
begin
  if key='.' then
    if tabla.Columns[tabla.selectedindex].fieldname='Precio'then
      key:=',';
end;

procedure TFormVariedades.BPreciosClick(Sender: TObject);
var
  Filtro, campo, operador: string;
  Mantener: boolean;
  PesoNeto,Precio,Importe,importetotal : double;
begin
  if messagedlg('ATENCIN: se van a pasar todos los precios de las variedades a vales de fruta. Los vales de fruta sern recalculados con los nuevos precios.' +
      #13+#13+'   Pulse "Aceptar" para continuar con el proceso'+
      #13+'   Pulse "Cancelar" para anular el proceso.',
      mtwarning,[mbcancel,mbok],0)=mrok then
  begin
    datos.tvariedadesvales.filter:='';
    datos.TVariedadesVales.open;
    datos.tvariedadesvales.filtered:=false;
    datos.tvariedadesvales.Refresh;
    datos.TVariedades.open;
    datos.TVariedades.filter:='';
    datos.TVariedades.filtered:=false;
    datos.TVariedades.refresh;
    datos.dvariedades.dataset.first;
    if messagedlg('Desea mantener los precios ya introducidos en variedades de vales de fruta?'+
    #13+#13+'   Pulse "S" para mantener los precios ya introducidos.'+
      #13+'   Pulse "No" para reemplazar los precios por los nuevos.',
      mtconfirmation,[mbyes,mbno],0)=mryes then
      Mantener:=true
    else
      Mantener:=false;
    formi.l.Caption := 'Recalculando vales y actualizando precios, espere por favor...';
    formi.B.min := 0;
    formi.B.visible := true;
    formi.b.max:=datos.dvariedades.dataset.recordcount;
    formi.show;
    formi.refresh;
    while not datos.dvariedades.dataset.eof do
    begin
      formi.b.position:=datos.tvariedades.recno;
      if not varisnull (datos.dvariedades.dataset.fieldbyname('Precio').value) then
      begin
        //Filtrar variedades vales
        Filtro:=quotedstr(datos.dvariedades.dataset.fieldbyname('ID').value);
        campo:='IDVariedad';
        operador:='=';
        datos.tvariedadesvales.filter:=Format ('[%s] %s %s', [campo,operador,Filtro]);
        datos.tvariedadesvales.filtered:=true;
        datos.tvariedadesvales.Refresh;
        datos.dvariedadesvales.dataset.first;
        while not datos.dvariedadesvales.dataset.eof do
        begin
          if mantener then
          begin
            if varisnull(datos.dvariedadesvales.dataset.fieldbyname('PrecioConIVA').value) or (datos.dvariedadesvales.dataset.fieldbyname('PrecioConIVA').value=0) then
            begin
              datos.dvariedadesvales.dataset.edit;
              datos.dvariedadesvales.dataset.fieldbyname('PrecioConIVA').value:=datos.dvariedades.dataset.fieldbyname('Precio').value;
              datos.dvariedadesvales.dataset.post;
            end;
          end
          else
          begin
            datos.dvariedadesvales.dataset.edit;
            datos.dvariedadesvales.dataset.fieldbyname('PrecioConIVA').value:=datos.dvariedades.dataset.fieldbyname('Precio').value;
            datos.dvariedadesvales.dataset.post;
          end;
          datos.dvariedadesvales.dataset.Next;
        end;
      end;
      datos.dvariedades.dataset.next;
    end;

    //Recalcular vales
    Application.CreateForm(TModuloValesFruta, ModuloValesFruta);
    modulovalesfruta.tvales.open;
    modulovalesfruta.tvariedades.open;
    formi.b.max:=modulovalesfruta.dvales.dataset.recordcount;
    formi.b.min:=0;
    formi.l.caption:='Recalculando vales...';
    formi.l.refresh;
    formi.b.max:=modulovalesfruta.dvales.dataset.recordcount;
    formi.Refresh;
    while not modulovalesfruta.dvales.dataset.eof do
    begin
      formi.b.position:=modulovalesfruta.tvales.recno;
      modulovalesfruta.dvariedades.dataset.first;
      importetotal:=0;
      while not modulovalesfruta.dvariedades.dataset.eof do
      begin
        if (not varisnull(modulovalesfruta.dvariedades.dataset.fieldbyname('Pesoneto').value)) then
          pesoneto:=modulovalesfruta.dvariedades.dataset.fieldbyname('Pesoneto').value
        else
          pesoneto:=0;
        if not varisnull(modulovalesfruta.dvariedades.dataset.fieldbyname('PrecioConIVA').value) then
          precio:=modulovalesfruta.dvariedades.dataset.fieldbyname('PrecioConIVA').value
        else
          precio:=0;
        importe:=pesoneto*precio;
        importetotal:=importe+importetotal;
        modulovalesfruta.dvariedades.dataset.edit;
        modulovalesfruta.dvariedades.dataset.fieldbyname('ImporteTotal').value:=importe;
        modulovalesfruta.dvariedades.dataset.post;
        modulovalesfruta.dvariedades.dataset.next;
      end;
      modulovalesfruta.dvales.dataset.Edit;
      modulovalesfruta.dvales.DataSet.fieldbyname('ImporteTotal').value:=importetotal;
      modulovalesfruta.dvales.dataset.post;
      modulovalesfruta.dvales.dataset.next;
    end;
    modulovalesfruta.free;
    formi.close;
    messagedlg('El proceso ha finalizado correctamente.',mtinformation,[mbok],0);
  end;
end;

procedure TFormVariedades.RadioButton1Click(Sender: TObject);
begin
  ttabla.indexfieldnames:='IDTipo';
  lbuscar.caption:='ID Tipo a &buscar:';
end;

procedure TFormVariedades.BActualizarClick(Sender: TObject);
begin
  datos.ttiposvariedades.open;
  datos.tvariedades.open;
  datos.tvariedades.first;
  while not datos.dvariedades.dataset.eof do
  begin
    if not datos.ttiposvariedades.locate('Nombre',
          datos.dvariedades.dataset.fieldbyname('Tipo').value,[]) then
    begin
      datos.dtiposvariedades.dataset.insert;
      datos.dtiposvariedades.dataset.fieldbyname('Nombre').value:=
          datos.dvariedades.dataset.fieldbyname('Tipo').value;
      datos.dtiposvariedades.dataset.post;
    end;
    datos.dvariedades.dataset.next;
  end;


  datos.tvariedades.first;
  while not datos.dvariedades.dataset.eof do
  begin
    if datos.ttiposvariedades.locate('Nombre',
          datos.dvariedades.dataset.fieldbyname('Tipo').value,[]) then
    begin
      datos.dvariedades.dataset.edit;
      datos.dvariedades.dataset.fieldbyname('IDTipo').value:=
          datos.dtiposvariedades.dataset.fieldbyname('ID').value;
      datos.dvariedades.dataset.post;
    end;
    datos.dvariedades.dataset.next;
  end;
  showmessage('Fin');
end;


procedure TFormVariedades.Panel2DblClick(Sender: TObject);
begin
  if not bactualizar.visible then
    bactualizar.visible:=true
  else
    bactualizar.visible:=false;
end;

procedure TFormVariedades.DBDDataChange(Sender: TObject; Field: TField);
begin
  n.caption:=inttostr(dbd.dataset.recno) +
    '/' + inttostr(dbd.DataSet.recordcount);
end;

procedure TFormVariedades.TTablaAfterPost(DataSet: TDataSet);
begin
  ttabla.FlushBuffers;
end;

procedure TFormVariedades.ActActualizarPrecioVariedadExecute(
  Sender: TObject);
var
  filtro, campo, operador: string;
  importetotal, pesoneto, precio, importe: double;
begin
  if varisnull (dbd.dataset.fieldbyname('Nombre').value) or
      varisnull (dbd.dataset.fieldbyname('Precio').value) then
  begin
    messagedlg ('Primero debe introducir el nombre y el precio de la variedad seleccionada.',
        mtinformation, [mbok], 0);
    exit;
  end;
  if messagedlg ('ATENCIN: se va a actualizar el precio de la variedad:' +
      #13 + #13 + dbd.DataSet.fieldbyname('Nombre').value + ' ->  Nuevo precio: ' +
      floattostr(dbd.DataSet.fieldbyname('Precio').value) + #13 + #13 +
      ' Los vales de fruta que contengan esta variedad sern recalculados con el nuevo precio.' +
      #13 + #13 + '   Pulse "Aceptar" para continuar con el proceso.' +
      #13 + '   Pulse "Cancelar" para anular el proceso. ',
      mtwarning, [mbcancel, mbok], 0) = mrok then
  begin
    datos.tvariedadesvales.filter := '';
    datos.TVariedadesVales.open;
    datos.tvariedadesvales.filtered := false;
    datos.tvariedadesvales.Refresh;
    formi.l.Caption := 'Recalculando vales y actualizando precio, espere por favor...';
    formi.B.min := 0;
    formi.B.visible := true;
    formi.show;
    formi.refresh;
    //Filtrar variedad actual en vales
    Filtro := quotedstr(dbd.dataset.fieldbyname('ID').value);
    campo := 'IDVariedad';
    operador := '=';
    datos.tvariedadesvales.filter := Format ('[%s] %s %s', [campo, operador, Filtro]);
    datos.tvariedadesvales.filtered := true;
    datos.tvariedadesvales.Refresh;
    formi.b.max := datos.dvariedadesvales.dataset.recordcount;
    datos.dvariedadesvales.dataset.first;
    while not datos.dvariedadesvales.dataset.eof do
    begin
      formi.b.position := datos.tvariedadesvales.recno;
      datos.dvariedadesvales.dataset.edit;
      datos.dvariedadesvales.dataset.fieldbyname('PrecioConIVA').value :=
          dbd.dataset.fieldbyname('Precio').value;
      datos.dvariedadesvales.dataset.post;
      datos.dvariedadesvales.dataset.Next;
    end;
    //Recalcular vales
    Application.CreateForm(TModuloValesFruta, ModuloValesFruta);
    modulovalesfruta.tvales.open;
    modulovalesfruta.tvariedades.open;
    formi.b.max := modulovalesfruta.dvales.dataset.recordcount;
    formi.b.min := 0;
    formi.b.max := modulovalesfruta.dvales.dataset.recordcount;
    formi.Refresh;
    while not modulovalesfruta.dvales.dataset.eof do
    begin
      formi.b.position := modulovalesfruta.tvales.recno;
      modulovalesfruta.dvariedades.dataset.first;
      importetotal := 0;
      while not modulovalesfruta.dvariedades.dataset.eof do
      begin
        if (not varisnull(modulovalesfruta.dvariedades.dataset.fieldbyname('Pesoneto').value)) then
          pesoneto := modulovalesfruta.dvariedades.dataset.fieldbyname('Pesoneto').value
        else
          pesoneto := 0;
        if not varisnull(modulovalesfruta.dvariedades.dataset.fieldbyname('PrecioConIVA').value) then
          precio:=modulovalesfruta.dvariedades.dataset.fieldbyname('PrecioConIVA').value
        else
          precio := 0;
        importe := pesoneto * precio;
        importetotal := importe + importetotal;
        modulovalesfruta.dvariedades.dataset.edit;
        modulovalesfruta.dvariedades.dataset.fieldbyname('ImporteTotal').value := importe;
        modulovalesfruta.dvariedades.dataset.post;
        modulovalesfruta.dvariedades.dataset.next;
      end;
      modulovalesfruta.dvales.dataset.Edit;
      modulovalesfruta.dvales.DataSet.fieldbyname('ImporteTotal').value := importetotal;
      modulovalesfruta.dvales.dataset.post;
      modulovalesfruta.dvales.dataset.next;
    end;
    modulovalesfruta.free;
    formi.close;
    messagedlg('El proceso ha finalizado correctamente.', mtinformation, [mbok], 0);
  end;
end;

procedure TFormVariedades.TablaKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  // para no aadir al pulsar tecla abajo ni tab en ultima fila
  // y si se pulsa si aadir
  with (Sender as TDbGrid) do
  begin
    if key = 19 then  //si se pulsa Pausa validar
      if (datasource.dataset.state = dsinsert)
          or (datasource.dataset.state = dsedit) then
        datasource.dataset.post;
  end;
end;

procedure TFormVariedades.TTablaBeforePost(DataSet: TDataSet);
begin
  if (TTablaPrecio.Value = null) or (TTablaPrecio.Value = 0)then
    TTablaPrecio.Value := 0;
end;

end.
